<table class="statistics_table wp-list-table widefat" cellspacing="0" style="margin-bottom: 2em;">
    <thead>
        <tr>
            <th><?php _e( 'Monitor', 'advanced-uptime-monitor-extension' ); ?></th>
            <th><?php _e( 'Monitor URL', 'advanced-uptime-monitor-extension' ); ?></th>
            <th><?php _e( 'Monitor Type:', 'advanced-uptime-monitor-extension' ); ?></th>
            <th><?php _e( 'Monitor Status:', 'advanced-uptime-monitor-extension' ); ?></th>
        </tr>
    </thead>
    <tbody>
        <tr>
            <td><?php echo $url->url_friendly_name; ?></td>
            <td><a href="<?php echo $url->url_address; ?>" target="_blank"><?php echo $url->url_address; ?></a></td>
            <td><?php echo Advanced_Uptime_Monitor_Extension::get_install()->monitor_types[ $url->url_monitor_type ]; ?></td>
            <td>
                <?php
				$last_status = $stats[0];
				if ( $last_status->monitor_type == '-1' ) {
					$type = $last_status->type;
					echo ucfirst( $monitor_statuses[ $type ] );
				} else {
					$type = $last_status->monitor_type;
					switch ( $type ) {
						case '0':
							echo __( 'Paused', 'advanced-uptime-monitor-extension' );
							break;
						case '1':
							echo __( 'Started', 'advanced-uptime-monitor-extension' );
                            break;
					}
				}
				?>
            </td>
        </tr>       
    </tbody>
    </table>

    <?php    
    $option = get_option( 'advanced_uptime_monitor_extension' );
	$offset_time = 0;
    if ( isset( $option[ 'api_timezone' ] ) && is_array( $option[ 'api_timezone' ] ) ) {
        $offset_time = $option[ 'api_timezone' ][ 'offset_time' ];
		$offset_time = $offset_time * 60 * 60;
	}
			
	if ( count( $stats > 0 ) ) {
		?>  
 <table class="statistics_table wp-list-table widefat" cellspacing="0">
                <thead>
                    <tr>
                    <th><?php _e( 'Status', 'advanced-uptime-monitor-extension' ); ?></th>
                    <th><?php _e( 'Details', 'advanced-uptime-monitor-extension' ); ?></th>
                    <th><?php _e( 'Date / Time', 'advanced-uptime-monitor-extension' ); ?></th> 
                    <th><?php _e( 'Duration:', 'advanced-uptime-monitor-extension' ); ?></th>
                    </tr>
                </thead>
                <tbody>
                    <?php
					foreach ( $stats as $event ) {
                        $status = '';
						if ( $event->monitor_type == '-1' ) {
							$type = $event->type;
							$status = ucfirst( $monitor_statuses[ $type ] );
						} else {
							$type = $event->monitor_type;
							switch ( $type ) {
								case '0':
									$status = __( 'Paused', 'advanced-uptime-monitor-extension' );
									break;
								case '1':
									$status = __( 'Started', 'advanced-uptime-monitor-extension' );
                        break;
							}
						}
						?>
                        <tr>
                        <td class="<?php echo strtolower( $status ) ?>">
                                <?php 
                                switch ( $status ) {
                                    case 'Started':
                                        echo '<i class="fa fa-play"></i> ' . __( 'Started', 'advanced-uptime-monitor-extension' );
                                        break;
                                    case 'Up':
                                        echo '<i class="fa fa-check"></i> ' . __( 'Up', 'advanced-uptime-monitor-extension' );
                                        break;
                                    case 'Paused':
                                        echo '<i class="fa fa-pause"></i> ' . __( 'Paused', 'advanced-uptime-monitor-extension' );
                                        break;
                                    case 'Down':
                                            echo '<i class="fa fa-exclamation-circle"></i> ' . __( 'Down', 'advanced-uptime-monitor-extension' );
                                        break;
                                }
                                ?>
                            </td>
                            <td>
                                <?php
								switch ( $status ) {
									case 'Started':
										echo __( 'The monitor is started manually', 'advanced-uptime-monitor-extension' );
										break;
									case 'Up':
										echo __( 'Successful response received.', 'advanced-uptime-monitor-extension' );
										break;
									case 'Paused':
										echo __( 'The monitor is paused manually', 'advanced-uptime-monitor-extension' );
										break;
									case 'Down':
										if ( $url->url_monitor_type == '2' ) {
											echo __( 'The keyword exists.', 'advanced-uptime-monitor-extension' ); } 
                                        else {
											echo __( 'No Response From The Website.', 'advanced-uptime-monitor-extension' ); }
										break;
								}
								?>          
                            </td>
                            <td>
                                <?php
                                    $datetime = strtotime( $event->event_datetime_gmt ) + $offset_time;
                                    $datetime = Advanced_Uptime_Monitor_Extension::get_install()->format_timestamp($datetime);
                                    echo $datetime;                                    
                                ?>
                            </td>
                            <td>
                                <?php                                                          
                                   $duration = $event->duration;                                                                       
                                   $hrs = floor($duration / 3600);
                                   $mins =  floor(($duration - $hrs * 3600) / 60);                                
                                   echo $hrs . ' hrs, ' . $mins . ' mins' ; 
                                   ?>
                           </td>
                
                        </tr>
        <?php } ?>      
                </tbody>
        <?php if ( $stats_cnt > 10 ) { // 10 events per page?>
                <tfoot>
                    <tr>
                        <td>
                        <?php if ( $stats_page > 1 ) { ?>              
                                    <a href="#" onclick="urm_stats_monitor_button(<?php echo intval( $url->url_id ); ?>, '<?php echo wp_create_nonce( 'aum_nonce_statistics_table' ); ?>', <?php echo (int) ($stats_page - 1) ?> ); return false;" ><i class="fa fa-chevron-left"></i> <?php _e( 'Previous', 'advanced-uptime-monitor-extension' ); ?></a>
                        <?php } ?>                  
                        </td>
                        <td></td><td></td>
                        <td style="text-align: right;">
                            <?php if ( $stats_page < ceil( $stats_cnt / 10 ) ) { ?>              
                                    <a href="#" onclick="urm_stats_monitor_button(<?php echo intval( $url->url_id ); ?>, '<?php echo wp_create_nonce( 'aum_nonce_statistics_table' ); ?>', <?php echo (int) ($stats_page + 1) ?>); return false;"><?php _e( 'Next', 'advanced-uptime-monitor-extension' ); ?> <i class="fa fa-chevron-right"></i></a>             
                            <?php } ?>                  
                        </td>
                    </tr>
                </tfoot>
        <?php } ?> 
            </table>
        <?php
	}
