<?php

class MainWP_BackUp_WordPress_Plugin {

	private $option_handle = 'mainwp_backupwp_plugin_option';
	private $option = array();
	private static $order = '';
	private static $orderby = '';
	//Singleton
	private static $instance = null;

	static function get_instance() {
		if ( null == MainWP_BackUp_WordPress_Plugin::$instance ) {
			MainWP_BackUp_WordPress_Plugin::$instance = new MainWP_BackUp_WordPress_Plugin();
		}
		return MainWP_BackUp_WordPress_Plugin::$instance;
	}

	public function __construct() {
		$this->option = get_option( $this->option_handle );
	}

	public function admin_init() {
		add_action( 'wp_ajax_mainwp_backupwp_upgrade_noti_dismiss', array( $this, 'dismiss_notice' ) );
		add_action( 'wp_ajax_mainwp_backupwp_active_plugin', array( $this, 'active_plugin' ) );
		add_action( 'wp_ajax_mainwp_backupwp_upgrade_plugin', array( $this, 'upgrade_plugin' ) );
		add_action( 'wp_ajax_mainwp_backupwp_showhide_plugin', array( $this, 'showhide_plugin' ) );
	}

	public function get_option( $key = null, $default = '' ) {
		if ( isset( $this->option[ $key ] ) ) {
			return $this->option[ $key ]; }
		return $default;
	}

	public function set_option( $key, $value ) {
		$this->option[ $key ] = $value;
		return update_option( $this->option_handle, $this->option );
	}

	public static function gen_plugin_dashboard_tab( $websites ) {

		$orderby = 'name';
		$_order = 'desc';
		if ( isset( $_GET['backupwp_orderby'] ) && ! empty( $_GET['backupwp_orderby'] ) ) {
			$orderby = $_GET['backupwp_orderby'];
		}
		if ( isset( $_GET['backupwp_order'] ) && ! empty( $_GET['backupwp_order'] ) ) {
			$_order = $_GET['backupwp_order'];
		}

		$name_order = $version_order = $status_order = $last_scan_order = $time_order = $url_order = $hidden_order = '';

		if ( isset( $_GET['backupwp_orderby'] ) ) {
			if ( 'name' == $_GET['backupwp_orderby'] ) {
				$name_order = ('desc' == $_order) ? 'asc' : 'desc';
			} else if ( 'version' == $_GET['backupwp_orderby'] ) {
				$version_order = ('desc' == $_order) ? 'asc' : 'desc';
			} else if ( 'url' == $_GET['backupwp_orderby'] ) {
				$url_order = ('desc' == $_order) ? 'asc' : 'desc';
			} else if ( 'hidden' == $_GET['backupwp_orderby'] ) {
				$hidden_order = ('desc' == $_order) ? 'asc' : 'desc';
			}
		}

		self::$order = $_order;
		self::$orderby = $orderby;
		usort( $websites, array( 'MainWP_BackUp_WordPress_Plugin', 'backupwp_data_sort' ) );
		?>
        <table id="mainwp-table-plugins" class="wp-list-table widefat plugins" cellspacing="0">
            <thead>
                <tr>
                    <th class="check-column">
                        <input type="checkbox"  id="cb-select-all-1" >
                    </th>
					<th scope="col" class="manage-column sortable <?php echo $name_order; ?>">
						<a href="?page=Extensions-Mainwp-Backupwordpress-Extension&backupwp_orderby=name&backupwp_order=<?php echo (empty( $name_order ) ? 'asc' : $name_order); ?>"><span><?php _e( 'Site', 'mainwp-backupwordpress-extension' ); ?></span><span class="sorting-indicator"></span></a>
                    </th>
					<th scope="col" class="manage-column sortable <?php echo $url_order; ?>">
						<a href="?page=Extensions-Mainwp-Backupwordpress-Extension&backupwp_orderby=url&backupwp_order=<?php echo (empty( $url_order ) ? 'asc' : $url_order); ?>"><span><?php _e( 'URL', 'mainwp-backupwordpress-extension' ); ?></span><span class="sorting-indicator"></span></a>
                    </th>  
					<th scope="col" class="manage-column sortable <?php echo $version_order; ?>">
						<a href="?page=Extensions-Mainwp-Backupwordpress-Extension&backupwp_orderby=version&backupwp_order=<?php echo (empty( $version_order ) ? 'asc' : $version_order); ?>"><span><?php _e( 'Plugin Version', 'mainwp-backupwordpress-extension' ); ?></span><span class="sorting-indicator"></span></a>
                    </th>
					<th scope="col" class="manage-column <?php echo $hidden_order; ?>">
						<a href="?page=Extensions-Mainwp-Backupwordpress-Extension&backupwp_orderby=hidden&backupwp_order=<?php echo (empty( $hidden_order ) ? 'asc' : $hidden_order); ?>"><span><?php _e( 'Plugin Hidden', 'mainwp-backupwordpress-extension' ); ?></span><span class="sorting-indicator"></span></a>
                    </th>
                    <th scope="col" class="manage-column">
						<span><?php _e( 'Settings' ); ?></span>
                    </th>
                    <th scope="col" class="manage-column">
						<span><?php _e( 'Backup now', 'mainwp-backupwordpress-extension' ); ?></span>
                    </th>           
                </tr>
            </thead>
            <tfoot>
                <tr>
                    <th class="check-column">
                        <input type="checkbox"  id="cb-select-all-2" >
                    </th>
					<th scope="col" class="manage-column sortable <?php echo $name_order; ?>">
						<a href="?page=Extensions-Mainwp-Backupwordpress-Extension&backupwp_orderby=name&backupwp_order=<?php echo (empty( $name_order ) ? 'asc' : $name_order); ?>"><span><?php _e( 'Site' ); ?></span><span class="sorting-indicator"></span></a>
                    </th>
					<th scope="col" class="manage-column sortable <?php echo $url_order; ?>">
						<a href="?page=Extensions-Mainwp-Backupwordpress-Extension&backupwp_orderby=url&backupwp_order=<?php echo (empty( $url_order ) ? 'asc' : $url_order); ?>"><span><?php _e( 'URL', 'mainwp-backupwordpress-extension' ); ?></span><span class="sorting-indicator"></span></a>
                    </th>          
					<th scope="col" class="manage-column sortable <?php echo $version_order; ?>">
						<a href="?page=Extensions-Mainwp-Backupwordpress-Extension&backupwp_orderby=version&backupwp_order=<?php echo (empty( $version_order ) ? 'asc' : $version_order); ?>"><span><?php _e( 'Plugin Version', 'mainwp-backupwordpress-extension' ); ?></span><span class="sorting-indicator"></span></a>
                    </th>     
					<th scope="col" class="manage-column <?php echo $hidden_order; ?>">
						<a href="?page=Extensions-Mainwp-Backupwordpress-Extension&backupwp_orderby=hidden&backupwp_order=<?php echo (empty( $hidden_order ) ? 'asc' : $hidden_order); ?>"><span><?php _e( 'Plugin Hidden', 'mainwp-backupwordpress-extension' ); ?></span><span class="sorting-indicator"></span></a>
                    </th>
                    <th scope="col" class="manage-column">
						<span><?php _e( 'Settings' ); ?></span>
                    </th>
                    <th scope="col" class="manage-column">
						<span><?php _e( 'Backup now', 'mainwp-backupwordpress-extension' ); ?></span>
                    </th>          
                </tr>
            </tfoot>
            <tbody id="the-mwp-backupwp-list" class="list:sites">
				<?php
				if ( is_array( $websites ) && count( $websites ) > 0 ) {
					self::get_plugin_dashboard_table_row( $websites );
				} else {
					echo '<tr><td colspan="8">' . __( 'No websites were found with the BackUpWordPress plugin installed.', 'mainwp-backupwordpress-extension' ) . '</td></tr>';
				}
				?>
            </tbody>
        </table>
		<?php
	}

	public static function get_plugin_dashboard_table_row( $websites ) {
		$dismiss = array();
		if ( session_id() == '' ) {
			session_start(); }
		if ( isset( $_SESSION['mainwp_backupwp_dismiss_upgrade_plugin_notis'] ) ) {
			$dismiss = $_SESSION['mainwp_backupwp_dismiss_upgrade_plugin_notis'];
		}

		if ( ! is_array( $dismiss ) ) {
			$dismiss = array(); }

		$plugin_name = 'BackUpWordPress';

		$globalPremium = get_option( 'mainwp_backupwp_general_is_premium', 0 );

		foreach ( $websites as $website ) {
			$location = 'tools.php?page=backupwordpress';
			$website_id = $website['id'];
			$cls_active = (isset( $website['backupwp_active'] ) && ! empty( $website['backupwp_active'] )) ? 'active' : 'inactive';
			$cls_update = (isset( $website['backupwp_upgrade'] )) ? 'update' : '';
			$cls_update = ('inactive' == $cls_active) ? 'update' : $cls_update;
			$showhide_action = (1 == $website['hide_backupwp']) ? 'show' : 'hide';
			$showhide_link = '<a href="#" class="mwp_backupwp_showhide_plugin" showhide="' . $showhide_action . '"><i class="fa fa-eye-slash"></i> ' . ('show' === $showhide_action ? 'Show ' . $plugin_name . ' plugin' : 'Hide ' . $plugin_name . ' plugin') . '</a>';

			$td_status = '';
			?>
			<tr class="<?php echo $cls_active . ' ' . $cls_update; ?>" website-id="<?php echo $website_id; ?>" plugin-name="<?php echo $plugin_name; ?>">
                <th class="check-column">
                    <input type="checkbox"  name="checked[]">
                </th>
                <td>
					<a href="admin.php?page=managesites&dashboard=<?php echo $website_id; ?>"><?php echo $website['name']; ?></a><br/>
					<div class="row-actions"><span class="dashboard"><a href="admin.php?page=managesites&dashboard=<?php echo $website_id; ?>"><i class="fa fa-tachometer"></i> <?php _e( 'Dashboard', 'mainwp-backupwordpress-extension' ); ?></a></span> |  <span class="edit"><a href="admin.php?page=managesites&id=<?php echo $website_id; ?>"><i class="fa fa-pencil-square-o"></i> <?php _e( 'Edit' ); ?></a> | <?php echo $showhide_link; ?></span></div>                    
					<div class="its-action-working"><span class="status" style="display:none;"></span><span class="loading" style="display:none;"><i class="fa fa-spinner fa-pulse"></i> <?php _e( 'Please wait...' ); ?></span></div>
                </td>               
                <td>
					<a href="<?php echo $website['url']; ?>" target="_blank"><?php echo $website['url']; ?></a><br/>
					<div class="row-actions"><span class="edit"><a target="_blank" href="admin.php?page=SiteOpen&newWindow=yes&websiteid=<?php echo $website_id; ?>"><i class="fa fa-external-link"></i> <?php _e( 'Open WP-Admin', 'mainwp-backupwordpress-extension' ); ?></a></span> | <span class="edit"><a href="admin.php?page=SiteOpen&newWindow=yes&websiteid=<?php echo $website_id; ?>&location=<?php echo base64_encode( $location ); ?>" target="_blank"><i class="fa fa-cog"></i> <?php _e( 'Open BackUpWordPress', 'mainwp-backupwordpress-extension' ); ?></a></span></div>                    
                </td>
                <td>
					<?php
					if ( isset( $website['backupwp_plugin_version'] ) ) {
						echo $website['backupwp_plugin_version'];
						//                       if ($website['isOverride']) {
						//                            echo " " . ($website['isPremium'] ? "(Premium)" : "(Free)");
						//                       } else {
						//                            echo " " . ($globalPremium ? "(Premium)" : "(Free)");
						//                       }
					} else {
						echo '&nbsp;'; }
					?>
                </td>     
                <td>
					<span class="backupwp_hidden_title"><?php
						echo (1 == $website['hide_backupwp']) ? __( 'Yes' ) : __( 'No' );
						?>
                    </span>
                </td>
                <td>
					<span><?php echo ($website['isOverride'] ? __( 'Individual', 'mainwp-backupwordpress-extension' ) : __( 'General' )); ?></span>                                    
                </td>
                <td>
					<?php $bkn_url = 'admin.php?page=ManageSitesBackUpWordPress&id=' . $website_id; ?>
					<span><a href="<?php echo $bkn_url; ?>"><i class="fa fa-hdd-o"></i> <?php _e( 'Backup Now', 'mainwp-backupwordpress-extension' ); ?></a></span>                    
                </td>               
            </tr>        
			<?php
			$active_link = $update_link = '';
			$version = '';
			$plugin_slug = $website['plugin_slug'];
			if ( isset( $website['backupwp_active'] ) && empty( $website['backupwp_active'] ) ) {
				$active_link = '<a href="#" class="mwp_backupwp_active_plugin" >Activate ' . $plugin_name . ' plugin</a>'; }

			if ( isset( $website['backupwp_upgrade'] ) ) {
				if ( isset( $website['backupwp_upgrade']['new_version'] ) ) {
					$version = $website['backupwp_upgrade']['new_version']; }
				$update_link = '<a href="#" class="mwp_backupwp_upgrade_plugin" >Update ' . $plugin_name . ' plugin</a>';
				if ( isset( $website['backupwp_upgrade']['plugin'] ) ) {
					$plugin_slug = $website['backupwp_upgrade']['plugin']; }
			}

			$hide_update = false;
			if ( isset( $dismiss[ $website_id ] ) ) {
				$hide_update = true;
			}

			if ( ! empty( $active_link ) || ! empty( $update_link ) ) {
				$location = 'plugins.php';
				$link_row = $active_link . ' | ' . $update_link;
				$link_row = rtrim( $link_row, ' | ' );
				$link_row = ltrim( $link_row, ' | ' );
				?>
				<tr class="plugin-update-tr" <?php echo ($hide_update ? 'style="display: none"' : ''); ?>>
                    <td colspan="8" class="plugin-update">
						<div class="ext-upgrade-noti update-message" plugin-slug="<?php echo $plugin_slug; ?>" website-id="<?php echo $website_id; ?>" version="<?php echo $version; ?>"><p>
							<?php if ( ! $hide_update ) { ?>
								<span style="float:right"><a href="#" class="backupwp_plugin_upgrade_noti_dismiss"><?php _e( 'Dismiss' ); ?></a></span>                    
							<?php } ?>
							<?php echo $link_row; ?>
							<span class="mwp-backupwp-row-working"><i class="fa fa-spinner fa-pulse" style="display: none"></i>&nbsp;<span class="status"></span></span>
                        </p></div>
                    </td>
                </tr>
				<?php
			}
		}
	}

	public static function backupwp_data_sort( $a, $b ) {
		if ( 'version' == self::$orderby ) {
			$a = $a['backupwp_plugin_version'];
			$b = $b['backupwp_plugin_version'];
			$cmp = version_compare( $a, $b );
		} else if ( 'url' == self::$orderby ) {
			$a = $a['url'];
			$b = $b['url'];
			$cmp = strcmp( $a, $b );
		} else if ( 'hidden' == self::$orderby ) {
			$a = $a['hide_backupwp'];
			$b = $b['hide_backupwp'];
			$cmp = $a - $b;
		} else {
			$a = $a['name'];
			$b = $b['name'];
			$cmp = strcmp( $a, $b );
		}
		if ( 0 == $cmp ) {
			return 0; }

		if ( 'desc' == self::$order ) {
			return ($cmp > 0) ? -1 : 1; } else {
			return ($cmp > 0) ? 1 : -1; }
	}

	public function get_backupwp_websites() {
		global $mainWPBackUpWordPressExtensionActivator;
		$websites = apply_filters( 'mainwp-getsites', $mainWPBackUpWordPressExtensionActivator->get_child_file(), $mainWPBackUpWordPressExtensionActivator->get_child_key(), null );
		$sites_ids = array();
		if ( is_array( $websites ) ) {
			foreach ( $websites as $site ) {
				$sites_ids[] = $site['id'];
			}
			unset( $websites );
		}
		$option = array(
		'plugin_upgrades' => true,
			'plugins' => true,
		);
		$dbwebsites = apply_filters( 'mainwp-getdbsites', $mainWPBackUpWordPressExtensionActivator->get_child_file(), $mainWPBackUpWordPressExtensionActivator->get_child_key(), $sites_ids, array(), $option );
		$backupDataSites = array();
		if ( count( $sites_ids ) > 0 ) {
			$backupDataSites = MainWP_BackUp_WordPress_DB::get_instance()->get_backupwps_data( $sites_ids );
		}
		return MainWP_BackUp_WordPress_Plugin::get_instance()->get_websites_with_backupwp_data( $dbwebsites, $backupDataSites );
	}

	public function get_websites_with_backupwp_data( $websites, $plugin_data_sites = array() ) {
		$sites_updraft = array();
		if ( is_array( $websites ) ) {
			foreach ( $websites as $website ) {
				if ( $website && $website->plugins != '' ) {
					$plugins = json_decode( $website->plugins, 1 );
					if ( is_array( $plugins ) && count( $plugins ) != 0 ) {
						foreach ( $plugins as $plugin ) {
							if ( ('backupwordpress/backupwordpress.php' == $plugin['slug']) ) {
								$site = MainWP_BackUp_WordPress_Utility::map_site( $website, array( 'id' ) );
								if ( ! $plugin['active'] ) {
									continue; }

								$data = array( 'id' => $website->id );
								$plugintDS = isset( $plugin_data_sites[ $site['id'] ] ) ? $plugin_data_sites[ $site['id'] ] : array();
								if ( ! is_array( $plugintDS ) ) {
									$plugintDS = array(); }
								$data['lastbackup_gmttime'] = isset( $plugintDS['lastbackup_gmttime'] ) ? $plugintDS['lastbackup_gmttime'] : 0;
								$data['isOverride'] = isset( $plugintDS['override'] ) ? $plugintDS['override'] : 0;
								//$data['mwp_backupwp_is_premium'] = isset($plugintDS['mwp_backupwp_is_premium']) ? $plugintDS['mwp_backupwp_is_premium'] : "";
								$sites_updraft[ $website->id ] = $data;
								break;
							}
						}
					}
				}
			}
		}

		return $sites_updraft;
	}

	public function get_websites_with_the_plugin( $websites, $selected_group = 0, $plugin_data_sites = array() ) {
		$websites_backupwp = array();

		$pluginHide = $this->get_option( 'hide_the_plugin' );

		if ( ! is_array( $pluginHide ) ) {
			$pluginHide = array(); }
		$_text = __( 'Nothing currently scheduled', 'mainwp-backupwordpress-extension' );
		if ( is_array( $websites ) && count( $websites ) ) {
			if ( empty( $selected_group ) ) {
				foreach ( $websites as $website ) {
					if ( $website && $website->plugins != '' ) {
						$plugins = json_decode( $website->plugins, 1 );
						if ( is_array( $plugins ) && count( $plugins ) != 0 ) {
							foreach ( $plugins as $plugin ) {
								if ( ('backupwordpress/backupwordpress.php' == $plugin['slug']) ) {
									$site = MainWP_BackUp_WordPress_Utility::map_site( $website, array( 'id', 'name', 'url' ) );
									if ( $plugin['active'] ) {
										$site['backupwp_active'] = 1; } else {
										$site['backupwp_active'] = 0; }
										// get upgrade info
										$site['backupwp_plugin_version'] = $plugin['version'];
										$site['plugin_slug'] = $plugin['slug'];
										$plugin_upgrades = json_decode( $website->plugin_upgrades, 1 );
										if ( is_array( $plugin_upgrades ) && count( $plugin_upgrades ) > 0 ) {
											if ( isset( $plugin_upgrades['backupwordpress/backupwordpress.php'] ) ) {
												$upgrade = $plugin_upgrades['backupwordpress/backupwordpress.php'];
												if ( isset( $upgrade['update'] ) ) {
													$site['backupwp_upgrade'] = $upgrade['update'];
												}
											}
										}

										$site['hide_backupwp'] = 0;
										if ( isset( $pluginHide[ $website->id ] ) && $pluginHide[ $website->id ] ) {
											$site['hide_backupwp'] = 1;
										}

										$plugintDS = isset( $plugin_data_sites[ $site['id'] ] ) ? $plugin_data_sites[ $site['id'] ] : array();
										if ( ! is_array( $plugintDS ) ) {
											$plugintDS = array(); }

										//$site['isPremium'] = isset($plugintDS['is_premium']) ? $plugintDS['is_premium'] : 0;
										$site['isOverride'] = isset( $plugintDS['override'] ) ? $plugintDS['override'] : 0;
										$websites_backupwp[] = $site;
										break;
								}
							}
						}
					}
				}
			} else {
				global $mainWPBackUpWordPressExtensionActivator;

				$group_websites = apply_filters( 'mainwp-getdbsites', $mainWPBackUpWordPressExtensionActivator->get_child_file(), $mainWPBackUpWordPressExtensionActivator->get_child_key(), array(), array( $selected_group ) );
				$sites = array();
				foreach ( $group_websites as $site ) {
					$sites[] = $site->id;
				}
				foreach ( $websites as $website ) {
					if ( $website && $website->plugins != '' && in_array( $website->id, $sites ) ) {
						$plugins = json_decode( $website->plugins, 1 );
						if ( is_array( $plugins ) && count( $plugins ) != 0 ) {
							foreach ( $plugins as $plugin ) {
								if ( ('backupwordpress/backupwordpress.php' == $plugin['slug']) ) {
									$site = MainWP_BackUp_WordPress_Utility::map_site( $website, array( 'id', 'name', 'url' ) );
									if ( $plugin['active'] ) {
										$site['backupwp_active'] = 1; } else {
										$site['backupwp_active'] = 0; }
										$site['backupwp_plugin_version'] = $plugin['version'];
										// get upgrade info
										$plugin_upgrades = json_decode( $website->plugin_upgrades, 1 );
										if ( is_array( $plugin_upgrades ) && count( $plugin_upgrades ) > 0 ) {
											if ( isset( $plugin_upgrades['backupwordpress/backupwordpress.php'] ) ) {
												$upgrade = $plugin_upgrades['backupwordpress/backupwordpress.php'];
												if ( isset( $upgrade['update'] ) ) {
													$site['backupwp_upgrade'] = $upgrade['update'];
												}
											}
										}
										$site['hide_backupwp'] = 0;
										if ( isset( $pluginHide[ $website->id ] ) && $pluginHide[ $website->id ] ) {
											$site['hide_backupwp'] = 1;
										}

										$plugintDS = isset( $plugin_data_sites[ $site['id'] ] ) ? $plugin_data_sites[ $site['id'] ] : array();
										if ( ! is_array( $plugintDS ) ) {
											$plugintDS = array(); }

										//$site['isPremium'] = $plugintDS['is_premium'];
										$site['isOverride'] = $plugintDS['override'];
										$websites_backupwp[] = $site;
										break;
								}
							}
						}
					}
				}
			}
		}

		// if search action
		$search_sites = array();
		if ( isset( $_GET['s'] ) && ! empty( $_GET['s'] ) ) {
			$find = trim( $_GET['s'] );
			foreach ( $websites_backupwp as $website ) {
				if ( stripos( $website['name'], $find ) !== false || stripos( $website['url'], $find ) !== false ) {
					$search_sites[] = $website;
				}
			}
			$websites_backupwp = $search_sites;
		}
		unset( $search_sites );

		return $websites_backupwp;
	}

	public static function gen_select_sites( $websites, $selected_group ) {
		global $mainWPBackUpWordPressExtensionActivator;
		//$websites = apply_filters('mainwp-getsites', $mainWPBackUpWordPressExtensionActivator->get_child_file(), $mainWPBackUpWordPressExtensionActivator->get_child_key(), null);
		$groups = apply_filters( 'mainwp-getgroups', $mainWPBackUpWordPressExtensionActivator->get_child_file(), $mainWPBackUpWordPressExtensionActivator->get_child_key(), null );
		$search = (isset( $_GET['s'] ) && ! empty( $_GET['s'] )) ? trim( $_GET['s'] ) : '';
		?> 

        <div class="alignleft actions bulkactions">
            <select id="mwp_backupwp_plugin_action">
				<option selected="selected" value="-1"><?php _e( 'Bulk Actions' ); ?></option>
				<option value="activate-selected"><?php _e( 'Active' ); ?></option>
				<option value="update-selected"><?php _e( 'Update' ); ?></option>
				<option value="hide-selected"><?php _e( 'Hide' ); ?></option>
				<option value="show-selected"><?php _e( 'Show' ); ?></option>
            </select>
			<input type="button" value="<?php _e( 'Apply' ); ?>" class="button action" id="backupwp_plugin_doaction_btn" name="">
        </div>

        <div class="alignleft actions">
            <form action="" method="GET">
                <input type="hidden" name="page" value="Extensions-Mainwp-Backupwordpress-Extension">
				<span role="status" aria-live="polite" class="ui-helper-hidden-accessible"><?php _e( 'No search results.', 'mainwp-backupwordpress-extension' ); ?></span>
				<input type="text" class="mainwp_autocomplete ui-autocomplete-input" name="s" autocompletelist="sites" value="<?php echo stripslashes( $search ); ?>" autocomplete="off">
                <datalist id="sites">
					<?php
					if ( is_array( $websites ) && count( $websites ) > 0 ) {
						foreach ( $websites as $website ) {
							echo '<option>' . $website['name'] . '</option>';
						}
					}
					?>                
                </datalist>
                <input type="submit" name="" class="button" value="Search Sites">
            </form>
        </div>    
        <div class="alignleft actions">
            <form method="post" action="admin.php?page=Extensions-Mainwp-Backupwordpress-Extension">
                <select name="mainwp_backupwp_plugin_groups_select">
					<option value="0"><?php _e( 'Select a group' ); ?></option>
					<?php
					if ( is_array( $groups ) && count( $groups ) > 0 ) {
						foreach ( $groups as $group ) {
							$_select = '';
							if ( $selected_group == $group['id'] ) {
								$_select = 'selected '; }
							echo '<option value="' . $group['id'] . '" ' . $_select . '>' . $group['name'] . '</option>';
						}
					}
					?>
                </select>&nbsp;&nbsp;                     
				<input class="button" type="submit" name="mwp_backupwp_plugin_btn_display" value="<?php _e( 'Display', 'mainwp-backupwordpress-extension' ); ?>">
            </form>  
        </div>    
		<?php
		return;
	}

	public function dismiss_notice() {
		$website_id = $_POST['backupwpRequestSiteID'];
		$version = $_POST['new_version'];
		if ( $website_id ) {
			session_start();
			$dismiss = $_SESSION['mainwp_backupwp_dismiss_upgrade_plugin_notis'];
			if ( is_array( $dismiss ) && count( $dismiss ) > 0 ) {
				$dismiss[ $website_id ] = 1;
			} else {
				$dismiss = array();
				$dismiss[ $website_id ] = 1;
			}
			$_SESSION['mainwp_backupwp_dismiss_upgrade_plugin_notis'] = $dismiss;
			die( 'updated' );
		}
		die( 'nochange' );
	}

	public function active_plugin() {
		$_POST['websiteId'] = $_POST['backupwpRequestSiteID'];
		do_action( 'mainwp_activePlugin' );
		die();
	}

	public function upgrade_plugin() {
		$_POST['websiteId'] = $_POST['backupwpRequestSiteID'];
		do_action( 'mainwp_upgradePluginTheme' );
		die();
	}

	public function showhide_plugin() {
		$siteid = isset( $_POST['backupwpRequestSiteID'] ) ? $_POST['backupwpRequestSiteID'] : null;
		$showhide = isset( $_POST['showhide'] ) ? $_POST['showhide'] : null;
		if ( null !== $siteid && null !== $showhide ) {
			global $mainWPBackUpWordPressExtensionActivator;
			$post_data = array(
			'mwp_action' => 'set_showhide',
				'showhide' => $showhide,
			);
			$information = apply_filters( 'mainwp_fetchurlauthed', $mainWPBackUpWordPressExtensionActivator->get_child_file(), $mainWPBackUpWordPressExtensionActivator->get_child_key(), $siteid, 'backup_wp', $post_data );

			if ( is_array( $information ) && isset( $information['result'] ) && 'SUCCESS' === $information['result'] ) {
				$hide_backupwp = $this->get_option( 'hide_the_plugin' );
				if ( ! is_array( $hide_backupwp ) ) {
					$hide_backupwp = array(); }
				$hide_backupwp[ $siteid ] = ('hide' === $showhide) ? 1 : 0;
				$this->set_option( 'hide_the_plugin', $hide_backupwp );
			}
			die( json_encode( $information ) );
		}
		die();
	}
}
