<?php

class MainWP_BackupBuddy {

	public static $instance = null;
	public static $manager_site_id = null;

	public static function get_instance() {
		if ( null == self::$instance ) {
			self::$instance = new self(); }
		return self::$instance;
	}

	public function init() {

	}

	public function admin_init() {
		add_action( 'wp_ajax_mainwp_backupbuddy_site_override_settings', array( $this, 'ajax_override_settings' ) );
		add_action( 'wp_ajax_mainwp_backupbuddy_save_settings', array( $this, 'ajax_save_settings' ) );
		add_action( 'wp_ajax_mainwp_backupbuddy_reload_notifications', array( $this, 'ajax_reload_notifications' ) );
		add_action( 'wp_ajax_mainwp_backupbuddy_reload_backups_list', array( $this, 'ajax_reload_backups_list' ) );
        add_action( 'wp_ajax_mainwp_backupbuddy_reload_remote_dest', array( $this, 'ajax_reload_remote_dest' ) );
        add_action( 'wp_ajax_mainwp_backupbuddy_reload_schedules_list', array( $this, 'ajax_reload_schedules_list' ) );
        add_action( 'wp_ajax_mainwp_backupbuddy_reload_products_license', array( $this, 'ajax_reload_products_license' ) );
		add_action( 'wp_ajax_mainwp_backupbuddy_load_sites', array( $this, 'ajax_load_sites' ) );
		add_action( 'wp_ajax_mainwp_backupbuddy_perform_scheduled_backup', array( $this, 'ajax_process_scheduled_backup' ) );
		add_action( 'wp_ajax_mainwp_backupbuddy_run_scheduled_backup', array( $this, 'ajax_run_scheduled_backup' ) );
		add_action( 'wp_ajax_mainwp_backupbuddy_perform_profile_action', array( $this, 'ajax_perform_profile_action' ) );
		add_action( 'wp_ajax_mainwp_backupbuddy_perform_action', array( $this, 'ajax_perform_action' ) );
		add_action( 'mainwp_delete_site', array( &$this, 'delete_site_data' ), 10, 1 );
	}

	public function delete_site_data( $website ) {
		if ( $website ) {
			MainWP_BackupBuddy_DB::get_instance()->delete_backupbuddy( 'site_id', $website->id );
		}
	}

	public static function render() {
		$website = null;
		if ( isset( $_GET['id'] ) && ! empty( $_GET['id'] ) ) {
			global $mainWP_BackupBuddy_Extension_Activator;
			$option = array(
			'plugin_upgrades' => true,
				'plugins' => true,
			);
			$dbwebsites = apply_filters( 'mainwp-getdbsites', $mainWP_BackupBuddy_Extension_Activator->get_child_file(), $mainWP_BackupBuddy_Extension_Activator->get_child_key(), array( $_GET['id'] ), array(), $option );

			if ( is_array( $dbwebsites ) && ! empty( $dbwebsites ) ) {
				$website = current( $dbwebsites );
			}
		}

		if ( self::is_manage_site() ) {
			$error = '';
			if ( empty( $website ) || empty( $website->id ) ) {
				$error = __( 'Error: Site not found.', 'it-l10n-mainwp-backupbuddy' );
			} else {
				$activated = false;
				if ( $website && $website->plugins != '' ) {
					$plugins = json_decode( $website->plugins, 1 );
					if ( is_array( $plugins ) && count( $plugins ) > 0 ) {
						foreach ( $plugins as $plugin ) {
							if ( ('backupbuddy/backupbuddy.php' == strtolower($plugin['slug'])) ) {
								if ( $plugin['active'] ) {
									$activated = true; }
								break;
							}
						}
					}
				}
				if ( ! $activated ) {
					$error = __( 'BackupBuddy plugin is not installed or activated on the site.', 'it-l10n-mainwp-backupbuddy' );
				}
			}

			if ( ! empty( $error ) ) {
				do_action( 'mainwp-pageheader-sites', 'Buddy' );
				echo '<div class="ui red message">' . $error . '</div>';
				do_action( 'mainwp-pagefooter-sites', 'Buddy' );
				return;
			}
		}

		self::render_tabs();
	}

	public static function render_tabs() {

		$bp_subpages = array(
			'dashboard' => __( 'BackupBuddy Dashboard', 'it-l10n-mainwp-backupbuddy' ),
			'backup' => __( 'Backup', 'it-l10n-mainwp-backupbuddy' ),
			'live' => __( 'Stash Live', 'it-l10n-mainwp-backupbuddy' ),
			'migrate_restore' => __( 'Restore / Migrate', 'it-l10n-mainwp-backupbuddy' ),
			'destinations' => __( 'Remote Destinations', 'it-l10n-mainwp-backupbuddy' ),
			//'server_tools' => __( 'Server Tools', 'it-l10n-mainwp-backupbuddy' ),
			'malware_scan' => __( 'Malware Scan', 'it-l10n-mainwp-backupbuddy' ),
			'scheduling' => __( 'Schedules', 'it-l10n-mainwp-backupbuddy' ),
			'settings' => __( 'Settings', 'it-l10n-mainwp-backupbuddy' ),
		);

		$is_manager_site = self::is_manage_site();

		if ( $is_manager_site ) {
			do_action( 'mainwp-pageheader-sites', 'Buddy' );
		}

		?>
		<div class="ui labeled icon inverted menu mainwp-sub-submenu" id="mainwp-buddy-menu">
			<?php
		if ($is_manager_site) {
			unset($bp_subpages['dashboard']);

			foreach($bp_subpages as $slug => $title) {
				echo '<a class="item" href="admin.php?page=ManageSitesBuddy&subpage=' . $slug . '&id=' . self::get_manager_site_id(). '">' . $title . '</a>';
			}

			$sub_page = isset($_GET['subpage']) ? $_GET['subpage'] : 'dashboard';
			if (!isset($bp_subpages[$sub_page])) {
				$sub_page = 'backup';
			}

		} else {
			unset($bp_subpages['live']);
			//unset($bp_subpages['server_tools']);
      unset($bp_subpages['migrate_restore']);
      unset($bp_subpages['malware_scan']);
			foreach($bp_subpages as $slug => $title) {
				echo '<a class="item" href="admin.php?page=Extensions-Mainwp-Buddy-Extension&subpage=' . $slug . '">' . $title . '</a>';
			}

			$sub_page = isset($_GET['subpage']) ? $_GET['subpage'] : 'dashboard';
			if (!isset($bp_subpages[$sub_page])) {
				$sub_page = 'dashboard';
			}
		}

		?>
	</div>

		<div id="mwp_backupbuddy_message_zone" class="ui green message" style="display: none"></div>
		<div id="mwp_backupbuddy_error_zone" class="ui red message" style="display: none"></div>
		<?php

		pb_mainwp_backupbuddy::load_controller('pages/' . $sub_page);

		if ($is_manager_site) {
			do_action( 'mainwp-pagefooter-sites', 'Buddy' );
		}

	}

	public static function site_settings_box($site_id) {
		if (empty($site_id))
			return;
		$override = 0;
		$site_backupbuddy = MainWP_BackupBuddy_DB::get_instance()->get_backupbuddy_by( 'site_id', $site_id, 'override' );
		if ( $site_backupbuddy ) {
			$override = $site_backupbuddy->override;
		}

		?>
    <div class="mainwp-select-sites" id="backupbuddy_site_settings">
			<h3 class="ui header"><?php _e( 'Buddy Site Settings', 'it-l10n-mainwp-backupbuddy' ); ?></h3>
      <input type="hidden" name="mainwp_backupbuddy_settings_site_id" value="<?php echo $site_id; ?>">
      <input type="hidden" name="mainwp_backupbuddy_override_settings_value" id="mainwp_backupbuddy_override_settings_value" value="<?php echo intval($override); ?>">
			<div class="ui grid field">
				<label class="six wide column middle aligned">Override general settings</label>
      		<div class="ten wide column ui toggle checkbox">
						<input type="checkbox" id="mainwp_backupbuddy_override_general_settings" name="mainwp_backupbuddy_override_general_settings"  <?php echo (0 == $override ? '' : 'checked="checked"'); ?> value="1"/>
				</div>
			</div>
			<i style="display: none;" class="notched circle loading icon"></i>
			<span id="mwp_backupbuddy_perform_individual_status" class="hidden"></span>
    </div>
		<?php
	}


	public static function is_manage_site( $tabs = array() ) {
		if ( isset( $_POST['isIndividual'] ) && ! empty( $_POST['isIndividual'] ) && isset( $_POST['backupbuddyRequestSiteID'] ) && ! empty( $_POST['backupbuddyRequestSiteID'] ) ) {
			return true;
		} else if ( isset( $_GET['page'] ) && ('ManageSitesBuddy' == $_GET['page']) ) {
			return true;
		} else if ( isset( $_REQUEST['buddy_manage_site_id'] ) ) {
			return true;
		}
		return false;
	}

	public static function get_manager_site_id() {
		if (self::$manager_site_id !== null)
			return self::$manager_site_id;

		$site_id = 0;
		if ( self::is_manage_site() ) {
			// ajax
			if ( isset( $_POST['isIndividual'] ) && ! empty( $_POST['isIndividual'] ) && isset( $_POST['backupbuddyRequestSiteID'] ) && ! empty( $_REQUEST['backupbuddyRequestSiteID'] ) ) {
				$site_id = $_POST['backupbuddyRequestSiteID'];
			} else if ( isset( $_REQUEST['buddy_manage_site_id'] ) ) {
				$site_id = $_REQUEST['buddy_manage_site_id'];
			} else if (isset($_GET['page']) && 'ManageSitesBuddy' == $_GET['page'] ) {
				$site_id = isset($_GET['id']) ? $_GET['id'] : 0;
			}
		}
		return $site_id;
	}

	public static function ajax_load_sites() {
                $ajax_call = true;
                if ( pb_mainwp_backupbuddy::_GET( 'run' ) != '' && isset( $_GET['_wpnonce'] ) ) {
                    if ( wp_verify_nonce( $_GET['_wpnonce'], '_widget_nonce' ) ) {
                        $what = 'run_schedule';
                        $ajax_call = false;
                    } else {
                        die(-1);
                    }
                } else {
                    self::verify_nonce(false);
                }

                if (!isset($what) || null === $what)
                    $what = $_POST['what'];

                if ('run_schedule' == $what) {

                    if (isset($_POST['schedule_id']))
                        $_sch_id = $_POST['schedule_id'];
                    else if (isset($_GET['run'])) {
                        $_sch_id = $_GET['run'];
                    }

                    $general_settings =  pb_mainwp_backupbuddy::load_general_option();
                    if (isset($general_settings['schedules'][$_sch_id])) {
                        $_schedule = $general_settings['schedules'][$_sch_id];
                        $sites_ids = isset($_schedule['sites']) ? explode(";", $_schedule['sites']) : array();
                        $groups_ids = isset($_schedule['groups']) ? explode(";", $_schedule['groups']) : array();
                    } else {
                        echo '<div class="mainwp_info-box-yellow">' . __( 'Schedule not found.', 'it-l10n-mainwp-backupbuddy' ) . '</div>';
                        if ($ajax_call)
                            die();
                        else
                            return;
                    }
                } else {
                    $sites_ids = isset($_POST['sites']) && is_array($_POST['sites']) ? $_POST['sites'] : array();
                    $groups_ids = isset($_POST['groups']) && is_array($_POST['groups']) ? $_POST['groups'] : array();
                }

		global $mainWP_BackupBuddy_Extension_Activator;
               $_old_site_ids = array();

                if (empty($sites_ids) && empty($groups_ids)) {
                    $websites = apply_filters( 'mainwp-getsites', $mainWP_BackupBuddy_Extension_Activator->get_child_file(), $mainWP_BackupBuddy_Extension_Activator->get_child_key(), null );
                    $sites_ids = array();
                    $groups_ids = array();
                    if ( is_array( $websites ) ) {
                            foreach ( $websites as $website ) {
                                    $sites_ids[] = $website['id'];
                            }
                            unset( $websites );
                    }
                }

                $option = array(
                        'plugin_upgrades' => true,
                        'plugins' => true,
                );
                $dbwebsites = apply_filters( 'mainwp-getdbsites', $mainWP_BackupBuddy_Extension_Activator->get_child_file(), $mainWP_BackupBuddy_Extension_Activator->get_child_key(), $sites_ids, $groups_ids, $option );
                $dbwebsites_backupbuddy = MainWP_BackupBuddy_Plugin::get_instance()->get_websites_with_the_plugin( $dbwebsites );
                unset( $dbwebsites );

                if ('save_scheduled_backup' == $what) {
                    $_old_sitesgroups = get_option('mainwp_backbuddy_perform_schedule_old_sitesgroups', array());
                    delete_option('mainwp_backbuddy_perform_schedule_old_sitesgroups');

                    $_old_sites = $_old_groups = '';
                    if (is_array($_old_sitesgroups)) {
                        $_old_sites = isset($_old_sitesgroups['sites']) ? $_old_sitesgroups['sites'] : '';
                        $_old_groups = isset($_old_sitesgroups['groups']) ? $_old_sitesgroups['groups'] : '';
                    }

                    $_old_sites = array_filter(explode(";", $_old_sites));
                    $_old_groups = array_filter(explode(";", $_old_groups));

                    $_old_dbwebsites = apply_filters( 'mainwp-getdbsites', $mainWP_BackupBuddy_Extension_Activator->get_child_file(), $mainWP_BackupBuddy_Extension_Activator->get_child_key(), $_old_sites, $_old_groups, $option );
                    $_old_dbwebsites_backupbuddy = MainWP_BackupBuddy_Plugin::get_instance()->get_websites_with_the_plugin( $_old_dbwebsites );


                    foreach($_old_dbwebsites_backupbuddy as $website) {
                        if ( ! isset( $website['backupbuddy_active'] ) || empty( $website['backupbuddy_active'] ) ) {
                                continue;
                        }
                        $_old_site_ids[$website['id']] = $website['name'];
                    }
                    unset( $_old_dbwebsites );
                }

		$title = '';
		if ( 'general_settings' == $what ) {
			$title = __( 'Saving General Settings to child sites...', 'it-l10n-mainwp-backupbuddy' );
		} else if ( 'advanced_settings' == $what ) {
			$title = __( 'Saving Advanced Settings to child sites...', 'it-l10n-mainwp-backupbuddy' );
		} else if ('reset_defaults' == $what) {
			$title = __( 'Reset Settings on child sites to default...', 'it-l10n-mainwp-backupbuddy' );
		} else if ('save_scheduled_backup' == $what) {
			$title = __( 'Saving Scheduled backup(s) on child sites...', 'it-l10n-mainwp-backupbuddy' );
		} else if ('delete_scheduled_backup' == $what) {
			$title = __( 'Deleting scheduled backup(s) on child sites...', 'it-l10n-mainwp-backupbuddy' );
		} else if ('save_profile' == $what) {
			$title = __( 'Saving Profile to child sites...', 'it-l10n-mainwp-backupbuddy' );
		} else if ('delete_profile' == $what) {
			$title = __( 'Deleting Profile on child sites...', 'it-l10n-mainwp-backupbuddy' );
		} else if ( 'run_schedule' == $what) {
			$title = __( 'Run Scheduled Backup on child sites...', 'it-l10n-mainwp-backupbuddy' );
		} else if ( 'create_backup' == $what) {
			$title = __( 'Creating backup on child sites...', 'it-l10n-mainwp-backupbuddy' );
		} else if ( 'remote_save' == $what) {
			$title = __( 'Saving Remote Destination on child sites...', 'it-l10n-mainwp-backupbuddy' );
		} else if ( 'remote_delete' == $what) {
			$title = __( 'Deleting Remote Destination on child sites...', 'it-l10n-mainwp-backupbuddy' );
		} else if ( 'settings_other' == $what) {
                        $otherAction = $_POST['other_action'];
                        switch ($otherAction) {
                            case 'cleanup_now':
                                $title = 'Cleanup OLD temporary data & perform housekeeping on the child site';
                                break;
                            case 'delete_tempfiles_now':
                                $title = 'Deleting ALL data files (including resetting Stash Live catalog) on the child site';
                                break;
                            case 'reset_disalerts':
                                $title = 'Resetting Dismissed Alerts on the child site';
                                break;
                            case 'cancel_running_backups':
                                $title = 'Forcing Cancel of all Backups & Transfers on the child site';
                                break;
                            case 'reset_log':
                                $title = 'Clearing Log on the child site';
                                break;
                        }
		} else if ('activate_package' == $what) {
                    $title = __( 'Activating packages on child sites...', 'it-l10n-mainwp-backupbuddy' );
                } else if ('save_license_settings' == $what) {
                    $title = __( 'Saving License settings on child sites...', 'it-l10n-mainwp-backupbuddy' );
                }
                $have_active = false;
                ob_start();
                ?>
                <div class="poststuff">
                    <div class="ui segment">
                        <h3 class="mainwp_box_title"><?php echo !empty( $title ) ? $title : '&nbsp;'; ?></h3>
                        <div class="ui relaxed divided list">
                                <?php
                                if ( is_array( $dbwebsites_backupbuddy ) && count( $dbwebsites_backupbuddy ) > 0 ) {
                                        $new_sites_ids = array();
                                        foreach ( $dbwebsites_backupbuddy as $website ) {
                                                $new_sites_ids[] = $website['id'];
                                                if ( ! isset( $website['backupbuddy_active'] ) || empty( $website['backupbuddy_active'] ) ) {
                                                        continue;
                                                }
                                                $have_active = true;
                                                echo '<div class="item"><strong>' . $website['name'] . '</strong>: ';
                                                echo '<span class="siteItemProcess" action="" site-id="' . $website['id'] . '" status="queue"><span class="status">Queue ...</span> <i style="display: none;" class="fa fa-spinner fa-pulse"></i></span>';
                                                echo '</div>';
                                        }
                                        foreach ($_old_site_ids as $_id => $_name) {
                                            if (!in_array($_id, $new_sites_ids)) {
                                                echo '<div class="item"><strong>' . $_name . '</strong>: ';
                                                echo '<span class="siteItemProcess" action="delete" site-id="' . $_id . '" status="queue"><span class="status">Queue ...</span> <i style="display: none;" class="fa fa-spinner fa-pulse"></i></span>';
                                                echo '</div>';
                                            }
                                        }
                                }

                                ?>
                        </div>
                    </div>
                </div>
                <?php

//                print_r($_old_site_ids);
//                print_r($new_sites_ids);

                $html = ob_get_clean();
                if ( ! $have_active ) {
                    $html = '<div class="mainwp_info-box-yellow">' . __( 'No websites were found with the BackupBuddy plugin installed.', 'it-l10n-mainwp-backupbuddy' ) . '</div>';
                    if ('create_backup' == $what) {
                        $html .= '<a href="admin.php?page=Extensions-Mainwp-Buddy-Extension&subpage=backup" class="button-primary">Return to Backup</a>';
                    } else if ('run_schedule' == $what) {
                        $html .= '<a href="admin.php?page=Extensions-Mainwp-Buddy-Extension&subpage=scheduling" class="button-primary">Return to Schedules</a>';
                    }

                }
                echo $html;

                if ($ajax_call)
                    die();
	}

	public static function verify_nonce($verify_site_id = true) {
		if ( ! isset( $_REQUEST['_backupbuddyNonce'] ) || ! wp_verify_nonce( $_REQUEST['_backupbuddyNonce'], '_wpnonce' ) ) {
			die( json_encode( array( 'error' => 'Security Error.' ) ) ); }

		if ($verify_site_id) {
			if ( empty( $_POST['backupbuddyRequestSiteID'] ) ) {
				die( json_encode( array( 'error' => 'Empty site id.' ) ) ); }
		}
	}

	public static function ajax_check_individual_action( $pSiteId, $isIndividual = null , $return = false ) {
                $error = '';
                if (empty($pSiteId)) {
                    $error = __('Invalid request', 'it-l10n-mainwp-backupbuddy');
                } else {
                    $site_backupbuddy = MainWP_BackupBuddy_DB::get_instance()->get_backupbuddy_by( 'site_id', $pSiteId, 'override' );

                    if ($isIndividual !== null) {
                        $individual = $isIndividual;
                    } else {
                        $individual = isset( $_POST['isIndividual'] ) && ! empty( $_POST['isIndividual'] ) ? true : false;
                    }

                    if ( $individual ) {
                            if ( $site_backupbuddy && ! $site_backupbuddy->override ) {
                                    $error = __('Action could not be performed: Override General Settings needs to be set to Yes.', 'it-l10n-mainwp-backupbuddy' );
                            }
                    } else {
                            if ( $site_backupbuddy && $site_backupbuddy->override ) {
                                    $error = __( 'Action could not be performed - Individual site settings are enabled.', 'it-l10n-mainwp-backupbuddy' );
                            }
                    }
                }

                if ($error != '') {
                    if ($return)
                        return $error;
                    else
                        die( json_encode( array( 'error' => $error ) ) );
                }
	}

	function ajax_override_settings() {
		self::verify_nonce();
		$websiteId = $_POST['backupbuddyRequestSiteID'];
		global $mainWP_BackupBuddy_Extension_Activator;
		$website = apply_filters( 'mainwp-getsites', $mainWP_BackupBuddy_Extension_Activator->get_child_file(), $mainWP_BackupBuddy_Extension_Activator->get_child_key(), $websiteId );
		if ( $website && is_array( $website ) ) {
			$website = current( $website );
		}

		if ( ! $website ) {
			die( json_encode( array( 'error' => 'Error site data.' ) ) ); }

		$update = array(
			'site_id' => $website['id'],
			'override' => intval($_POST['override']),
		);

		MainWP_BackupBuddy_DB::get_instance()->update_backupbuddy( $update );
		die( json_encode( array( 'result' => 'success' ) ) );
	}

	function ajax_save_settings() {
		self::verify_nonce();
		$websiteId = $_POST['backupbuddyRequestSiteID'];
		self::ajax_check_individual_action( $websiteId );

		$type = isset( $_POST['type'] ) ? $_POST['type'] : '';
		if ('general_settings' !== $type && 'advanced_settings' !== $type && 'reset_defaults' !== $type) {
			die( json_encode( array( 'error' => 'Invalid data.' ) ) );
		}

		$is_individual = isset( $_POST['isIndividual'] ) && ! empty( $_POST['isIndividual'] ) ? true : false;

		global $mainWP_BackupBuddy_Extension_Activator;


		if ('reset_defaults' === $type) {
			$post_data = array(
				'mwp_action' => 'reset_defaults',
				'keep_destinations' => isset($_POST['keep_destinations']) ? intval($_POST['keep_destinations']) : 0
			);
		} else {
			$filter_advanced_settings = array(
				'backup_reminders',
				'archive_name_format',
				'archive_name_profile',
				'lock_archives_directory',
				'include_importbuddy',
				'default_backup_tab',
				'disable_localization',
				'limit_single_cron_per_pass',
				'use_internal_cron',
				'remote_send_timeout_retries',
				'hide_live',
                'hide_dashboard_widget',
				'set_greedy_execution_time',
				'archive_limit_size_big',
				'max_execution_time',
				'log_level',
				'save_backup_sum_log',
				'max_site_log_size',
				'max_send_stats_days',
				'max_send_stats_count',
				'max_notifications_age_days',
				'backup_mode',
				'delete_archives_pre_backup',
				'disable_https_local_ssl_verify',
				'prevent_flush',
				'save_comment_meta',
				'integrity_check', // profiles#0
				'backup_cron_rescheduling',
				'skip_spawn_cron_call',
				'backup_cron_passed_force_time',
                'php_runtime_test_minimum_interval',
                'php_memory_test_minimum_interval',
				'database_method_strategy',
				'skip_database_dump', // profiles#0
				'breakout_tables',
				'force_single_db_file',
				'phpmysqldump_maxrows',
				'ignore_command_length_check',
				'compression',
				'zip_method_strategy',
				'alternative_zip_2',
				'zip_build_strategy',
				'zip_step_period',
				'zip_burst_gap',
				'zip_min_burst_content',
				'zip_max_burst_content',
				'disable_zipmethod_caching',
				'ignore_zip_warnings',
				'ignore_zip_symlinks',
			);


			$filter_general_settings = array(
				'importbuddy_pass_hash',
                                'importbuddy_pass_length',
				//'backup_directory',
				'role_access',
				'archive_limit_age',
				'archive_limit_full',
				'archive_limit',
				'archive_limit_size',
				'archive_limit_db',
				'archive_limit_files',
				'title_multisite',
				'multisite_export',
				'backup_nonwp_tables', // profiles#0
				'email_notify_scheduled_start',
				'email_notify_scheduled_start_subject',
				'email_notify_scheduled_start_body',
				'email_notify_scheduled_complete',
				'email_notify_scheduled_complete_subject',
				'email_notify_scheduled_complete_body',
                                'no_new_backups_error_days',
				'email_notify_send_finish',
				'email_notify_send_finish_subject',
				'email_notify_send_finish_body',
				'email_notify_error',
				'email_notify_error_subject',
				'email_notify_error_body',
				'email_return'
			);

                        $individual_settings = array();
                        $individual_data = MainWP_BackupBuddy_DB::get_instance()->get_backupbuddy_by( 'site_id', $websiteId );

                        if ($individual_data) {
                                $individual_settings = $individual_data->settings;
                                $individual_settings = maybe_unserialize( $individual_settings );
                        }

                        if (!is_array($individual_settings)) {
                            $individual_settings = array();
                        }


                        if ($is_individual)
                            $options = $individual_settings;
                        else
                            $options = pb_mainwp_backupbuddy::load_general_option();

                        $use_individual_settings_value = array();

			// save mysql and files options
                        if ($type == 'general_settings') {
                            if ($is_individual) {
                                    $filter_general_settings[] =  'backup_directory';
                                    $filter_general_settings[] =  'mysqldump_additional_includes';
                                    $filter_general_settings[] =  'mysqldump_additional_excludes';
                                    $filter_general_settings[] =  'excludes';
                            } else {
                                    if (isset($options['use_individual_backup_directory']) && !empty($options['use_individual_backup_directory'])) {
                                            if (is_array($individual_settings) && isset($individual_settings['backup_directory'])) {
                                                $use_individual_settings_value['backup_directory'] = $individual_settings['backup_directory'];
                                            }
                                            $filter_general_settings[] = 'backup_directory';
                                    }
                                    if (isset($options['use_individual_mysqldump_inclusions_exclusions']) && !empty($options['use_individual_mysqldump_inclusions_exclusions'])) {
                                            if (is_array($individual_settings) && isset($individual_settings['profiles'][0]['mysqldump_additional_includes'])) {
                                                    $use_individual_settings_value['mysqldump_additional_includes'] = $individual_settings['profiles'][0]['mysqldump_additional_includes'];
                                                    $filter_general_settings[] =  'mysqldump_additional_includes'; // to save the setting
                                            }
                                            if (is_array($individual_settings) && isset($individual_settings['profiles'][0]['mysqldump_additional_excludes'])) {
                                                    $use_individual_settings_value['mysqldump_additional_excludes'] = $individual_settings['profiles'][0]['mysqldump_additional_excludes'];
                                                    $filter_general_settings[] =  'mysqldump_additional_excludes'; // to save the setting
                                            }
                                    }
                                    if (isset($options['use_individual_excludes']) && !empty($options['use_individual_excludes'])) {
                                            if (is_array($individual_settings) && isset($individual_settings['profiles'][0]['excludes'])) {
                                                    $use_individual_settings_value['excludes'] = $individual_settings['profiles'][0]['excludes'];
                                                    $filter_general_settings[] =  'excludes'; // to save the setting
                                            }
                                    }
                            }
                        }

			$filter_profile0_values = array(
				'mysqldump_additional_includes',
				'mysqldump_additional_excludes',
				'excludes',
				'integrity_check',
				'skip_database_dump',
				'backup_nonwp_tables'
			);

			$save_fields = array();
			switch( $type ) {
				case 'general_settings':
					$save_fields = $filter_general_settings;
					break;
				case 'advanced_settings':
					$save_fields = $filter_advanced_settings;
					break;
			}


			$save_options = array();

			foreach($save_fields as $field) {
                                if (isset($use_individual_settings_value[$field])) {
                                        $save_options[$field] = $use_individual_settings_value[$field];
                                } else if (in_array($field, $filter_profile0_values)) {
					if (isset($options['profiles'][0][$field])) {
						$save_options[$field] = $options['profiles'][0][$field];
					}
				} else if (isset($options[$field])) {
					$save_options[$field] = $options[$field];
				}
			}

			if ( empty( $save_options ) ) {
				die( json_encode( array( 'error' => 'Empty settings value.' ) ) );
			}

			$post_data = array(
				'mwp_action' => 'save_settings',
				'type' => $type,
				'options' => base64_encode( serialize( $save_options ) ),
			);

		}

		$information = apply_filters( 'mainwp_fetchurlauthed', $mainWP_BackupBuddy_Extension_Activator->get_child_file(), $mainWP_BackupBuddy_Extension_Activator->get_child_key(), $websiteId, 'backup_buddy', $post_data );
                if (is_array($information)) {
			if (isset($information['backupDirectoryDefault'])) {
				$plugin_data = pb_mainwp_backupbuddy::get_the_plugin_data_of_site($websiteId);
				$plugin_data['backupDirectoryDefault'] = $information['backupDirectoryDefault'];
				$update = array(
					'site_id' => $websiteId,
					'plugin_data' => serialize($plugin_data),
				);
				MainWP_BackupBuddy_DB::get_instance()->update_backupbuddy( $update );
			}
		}
		die( json_encode( $information ) );
	}


	function ajax_reload_notifications() {
		self::verify_nonce();
		$websiteId = $_POST['backupbuddyRequestSiteID'];
		global $mainWP_BackupBuddy_Extension_Activator;
		$post_data = array(
			'mwp_action' => 'get_notifications'
		);
		$information = apply_filters( 'mainwp_fetchurlauthed', $mainWP_BackupBuddy_Extension_Activator->get_child_file(), $mainWP_BackupBuddy_Extension_Activator->get_child_key(), $websiteId, 'backup_buddy', $post_data );
		if (is_array($information)) {
			if (isset($information['notifications'])) {
				$plugin_data = pb_mainwp_backupbuddy::get_the_plugin_data_of_site($websiteId);
				$plugin_data['notifications'] = $information['notifications'];
				$update = array(
					'site_id' => $websiteId,
					'plugin_data' => serialize($plugin_data),
				);
				MainWP_BackupBuddy_DB::get_instance()->update_backupbuddy( $update );
				$information['html_acts'] = self::gen_activities_list($information['notifications']);
				unset($information['notifications']);
			}
		}
		die( json_encode( $information ) );
	}

	function ajax_reload_backups_list() {
		self::verify_nonce();
		$websiteId = $_POST['backupbuddyRequestSiteID'];
		global $mainWP_BackupBuddy_Extension_Activator;
		$post_data = array(
			'mwp_action' => 'backup_list'
		);
		$information = apply_filters( 'mainwp_fetchurlauthed', $mainWP_BackupBuddy_Extension_Activator->get_child_file(), $mainWP_BackupBuddy_Extension_Activator->get_child_key(), $websiteId, 'backup_buddy', $post_data );

		if (is_array($information) && isset($information['backup_list'])) {
			$plugin_data = pb_mainwp_backupbuddy::get_the_plugin_data_of_site($websiteId);
			$plugin_data['backup_list'] = $information['backup_list'];
			$plugin_data['recent_backup_list'] = $information['recent_backup_list'];
			$plugin_data['backupDirectoryWithinSiteRoot'] = $information['backupDirectoryWithinSiteRoot'];
			//$plugin_data['destinations_list'] = $information['destinations_list'];
			$update = array(
				'site_id' => $websiteId,
				'plugin_data' => serialize($plugin_data),
			);
			MainWP_BackupBuddy_DB::get_instance()->update_backupbuddy( $update );
			unset($information['backup_list']);
			unset($information['recent_backup_list']);
			//unset($information['destinations_list']);
		}

		die( json_encode( $information ) );
	}

        function ajax_reload_remote_dest() {
		self::verify_nonce();
		$websiteId = $_POST['backupbuddyRequestSiteID'];
		global $mainWP_BackupBuddy_Extension_Activator;
		$post_data = array(
			'mwp_action' => 'remote_list'
		);
		$information = apply_filters( 'mainwp_fetchurlauthed', $mainWP_BackupBuddy_Extension_Activator->get_child_file(), $mainWP_BackupBuddy_Extension_Activator->get_child_key(), $websiteId, 'backup_buddy', $post_data );
		if (is_array($information) && isset($information['remote_destinations'])) {
                        $current = MainWP_BackupBuddy_DB::get_instance()->get_backupbuddy_by( 'site_id', $websiteId );
                        $settings = array();
                        if ($current) {
				$value = $current->settings;
				$settings = maybe_unserialize( $value );
			}
                        $settings['remote_destinations'] = $information['remote_destinations'];
			$update = array(
				'site_id' => $websiteId,
				'settings' => serialize($settings),
			);
			MainWP_BackupBuddy_DB::get_instance()->update_backupbuddy( $update );
			unset($information['remote_destinations']);
		}
		die( json_encode( $information ) );
	}

        function ajax_reload_products_license() {
            self::verify_nonce();
		$websiteId = $_POST['backupbuddyRequestSiteID'];
		global $mainWP_BackupBuddy_Extension_Activator;
		$post_data = array(
			'mwp_action' => 'load_products_license'
		);
		$information = apply_filters( 'mainwp_fetchurlauthed', $mainWP_BackupBuddy_Extension_Activator->get_child_file(), $mainWP_BackupBuddy_Extension_Activator->get_child_key(), $websiteId, 'backup_buddy', $post_data );

		if (is_array($information) && isset($information['packages'])) {
			$plugin_data = pb_mainwp_backupbuddy::get_the_plugin_data_of_site($websiteId);
			$plugin_data['ithemes_packages'] = $information['packages'];
                        $plugin_data['ithemes_packages_name'] = $information['packages_name'];
			$update = array(
				'site_id' => $websiteId,
				'plugin_data' => serialize($plugin_data),
			);
			MainWP_BackupBuddy_DB::get_instance()->update_backupbuddy( $update );
			unset($information['packages']);
                        unset($information['packages_name']);
		}
		die( json_encode( $information ) );
        }

        function ajax_reload_schedules_list() {
		self::verify_nonce();
		$websiteId = $_POST['backupbuddyRequestSiteID'];
		global $mainWP_BackupBuddy_Extension_Activator;
		$post_data = array(
			'mwp_action' => 'schedules_list'
		);
		$information = apply_filters( 'mainwp_fetchurlauthed', $mainWP_BackupBuddy_Extension_Activator->get_child_file(), $mainWP_BackupBuddy_Extension_Activator->get_child_key(), $websiteId, 'backup_buddy', $post_data );

		if (is_array($information) && isset($information['schedules'])) {
                        // save individual settings
                        $options = pb_mainwp_backupbuddy::get_backupbuddy_options($websiteId);
                        $options['schedules'] = $information['schedules'];
                        //$options['next_schedule_index'] = $information['next_schedule_index'];
                        $options['schedules_run_time'] = $information['schedules_run_time'];

                        pb_mainwp_backupbuddy::save_backupbuddy_options($websiteId, $options);
			unset($information['schedules']);
			unset($information['next_schedule_index']);
                        unset($information['schedules_run_time']);
			//unset($information['destinations_list']);
		}
		die( json_encode( $information ) );
	}

	function ajax_process_scheduled_backup() {
		self::verify_nonce();

		$action = $_POST['what'];
		if ('save_scheduled_backup' !== $action && 'delete_scheduled_backup' !== $action) {
			die(json_encode(array('error' => __('Error: Invalid request', 'it-l10n-mainwp-backupbuddy'))));
		}

		$websiteId = $_POST['backupbuddyRequestSiteID'];

                $is_individual = isset( $_POST['isIndividual'] ) && ! empty( $_POST['isIndividual'] ) ? true : false;
                if (!$is_individual) // check general only
                    self::ajax_check_individual_action( $websiteId );

		$schedule_ids = isset($_POST['schedule_ids']) ? $_POST['schedule_ids'] : 0;
		if (empty($schedule_ids)) {
			die(json_encode(array('error' => __('Error: empty scheduled backup id', 'it-l10n-mainwp-backupbuddy'))));
		}


		$post_data = array(
			'mwp_action' => $action,
		);

		$sche_id = 0;
		if ('save_scheduled_backup' === $action) {
			$sche_id = intval($schedule_ids);
			if (!isset(pb_mainwp_backupbuddy::$options['schedules'][$sche_id])) {
				die(json_encode(array('error' => __('Error: not found the scheduled backup', 'it-l10n-mainwp-backupbuddy'))));
			}
			$post_data['schedule_id'] = intval($sche_id);
                        $schedule = pb_mainwp_backupbuddy::$options['schedules'][$sche_id];

                        if (!$is_individual) {
                            if (isset($schedule['sites'])) {
                                unset($schedule['sites']);
                            }
                            if (isset($schedule['groups'])) {
                                unset($schedule['groups']);
                            }
                        }

			$post_data['data'] = base64_encode( serialize( $schedule ) );
		} else {
			$post_data['schedule_ids'] = $schedule_ids;
		}
		global $mainWP_BackupBuddy_Extension_Activator;
		$information = apply_filters( 'mainwp_fetchurlauthed', $mainWP_BackupBuddy_Extension_Activator->get_child_file(), $mainWP_BackupBuddy_Extension_Activator->get_child_key(), $websiteId, 'backup_buddy', $post_data );
		if (is_array($information)) {
			if ($is_individual && 'save_scheduled_backup' === $action &&  isset($information['schedules'])) {
				$options = pb_mainwp_backupbuddy::get_backupbuddy_options($websiteId);
				$options['schedules'] = $information['schedules'];
                                //$options['next_schedule_index'] = $information['next_schedule_index'];
                                $options['schedules_run_time'] = $information['schedules_run_time'];
				pb_mainwp_backupbuddy::save_backupbuddy_options($websiteId, $options);
				unset($information['schedules']);
                                unset($information['next_schedule_index']);
                                unset($information['schedules_run_time']);
			}
		}
		die( json_encode( $information ) );
	}

	function ajax_perform_profile_action() {
		self::verify_nonce();

		$action = $_POST['what'];
		if ('save_profile' !== $action && 'delete_profile' !== $action && 'create_backup' !== $action) {
			die(json_encode(array('error' => __('Error: Invalid request', 'it-l10n-mainwp-backupbuddy'))));
		}
		$individual = isset( $_POST['isIndividual'] ) && ! empty( $_POST['isIndividual'] ) ? true : false;
		$websiteId = $_POST['backupbuddyRequestSiteID'];
        self::ajax_check_individual_action( $websiteId );

		$profile_id = isset($_POST['profile_id']) ? $_POST['profile_id'] : 0;
		if (empty($profile_id)) {
			die(json_encode(array('error' => __('Error: empty profile id', 'it-l10n-mainwp-backupbuddy'))));
		}

		$post_data = array(
			'mwp_action' => $action,
		);

		if ('save_profile' === $action) {
			if (!isset(pb_mainwp_backupbuddy::$options['profiles'][$profile_id])) {
				die(json_encode(array('error' => __('Error: not found the profile', 'it-l10n-mainwp-backupbuddy'))));
			}

            $profile = pb_mainwp_backupbuddy::$options['profiles'][$profile_id];

            if (!$individual) {
                if (isset($profile['sites']))
                    unset($profile['sites']);
                if (isset($profile['groups']))
                    unset($profile['groups']);
            }

			$post_data['profile_id'] = intval($profile_id);

			$post_data['data'] = base64_encode( serialize( $profile ) );
		} else if ('create_backup' == $action) {
            // Sending to remote destination after manual backup completes?
            $post_backup_steps = array();
            if ( isset($_POST['after_destination']) && ( is_numeric( $_POST['after_destination'] ) ) ) {
                    $destination_id = (int) $_POST['after_destination'];
                    if ( isset($_POST['delete_after']) && $_POST['delete_after'] == 'true' ) {
                            $delete_after = true;
                    } else {
                            $delete_after = false;
                    }
                    $post_backup_steps = array(
                            array(
                                    'function'		=>		'send_remote_destination',
                                    'args'			=>		array( $destination_id, $delete_after ),
                                    'start_time'	=>		0,
                                    'finish_time'	=>		0,
                                    'attempts'		=>		0,
                            )
                    );
            }

			$post_data['profile_id'] = $profile_id;
            $post_data['post_backup_steps'] = $post_backup_steps;

		} else if ('delete_profile' == $action ){
			$post_data['profile_id'] = $profile_id;
		}

		global $mainWP_BackupBuddy_Extension_Activator;
		$information = apply_filters( 'mainwp_fetchurlauthed', $mainWP_BackupBuddy_Extension_Activator->get_child_file(), $mainWP_BackupBuddy_Extension_Activator->get_child_key(), $websiteId, 'backup_buddy', $post_data );
		die( json_encode( $information ) );
	}

	function ajax_perform_action() {
		self::verify_nonce();

		$websiteId = $_POST['backupbuddyRequestSiteID'];

                if ( !isset($_POST['donotcheckIndividual']) || !$_POST['donotcheckIndividual']) {
                    self::ajax_check_individual_action( $websiteId );
                }

                $action = $_POST['what'];

		$post_data = array(
			'mwp_action' => $action,
		);

		$error = '';
		if ('delete_backup' == $action ) {
                    $item_id = isset($_POST['item_id']) ? $_POST['item_id'] : 0;
                    if (empty($item_id)) {
                        $error = __('Error: Empty item id', 'it-l10n-mainwp-backupbuddy');
                    } else {
                        $post_data['item_ids'] = $item_id;
                    }
		} else if ( 'remote_save' == $action ) {
                    if (isset($_POST['destination_id'])) {
                        $destination_id = $_POST['destination_id'];
                        $post_data['destination_id'] = $destination_id;
                        if ( isset(pb_mainwp_backupbuddy::$options['remote_destinations'][$destination_id]) ) {
                            $post_data['data'] = pb_mainwp_backupbuddy::$options['remote_destinations'][$destination_id];
                        } else {
                            $error = __('Error: Empty destination data', 'it-l10n-mainwp-backupbuddy');
                        }
                    } else {
                        $error = __('Error: Empty destination id', 'it-l10n-mainwp-backupbuddy');
                    }
                } else if ('remote_delete' == $action) {
                    if (isset($_POST['destination_id'])) {
                        $post_data['destination_id'] = $_POST['destination_id'];
                    } else {
                        $error = __('Error: Empty destination id', 'it-l10n-mainwp-backupbuddy');
                    }
                } else if ('settings_other' == $action) {
                    $post_data['other_action'] = $_POST['other_action'];
                } else if ('license_settings' == $action) {
                    $post_data = unserialize(base64_decode($_POST['post_data']));
                } else {
                    $error = __('Error: Invalid request', 'it-l10n-mainwp-backupbuddy');
                }

                if (!empty($error)) {
                    die(json_encode(array('error' => $error)));
                }

		global $mainWP_BackupBuddy_Extension_Activator;
		$information = apply_filters( 'mainwp_fetchurlauthed', $mainWP_BackupBuddy_Extension_Activator->get_child_file(), $mainWP_BackupBuddy_Extension_Activator->get_child_key(), $websiteId, 'backup_buddy', $post_data );

                if ('license_settings' == $action) {
                    if ($post_data['mwp_action'] == 'activate_package') {
                            if (is_array($information)) {
                                if (isset($information['messages']) && is_array($information['messages'])) {
                                    $information['messages'] = implode("<br />", $information['messages']);
                                }
                                if (isset($information['errors']) && is_array($information['errors'])) {
                                    $information['errors'] = implode("<br />", $information['errors']);
                                }
                                if (isset($information['soft_errors']) && is_array($information['soft_errors'])) {
                                    $information['soft_errors'] = implode("<br />", $information['soft_errors']);
                                }
                            }
                    }
                }

		die( json_encode( $information ) );
	}

	function ajax_run_scheduled_backup() {
		self::verify_nonce();
		$websiteId = $_POST['backupbuddyRequestSiteID'];
                $is_individual = isset( $_POST['isIndividual'] ) && ! empty( $_POST['isIndividual'] ) ? true : false;

                if (!$is_individual)
                    self::ajax_check_individual_action( $websiteId );

		if (!isset($_POST['schedule_id']) || empty($_POST['schedule_id'])) {
			die(json_encode(array('error' => __('Error: empty schedule id', 'it-l10n-mainwp-backupbuddy'))));
		}



		global $mainWP_BackupBuddy_Extension_Activator;
		$post_data = array(
			'mwp_action' => 'run_scheduled_backup',
			'schedule_id' => $_POST['schedule_id']
		);
		$information = apply_filters( 'mainwp_fetchurlauthed', $mainWP_BackupBuddy_Extension_Activator->get_child_file(), $mainWP_BackupBuddy_Extension_Activator->get_child_key(), $websiteId, 'backup_buddy', $post_data );
		die( json_encode( $information ) );
	}

	public static function gen_activities_list($notifications) {
			// Compile table from notifications.
			$notificationTable = array();
			foreach( $notifications as $notification ) {

				$slug = $notification['slug'];
				if ( true === $notification['urgent'] ) {
					$slug = '<font color="red">' . $slug . '</font>';
				}

				$additionalData = '<i>None</i>';
				if ( count( $notification['data'] ) > 0 ) {
					//$additionalData = '<textarea>' . print_r( $notification['data'], true ) . '</textarea>';
					$additionalData = '<textarea class="backupbuddy-recent-activity-details" wrap="off">';
					foreach( $notification['data'] as $thisKey => $thisData ) {
						$additionalData .= str_pad( $thisKey, 15 ) . $thisData . "\n";
					}
					$additionalData .= '</textarea>';
				}

				$time = pb_mainwp_backupbuddy::$format->date( pb_mainwp_backupbuddy::$format->localize_time( $notification['time'] ) );
				$time .= '<br><span class="description">' . pb_mainwp_backupbuddy::$format->time_ago( $notification['time'] ) . ' ago</span>';

				$notificationTable[] = array(
					$slug,
					'<b>' . $notification['title'] . '</b><br>' . esc_html( $notification['message'] ),
					$time,
					$additionalData,
				);
			}


			// Flip newest up top.
			$notificationTable = array_reverse( $notificationTable );
			$no_activities = false;

			ob_start();
			echo '<p>';
			if ( count( $notificationTable ) > 0 ) {
				_e( 'Below lists some of the recent activity for this site.', 'it-l10n-mainwp-backupbuddy' );
			} else {
				_e( 'No recent activity logged yet.', 'it-l10n-mainwp-backupbuddy' );
				$no_activities = true;
			}
			echo '</p>';
			if ( count( $notificationTable ) > 0 ) {
				// Display table.
				pb_mainwp_backupbuddy::$ui->list_table(
					$notificationTable, // Array of cron items set in code section above.
					array(
						//'action'					=>	pb_mainwp_backupbuddy::page_url() . '#pb_backupbuddy_getting_started_tab_tools',
						'columns'					=>	array(
															__( 'Action', 'it-l10n-mainwp-backupbuddy' ),
															__( 'Title & Message', 'it-l10n-mainwp-backupbuddy' ),
															__( 'When', 'it-l10n-mainwp-backupbuddy' ),
															__( 'Additional Data', 'it-l10n-mainwp-backupbuddy' ),
														),
						'css'						=>		'width: 100%;',
					)
				);
			}

			$output = ob_get_clean();
			return $output;
	}

}
