<?php
mainwp_backupbuddy_core::verifyAjaxAccess();


// Display file listing of zip.
/*	file_tree()
*	
*	File tree for viewing zip contents.
*	
*	@return		null
*/

$websiteId = $_GET['site_id'];
if (empty($websiteId)) {
	pb_mainwp_backupbuddy::alert( 'Error from file tree: empty site id.' );
	return;
}

$root = trim( urldecode( pb_mainwp_backupbuddy::_POST( 'dir' ) ) );
$post_data = array(
	'mwp_action' => 'zip_viewer',	
	'dir' => $root,
	'serial' => pb_mainwp_backupbuddy::_GET( 'serial' ),
	'zip_viewer' => pb_mainwp_backupbuddy::_GET( 'zip_viewer' ),
);		

global $mainWP_BackupBuddy_Extension_Activator;			
$information = apply_filters( 'mainwp_fetchurlauthed', $mainWP_BackupBuddy_Extension_Activator->get_child_file(), $mainWP_BackupBuddy_Extension_Activator->get_child_key(), $websiteId, 'backup_buddy', $post_data );		

if (is_array($information)) {
	if (isset($information['files'])) {
		if (isset($information['error'])) {
			pb_mainwp_backupbuddy::alert( $information['error'] );
		}
		$files = $information['files'];
	} else if (isset($information['error'])) {
		pb_mainwp_backupbuddy::alert( $information['error'] );
		return;
	} else {
		pb_mainwp_backupbuddy::alert( 'Undefined error.' );
		return;
	}
} else {
	pb_mainwp_backupbuddy::alert( 'Undefined error.' );
	return;
}

// Simple sort function to bubble dirs up to the top of list and
// have dirs and files in simple alpha order
function pb_mainwp_backupbuddy_sort_file_list( $a, $b ) {

	// If both are dirs or files then result is 0
	// If $a is dir and $b is file then result is -1
	// If $a is file and $b is dir then result is 1
	if ( 0 == ( $res = substr_count( $b[0], '/' ) - substr_count( $a[0], '/' ) ) ) {
	
		// Both same type so sort alpha
		$res = strcmp( rtrim( $a[0], '/' ), rtrim( $b[0], '/') );
	
	}
	
	return $res;
	
}

// Try and sort the files to put dirs first and all in alpha
// Remember original in case the sort fails
$saved_files = $files;
if ( false === usort( $files, 'pb_mainwp_backupbuddy_sort_file_list' ) ) {

	// Hmm, the sort failed, just revert to original
	$files = $saved_files;
}

// Now we can start to build the listing to display
if( count( $files ) > 0 ) {
	echo '<ul class="jqueryFileTree" style="display: none;">';
	
	// Files which are considered text-based and therefore contents viewable to the user.
	$view_ext = array(
		'php',
		'htaccess',
		'htm',
		'html',
		'txt',
		'css',
		'ini',
		'sql',
	);
	
	foreach( $files as $file ) {
		if ( substr( $file[0], -1 ) == '/' ) { // Directory.
			echo '<li class="directory collapsed">';
			$return = '';
			echo '<input type="checkbox">';
			echo '<a class="hoverable" href="#" rel="' . htmlentities( $root . $file[0] ) . '" title="Toggle expand...">' . htmlentities( rtrim( $file[0], '/' ) ) . $return . '</a>';
			echo '</li>';
		} else { // File.
			
			$actions = array();
			$ext = pathinfo( htmlentities( $file[0] ), PATHINFO_EXTENSION );
			
			$viewable = false;
			if ( in_array( $ext, $view_ext ) ) {
				$viewable = true;
			}
			
			echo '<li class="file collapsed ext_' . $ext;
			if ( true === $viewable ) {
				echo ' viewable';
			}
			echo '"><input type="checkbox">';
			if ( true === $viewable ) {
				echo '<a onclick="modal_live(\'restore_file_view\',jQuery(this));" class="hoverable" rel="' . htmlentities( $root . $file[0] ) . '">';
			} else {
				echo '<a href="#" rel="' . htmlentities( $root . $file[0] ) . '">';
			}
			echo htmlentities( $file[0] );
			
			if ( true === $viewable ) {
				echo '<span class="viewlink_place"><img src="' . pb_mainwp_backupbuddy::plugin_url() . '/images/eyecon.png"></span>';
				echo '<span class="viewlink"><img src="' . pb_mainwp_backupbuddy::plugin_url() . '/images/eyecon.png"> View</span>';
			}
			
			echo '<span class="pb_backupbuddy_fileinfo">';
			echo '	<span class="pb_backupbuddy_col1">' . pb_mainwp_backupbuddy::$format->file_size( $file[1] ) . '</span>';
			echo '	<span class="pb_backupbuddy_col2">' . pb_mainwp_backupbuddy::$format->date( pb_mainwp_backupbuddy::$format->localize_time( $file[3] ) ) . ' <span class="description">(' . pb_mainwp_backupbuddy::$format->time_ago( $file[3] ) . ' ago)</span></span>';
			echo '</span>';
			
			echo '</a></li>';
		}
	}
	echo '</ul>';
} else {
	echo '<ul class="jqueryFileTree" style="display: none;">';
	echo '<li><a href="#" rel="' . htmlentities( pb_mainwp_backupbuddy::_POST( 'dir' ) . 'NONE' ) . '"><i>Empty Directory ...</i></a></li>';
	echo '</ul>';
}

