<?php
mainwp_backupbuddy_core::verifyAjaxAccess();
pb_mainwp_backupbuddy::$ui->ajax_header( $js = true, $padding = true );

require_once( pb_mainwp_backupbuddy::plugin_path() . '/destinations/bootstrap.php' );
require_once( pb_mainwp_backupbuddy::plugin_path() . '/destinations/live/live.php' );
require_once( pb_mainwp_backupbuddy::plugin_path() . '/destinations/live/live_periodic.php' );

$websiteId = isset($_REQUEST['buddy_manage_site_id']) ? $_REQUEST['buddy_manage_site_id'] : 0 ;
$hidden_site_id = '<input type="hidden" name="buddy_manage_site_id" value="' . $websiteId . '" />';

$destination_id = backupbuddy_mainwp_live::getLiveID();
$destination_settings = backupbuddy_mainwp_live_periodic::get_destination_settings();

echo '<h2>' . __( 'BackupBuddy Stash Live Settings', 'it-l10n-mainwp-backupbuddy' ) . '</h2>';


// Settings form setup.
$settings_form = pb_mainwp_backupbuddy_destinations::configure( $destination_settings, $mode = 'edit', $destination_id, $url = pb_mainwp_backupbuddy::ajax_url( 'live_settings' ) );

// Process saving.
if ( $websiteId && '' != pb_mainwp_backupbuddy::_POST( 'pb_backupbuddy_' ) ) {
	pb_mainwp_backupbuddy::verify_nonce();
	$save_result = $settings_form->process();
	if ( count( $save_result['errors'] ) == 0 ) { // NO ERRORS SO SAVE.
            
            $post_data = array(
                    'mwp_action' => 'live_save_settings',
                    'data' => $save_result['data'],
                    'destination_id' => $destination_id
            );
            
            global $mainWP_BackupBuddy_Extension_Activator;			
            $information = apply_filters( 'mainwp_fetchurlauthed', $mainWP_BackupBuddy_Extension_Activator->get_child_file(), $mainWP_BackupBuddy_Extension_Activator->get_child_key(), $websiteId, 'backup_buddy', $post_data );		
            $error = '';
            if (is_array($information)) { 
                if (isset($information['error'])) {	
                    $error = $information['error'];
                } else if (isset($information['ok'])) {                      
                    pb_mainwp_backupbuddy::$options['remote_destinations'][$destination_id] = array_merge( pb_mainwp_backupbuddy::$options['remote_destinations'][$destination_id], $save_result['data'] );
                    pb_mainwp_backupbuddy::save();
                    pb_mainwp_backupbuddy::alert( __( 'Settings saved. Restarting Live process so they take immediate effect.', 'it-l10n-mainwp-backupbuddy' ) );
                } else {
                    $error = 'Undefined error.';
                }
            } else {
                $error = 'Undefined error.';
            }  
            if (!empty($error)) {
                pb_mainwp_backupbuddy::alert( 'Error saving settings. ' . $error );
            }
            
	} else {
		pb_mainwp_backupbuddy::alert( 'Error saving settings. ' . implode( "\n", $save_result['errors'] ) );
	}
}

// Show settings form.
echo $settings_form->display_settings( 'Save Settings', $before = '', $afterText = $hidden_site_id . ' <img class="pb_backupbuddy_destpicker_saveload" src="' . pb_mainwp_backupbuddy::plugin_url() . '/images/loading.gif" title="Saving... This may take a few seconds..." style="display: none;">', 'pb_backupbuddy_destpicker_save' ); // title, before, after, class


if ( 'live' == $destination_settings['type'] ) {	
        $admin_url = admin_url( 'admin.php' );	
	?>
	<a href="<?php echo pb_mainwp_backupbuddy::nonce_url( $admin_url . '?page=ManageSitesBuddy&subpage=live&id=' . $websiteId . '&live_action=disconnect' ); ?>" target="_top" style="float:right;margin-top:-3em;color:#f95050;" class="" onClick="if ( ! confirm( '<?php _e( "Are you sure you want to disconnect this site from BackupBuddy Stash Live?", "it-l10n-mainwp-backupbuddy" ); ?>' ) ) { return false; }"><?php _e( 'Disconnect from Stash Live', 'it-l10n-mainwp-backupbuddy' ); ?></a>
	<?php
}


pb_mainwp_backupbuddy::$ui->ajax_footer( $js_common = true );