<?php
mainwp_backupbuddy_core::verifyAjaxAccess();
pb_mainwp_backupbuddy::verify_nonce();

$errors = array();
$form = pb_mainwp_backupbuddy::_POST();


$archive_types = array(
	'db' => __( 'Database Backup', 'it-l10n-mainwp-backupbuddy' ),
	'full' => __( 'Full Backup', 'it-l10n-mainwp-backupbuddy' ),
	'plugins' => __( 'Plugins Backup', 'it-l10n-mainwp-backupbuddy' ),
	'themes' => __( 'Themes Backup', 'it-l10n-mainwp-backupbuddy' ),
);

$archive_periods = array(
	'daily',
	'weekly',
	'monthly',
	'yearly',
);

$websiteId = isset($_POST['buddy_manage_site_id']) ? intval($_POST['buddy_manage_site_id']) : 0;

if (empty($websiteId)) {
    $errors[] = 'Error: Empty site id'; 
} else {
        if ( ( '' == pb_mainwp_backupbuddy::_POST( 'live_username' ) ) || ( '' == pb_mainwp_backupbuddy::_POST( 'live_password' ) ) ) { // A field is blank.
                $errors[] = 'You must enter your iThemes username & password to log in to BackupBuddy Stash Live.';
        } else { 
                $live_username = pb_mainwp_backupbuddy::_POST( 'live_username' );
                $live_password = pb_mainwp_backupbuddy::_POST( 'live_password' );
                $email = pb_mainwp_backupbuddy::_POST( 'email' );
                $send_snapshot_notification = pb_mainwp_backupbuddy::_POST( 'send_snapshot_notification' );        
                $live_settings = array();
                // Archive limits.
                foreach( $archive_types as $archive_type => $archive_type_name ) {
                        foreach( $archive_periods as $archive_period ) {
                               $settings_name = 'limit_' . $archive_type . '_' . $archive_period;
                               $live_settings[ $settings_name ] = pb_mainwp_backupbuddy::_POST( $settings_name );
                        }
                }

                
                $post_data = array(
                        'mwp_action' => 'live_setup',
                        'live_username' => $live_username,
                        'live_password' => $live_password,
                        'email' => $email,
                        'send_snapshot_notification' => $send_snapshot_notification,
                        'live_settings' => $live_settings                        
                );	
                global $mainWP_BackupBuddy_Extension_Activator;			
                $information = apply_filters( 'mainwp_fetchurlauthed', $mainWP_BackupBuddy_Extension_Activator->get_child_file(), $mainWP_BackupBuddy_Extension_Activator->get_child_key(), $websiteId, 'backup_buddy', $post_data );		

                if (is_array($information)) { 
                    if (isset($information['error'])) {	
                        $errors[] = $information['error'];
                    } else if (isset($information['errors'])) {
                        $errors = $information['errors'];
                    } else if (isset($information['destination_id'])) {
                        $destination_id = $information['destination_id'];
                        $data = $information['data'];
                        unset($data['itxapi_token']);
                        pb_mainwp_backupbuddy::$options['remote_destinations'][ $destination_id ] = $data;
                    } else {
                        $errors[] = 'Undefined error.';
                    }
                } else {
                    $errors[] = 'Undefined error.';
                }                
        } 
}

if ( 0 == count( $errors ) ) {
	pb_mainwp_backupbuddy::save();
	die( 'Success.' );
} else {
	die( '* ' . implode( "\n* ", $errors ) );
}
