<?php
mainwp_backupbuddy_core::verifyAjaxAccess();
//pb_mainwp_backupbuddy::$ui->ajax_header( $js = true, $padding = false );

$websiteId = isset($_POST['buddy_manage_site_id']) ? intval($_POST['buddy_manage_site_id']) : 0;
$destination_id = isset($_POST['destination_id']) ? $_POST['destination_id'] : 0; 
$live_mode = isset($_POST['live_mode']) && $_POST['live_mode'] ? true : false ; 

if ( ! isset( pb_mainwp_backupbuddy::$options['remote_destinations'][ $destination_id ] ) ) {
    die( json_encode( array( 'error' => 'Error #9828332: Destination not found with id `' . htmlentities( $destination_id ) . '`.' ) ) );
} 
       
if ( ! $live_mode ) {	
	$url_prefix = pb_mainwp_backupbuddy::ajax_url( 'remoteClient' ) . '&destination_id=' . $destination_id . '&remote_path=' . $remote_path;
} else {
	$url_prefix = pb_mainwp_backupbuddy::ajax_url( 'live_stash_files' ); 
}

$hover_actions = array( $url_prefix . '&cpy_file=' => '<span class="dashicons dashicons-migrate"></span> Copy to Local', 'stash_download_file' => '<span class="dashicons dashicons-download"></span> Download' );
 
$error = '';
$information = null;

if (empty($websiteId)) {
    $error = 'Error: Empty site id'; 
} else {
    $post_data = array(
            'mwp_action' => 'get_live_backups',
            'destination_id' => $destination_id       
    );
    global $mainWP_BackupBuddy_Extension_Activator;			
    $information = apply_filters( 'mainwp_fetchurlauthed', $mainWP_BackupBuddy_Extension_Activator->get_child_file(), $mainWP_BackupBuddy_Extension_Activator->get_child_key(), $websiteId, 'backup_buddy', $post_data );		           
}


if (is_array($information) && isset($information['backup_list']) && is_array($information['backup_list'])) {
        $backup_list = $information['backup_list'];
        $destination = pb_mainwp_backupbuddy::$options['remote_destinations'][ $destination_id ];
        
        ob_start();
        ?>
        <script type="text/javascript">
                jQuery(document).ready(function() {

                        jQuery( '.pb_backupbuddy_hoveraction_copy' ).click( function() {
                                var backup_file = jQuery(this).attr( 'rel' );
                                var backup_url = '<?php echo $url_prefix; ?>&cpy_file=' + backup_file;

                                window.location.href = backup_url;

                                return false;
                        } );

                        jQuery( '.pb_backupbuddy_hoveraction_download_link' ).click( function() {
                                var backup_file = jQuery(this).attr( 'rel' );
                                var backup_url = '<?php echo $url_prefix; ?>&downloadlink_file=' + backup_file;

                                window.location.href = backup_url;

                                return false;
                        } );

                });
        </script>

        <?php 


        if ( 'live' == $destination['type'] ) {
                $backup_title = __( 'Remote Snapshot Files', 'it-l10n-mainwp-backupbuddy' );
        } else {
                $backup_title = __( 'Stash Traditional Backup Files', 'it-l10n-mainwp-backupbuddy' );
        }

        // Render table listing files.
        if ( count( $backup_list ) == 0 ) {
                echo '<br><b>';
                if ( 'live' == $destination['type'] ) {
                        _e( 'Your remote BackupBuddy Stash storage does not contain any Snapshot zip files yet. It may take several minutes after a Snapshot for them to display.', 'it-l10n-mainwp-backupbuddy' );
                } else {
                        _e( 'Your remote BackupBuddy Stash storage does not contain any traditional backup zip files yet.', 'it-l10n-mainwp-backupbuddy' );
                }
                echo '</b></center>';
        } else {
                $tableArgs = array(
                        'action'		=>	$url_prefix,
                        'columns'		=>	array( '<b>' . $backup_title . '</b>', 'Uploaded <img src="' . pb_mainwp_backupbuddy::plugin_url() . '/images/sort_down.png" style="vertical-align: 0px;" title="Sorted most recent first">', 'File Size', 'Type' ),
                        'hover_actions'	=>	$hover_actions,
                        'hover_action_column_key'	=>	'0',
                        'bulk_actions'	=>	array( 'delete_backup' => __( 'Delete', 'it-l10n-mainwp-backupbuddy' ) ),
                        'css'			=>		'width: 100%;',
                        'site_id'   => $websiteId
                );
                if ( 'live' == $destination['type'] ) {
                        $tableArgs['bulk_actions'] = array();
                }
                pb_mainwp_backupbuddy::$ui->list_table( $backup_list, $tableArgs );
        }
        
        $result = ob_get_clean();
        die(json_encode(array('result' => $result)));

} else if (isset($information['error'])) {
    $error = $information['error'];
} else {
    $error = 'Undefined error.';
}

if (!empty($error))
    die(json_encode( array( 'error' => $error ) ) );

die();

//pb_mainwp_backupbuddy::$ui->ajax_footer( $js_common = true );