<?php
mainwp_backupbuddy_core::verifyAjaxAccess();


// File restorer (actual unzip/restore) in the file restore page.
/* restore_file_restore()
*
* AJAX page for thickbox for restoring a file from inside an archive..
*
*/


$files = pb_mainwp_backupbuddy::_GET( 'files' ); // file to extract.
$archive_file = pb_mainwp_backupbuddy::_GET( 'archive' ); // archive to extract from.

$files_array = explode( ',', $files );
$files = array();
foreach( $files_array as $file ) {
	if ( substr( $file, -1 ) == '/' ) { // If directory then add wildcard.
		$file = $file . '*';
	}
	$files[$file] = $file;
}
unset( $files_array );

$websiteId = $_GET['site_id'];
if (empty($websiteId)) {
	pb_mainwp_backupbuddy::alert( 'Error: file restore - empty site id.' );
	return;
}

pb_mainwp_backupbuddy::$ui->ajax_header( true, false ); // js, no padding
?>

<style>html { background: inherit !important; }</style>
<script type="text/javascript">
	function pb_status_append( json ) {
		if( 'undefined' === typeof statusBox ) { // No status box yet so may need to create it.
			statusBox = jQuery( '#backupbuddy_messages' );
			if( statusBox.length == 0 ) { // No status box yet so suppress.
				return;
			}
		}
		
		if ( 'string' == ( typeof json ) ) {
			mainwp_backupbuddy_log( json );
			console.log( 'Status log received string: ' + json );
			return;
		}
		
		// Used in BackupBuddy _backup-perform.php and ImportBuddy _header.php
		json.date = new Date();
		json.date = new Date(  ( json.time * 1000 ) + json.date.getTimezoneOffset() * 60000 );
		var seconds = json.date.getSeconds();
		if ( seconds < 10 ) {
			seconds = '0' + seconds;
		}
		json.date = mainwp_backupbuddy_hourpad( json.date.getHours() ) + ':' + json.date.getMinutes() + ':' + seconds;
		
		triggerEvent = 'backupbuddy_' + json.event;
		
		
		// Log non-text events.
		if ( ( 'details' !== json.event ) && ( 'message' !== json.event ) && ( 'error' !== json.event ) ) {
			//console.log( 'Non-text event `' + triggerEvent + '`.' );
		} else {
			//console.log( json.data );
		}
		//console.log( 'trigger: ' + triggerEvent );
		
		mainwp_backupbuddy_log( json );
		
		
	} // End function pb_status_append().
	
	
	// Used in BackupBuddy _backup-perform.php and ImportBuddy _header.php and _rollback.php
	function mainwp_backupbuddy_log( json ) {
		message = '';
		
		if ( 'string' == ( typeof json ) ) {
			message = "-----------\t\t-------\t-------\t" + json;
		} else {
			message = json.date + '.' + json.u + " \t" + json.run + "sec \t" + json.mem + "MB\t" + json.data;
		}
		
		target_id = 'pb_backupbuddy_status'; // importbuddy_status or pb_backupbuddy_status
		if( jQuery( '#' + target_id ).length == 0 ) { // No status box yet so suppress.
			return;
		}
		jQuery( '#' + target_id ).append( "\n" + message );
		textareaelem = document.getElementById( target_id );
		textareaelem.scrollTop = textareaelem.scrollHeight;
	}
	
	function mainwp_backupbuddy_hourpad(n) { return ("0" + n).slice(-2); }
</script>
<?php
$success = false;

global $pb_mainwp_backupbuddy_js_status;
$pb_mainwp_backupbuddy_js_status = true;
echo pb_mainwp_backupbuddy::status_box( 'Restoring . . .' );
echo '<div id="pb_backupbuddy_working" style="width: 100px;"><br><center><img src="' . pb_mainwp_backupbuddy::plugin_url() . '/images/working.gif" title="Working... Please wait as this may take a moment..."></center></div>';

$files = pb_mainwp_backupbuddy::_GET( 'files' ); // file to extract.
$archive_file = pb_mainwp_backupbuddy::_GET( 'archive' ); // archive to extract from.

$post_data = array(
	'mwp_action' => 'restore_file_restore',	
	'files' => $files,
	'archive' => $archive_file	
);		

global $mainWP_BackupBuddy_Extension_Activator;			
$information = apply_filters( 'mainwp_fetchurlauthed', $mainWP_BackupBuddy_Extension_Activator->get_child_file(), $mainWP_BackupBuddy_Extension_Activator->get_child_key(), $websiteId, 'backup_buddy', $post_data );		

if (is_array($information)) {
	if (isset($information['restore_result'])) {
		$restore_result = $information['restore_result'];
	} else if (isset($information['error'])) {
		pb_mainwp_backupbuddy::alert( $information['error'] );
		return;
	} else {
		pb_mainwp_backupbuddy::alert( 'Undefined error.' );
		return;
	}
} else {
	pb_mainwp_backupbuddy::alert( 'Undefined error.' );
	return;
}
//$result = $restore_result;
echo $restore_result;

echo '<script type="text/javascript">jQuery("#pb_backupbuddy_working").hide();</script>';

pb_mainwp_backupbuddy::flush();

if ( false === $result ) {	
} else {
}

pb_mainwp_backupbuddy::$ui->ajax_footer();
die();

