<?php
if ( ! is_admin() ) { die( 'Access denied' ); }

// Check if running PHP 5.3+.
$php_minimum = 5.3;
if ( version_compare( PHP_VERSION, $php_minimum, '<' ) ) { // Server's PHP is insufficient.
	echo '<br>';
	pb_mainwp_backupbuddy::alert( '<h3>' . __( 'We have a problem...', 'it-l10n-mainwp-backupbuddy' ) . '</h3><br>' . __( '<span style="font-size:1.5em;font-weight:bold;">Uh oh!</span><br />BackupBuddy Stash Live requires PHP version 5.3 or newer to run. Please upgrade your PHP version or contact your host for details on upgrading.', 'it-l10n-mainwp-backupbuddy' ) . ' ' . __( 'Current PHP version', 'it-l10n-mainwp-backupbuddy' ) . ': ' . PHP_VERSION );
	return;
}

if ( ! function_exists( 'curl_version' ) ) {
	echo '<br>';
	pb_mainwp_backupbuddy::alert( '<h3>' . __( 'We have a problem...', 'it-l10n-mainwp-backupbuddy' ) . '</h3><br>' . __( 'BackupBuddy Stash Live requires the PHP "curl" extension to run. Please install or contact your host to install curl. This is a standard extension and should be available on all hosts.', 'it-l10n-mainwp-backupbuddy' ) );
	return;
}

$site_id = $_GET['id'];

// No PHP runtime calculated yet. Try to see if test is finished.
if ( 0 == pb_mainwp_backupbuddy::$options['tested_php_runtime'] ) {
	mainwp_backupbuddy_core::php_runtime_test_results();
}

$liveDestinationID = false;
foreach( pb_mainwp_backupbuddy::$options['remote_destinations'] as $destination_id => $destination ) {
	if ( 'live' == $destination['type'] ) {
		$liveDestinationID = $destination_id;
		break;
	}
}


// Handle disconnect.
if ( ( 'disconnect' == pb_mainwp_backupbuddy::_GET( 'live_action' ) ) && ( false !== $liveDestinationID ) ) { // If disconnecting and not already disconnected.
	pb_mainwp_backupbuddy::verify_nonce();
	
        $post_data = array(
            'mwp_action' => 'live_action_disconnect',            
            'destination_id' => $liveDestinationID
        );
            
        global $mainWP_BackupBuddy_Extension_Activator;			
        $information = apply_filters( 'mainwp_fetchurlauthed', $mainWP_BackupBuddy_Extension_Activator->get_child_file(), $mainWP_BackupBuddy_Extension_Activator->get_child_key(), $site_id, 'backup_buddy', $post_data );		
        $error = '';
        if (is_array($information)) { 
            if (isset($information['error'])) {	
                $error = $information['error'];
            }            
            if (isset($information['ok'])) {
                    unset( pb_mainwp_backupbuddy::$options['remote_destinations'][ $liveDestinationID ] );
                    pb_mainwp_backupbuddy::save();
                    pb_mainwp_backupbuddy::disalert( '', 'You have disconnected from Stash Live.' );                    
                    $liveDestinationID = false;
            }
        } else {
            $error = 'Undefined error.';
        }  
        
        if (!empty($error))
            pb_mainwp_backupbuddy::disalert( '', $error );
            
}



// Show setup screen if not yet set up.
if ( false === $liveDestinationID ) {
	require_once( pb_mainwp_backupbuddy::plugin_path() . '/destinations/live/_live_setup.php' );
	return;
}



// Load normal manage page.



pb_mainwp_backupbuddy::$ui->title( __( 'BackupBuddy Stash Live', 'it-l10n-mainwp-backupbuddy' ) . '&nbsp;&nbsp;<a href="' . pb_mainwp_backupbuddy::ajax_url( 'live_settings' ) . '&buddy_manage_site_id=' . $site_id . '&#038;TB_iframe=1&#038;width=640&#038;height=600" class="add-new-h2 thickbox">' . __( 'Settings', 'it-l10n-mainwp-backupbuddy' ) . '</a>' );

$destination = pb_mainwp_backupbuddy::$options['remote_destinations'][ $liveDestinationID ];
$destination_id = $liveDestinationID;
require_once( pb_mainwp_backupbuddy::plugin_path() . '/destinations/live/_manage.php' ); // Expects incoming vars: $destination, $destination_id.


