<?php
/* BackupBuddy Stash Live Main Page
 *
 * @author Dustin Bolton
 * @since 7.0
 *
 */

pb_mainwp_backupbuddy::load_style( 'backupProcess2.css' );
pb_mainwp_backupbuddy::load_style( 'backupbuddy_live.css' );
pb_mainwp_backupbuddy::load_script( 'underscore' );

$site_id = isset($_GET['id']) ? intval($_GET['id']) : 0;

//if ( is_network_admin() ) {
//	$admin_url = network_admin_url( 'admin.php' );
//} else {
	$admin_url = 'admin.php?page=ManageSitesBuddy&subpage=live&id=' . $site_id;
//}



pb_mainwp_backupbuddy::alert( '{error placeholder}', false, $error_code = '', $rel_tag = 'stash_live_error_alert' );
?>


<script>
	var loadingIndicator = '';
	jQuery(document).ready(function() {
		loadingIndicator = jQuery( '.pb_backupbuddy_loading' );
	});

	function mainwp_backupbuddy_resizeIframe(obj) {
		newHeight = obj.contentWindow.document.body.scrollHeight;
		obj.style.height = newHeight + 'px';
	}
</script>

<?php
// Incoming vars: $destination, $destination_id
if ( isset( $destination['disabled'] ) && ( '1' == $destination['disabled'] ) ) {
	die( __( 'This destination is currently disabled based on its settings. Re-enable it under its Advanced Settings.', 'it-l10n-mainwp-backupbuddy' ) );
}

wp_enqueue_script( 'thickbox' );
wp_print_scripts( 'thickbox' );
wp_print_styles( 'thickbox' );


require_once( pb_mainwp_backupbuddy::plugin_path() . '/destinations/live/live_periodic.php' );
$state = array(); //backupbuddy_mainwp_live_periodic::get_stats();
include( '_stats.php' ); // Recalculate stats. Populates $stats var.
//$stats = array(); // waiting $stats data from child site

// First backup complete alert. Not output if older than 48 hours. Output but hidden if =0. Output and visible is non-zero > 48hrs.
if ( 0 == $state['stats']['first_completion'] ) { // Output but hidden if not finished.
	$completion_css = 'display: none;';
} elseif ( ( time() - $state['stats']['first_completion'] ) < 60*60*48 ) { // < 48hrs.
	$completion_css = '';
}
if ( isset( $completion_css ) ) {
	pb_mainwp_backupbuddy::disalert( 'live_first_completion_done', '<h3>' . __( 'Your first Live Backup is complete!', 'it-l10n-mainwp-backupbuddy' ) . '</h3><p class="description" style="max-width: 700px; display: inline-block;">' . __( 'Your first BackupBuddy Stash Live backup process has completed and your first Snapshot will arrive in your Stash storage shortly. We\'ll automatically backup any changes you make to your site from here on out and regularly create Snapshots in time of your data. Your site is well on its way to a secure future in the safe hands of BackupBuddy Stash Live.', 'it-l10n-mainwp-backupbuddy' ) . '</p>', $error = false, $completion_css );
}


if ( '' != pb_mainwp_backupbuddy::_GET( 'live_action' ) ) {
	pb_mainwp_backupbuddy::verify_nonce();

	$action = pb_mainwp_backupbuddy::_GET( 'live_action' );

        if (in_array($action, array('clear_log', 'resume_continuous', 'pause_continuous', 'resume_periodic', 'pause_periodic', 'create_snapshot'))) {

                $post_data = array(
                    'mwp_action' => 'live_action',
                    'live_action' => $action
                );

                global $mainWP_BackupBuddy_Extension_Activator;
                $information = apply_filters( 'mainwp_fetchurlauthed', $mainWP_BackupBuddy_Extension_Activator->get_child_file(), $mainWP_BackupBuddy_Extension_Activator->get_child_key(), $site_id, 'backup_buddy', $post_data );
                $error = $message = '';
                if (is_array($information)) {
                    if (isset($information['error'])) {
                            $error = $information['error'];
                    } else if (isset($information['ok'])) {
                            $error = $information['_error'];
                            $message = $information['_message'];
                    } else {
                            $error = 'Undefined error.';
                    }
                } else {
                    $error = 'Undefined error.';
                }

                if (!empty($error)) {
                    pb_mainwp_backupbuddy::alert( $error );
                }
                if (!empty($message)) {
                    pb_mainwp_backupbuddy::alert( $message );
                }
        }
}


// RUN ACTIONS FROM BUTTON PRESS.
// disabled
if ( false && '' != pb_mainwp_backupbuddy::_GET( 'live_action' ) ) {
	pb_mainwp_backupbuddy::verify_nonce();
	$action = pb_mainwp_backupbuddy::_GET( 'live_action' );
	if ( 'clear_log' == $action ) {

		$sumLogFile = mainwp_backupbuddy_core::getLogDirectory() . 'status-live_periodic_' . pb_mainwp_backupbuddy::$options['log_serial'] . '.txt';
		@unlink( $sumLogFile );
		if ( file_exists( $sumLogFile ) ) {
			pb_mainwp_backupbuddy::alert( 'Error #893489322: Unable to clear log file `' . $sumLogFile . '`. Check permissions or manually delete.' );
		} else {
			pb_mainwp_backupbuddy::alert( 'Log file cleared.' );
		}

	} elseif ( 'create_snapshot' == $action ) { // < 100% backed up _OR_ ( we are on a step other than daily_init and the last_activity is more recent than the php runtime )
		/*
		if ( '' != pb_mainwp_backupbuddy::_GET( 'get_snapshot_status' ) ) { // Check existing snapshot status.
			$response = array(
				'success' => false,
				'snapshot' => pb_mainwp_backupbuddy::_GET( 'get_snapshot_status' ),
				'note' => 'This is a dummy array populated in _manage.php for triggering status check manually.',
			);
		}
		*/

		if ( true === mainwp_backupbuddy_api::runLiveSnapshot() ) {
			pb_mainwp_backupbuddy::alert( '<h3>' . __( 'Verifying everything is up to date before Snapshot', 'it-l10n-mainwp-backupbuddy' ) . '</h3><p class="description" style="max-width: 700px; display: inline-block;">' . __( 'Please wait while we verify your backup is completely up to date before we create the Snapshot. This may take a few minutes...', 'it-l10n-mainwp-backupbuddy' ) . '</p>', false, '', 'backupbuddy_live_snapshot_verify_uptodate' );
			require( '_manual_snapshot.php' );
		}

	} elseif ( 'resume_periodic_step' == $action ) {

		pb_mainwp_backupbuddy::alert( 'Launching BackupBuddy Stash Live Periodic Process to run now where it left off.' );
		backupbuddy_mainwp_live_periodic::run_periodic_process();

	} elseif ( 'uncache_credentials' == $action ) {

		require_once( pb_mainwp_backupbuddy::plugin_path() . '/destinations/live/init.php' );
		delete_transient( pb_mainwp_backupbuddy_destination_live::LIVE_ACTION_TRANSIENT_NAME );
		pb_mainwp_backupbuddy::alert( 'Deleted cached Live credentials.' );

	} elseif ( 'restart_periodic' == $action ) {


		pb_mainwp_backupbuddy::$options['remote_destinations'][$destination_id]['pause_periodic'] = '0';
		$destination = pb_mainwp_backupbuddy::$options['remote_destinations'][$destination_id]; // Update local var.
		pb_mainwp_backupbuddy::save();

		backupbuddy_mainwp_live::queue_step( 'daily_init', $args = array() );

		pb_mainwp_backupbuddy::alert( __( 'Enabled Live Files Backup and Restarted Periodic Process (only running if between steps or timed out).', 'it-l10n-mainwp-backupbuddy' ) );

	} elseif ( 'restart_periodic_force' == $action ) {


		pb_mainwp_backupbuddy::$options['remote_destinations'][$destination_id]['pause_periodic'] = '0';
		$destination = pb_mainwp_backupbuddy::$options['remote_destinations'][$destination_id]; // Update local var.
		pb_mainwp_backupbuddy::save();

		backupbuddy_mainwp_live::queue_step( 'daily_init', $args = array(), $skip_run_now = false, $force_run_now  = true );

		pb_mainwp_backupbuddy::alert( __( 'Enabled Live Files Backup and Restarted Periodic Process (forced to run now).', 'it-l10n-mainwp-backupbuddy' ) );

	} elseif( 'restart_at_step' == $action ) {

		$step = pb_mainwp_backupbuddy::_POST( 'live_step' );
		pb_mainwp_backupbuddy::alert( 'Reset Periodic Process to run at step `' . $step . '` (FORCED). This may take a few minutes for the current process to complete.' );

		backupbuddy_mainwp_live::queue_step( $step, $args = array(), $skip_run_now = false, $force_run_now  = true );

	} elseif ( 'view_files' == $action ) {

		require( '_viewfiles.php' );
		echo '<br><hr><br><br>';

	/*} elseif ( 'view_stash_files' == $action ) {

		require( '_viewstashfiles.php' );
		echo '<br><hr><br><br>';
		*/
	} elseif ( 'view_files_tables' == $action ) {

		require( '_viewfiles_tables.php' );
		echo '<br><hr><br><br>';

	} elseif ( 'view_tables' == $action ) {

		require( '_viewtables.php' );
		echo '<br><hr><br><br>';

	} elseif ( 'view_catalog_raw' == $action ) {

		echo '<h3>Local Catalog File Signatures (raw):</h3>';
		$catalog = backupbuddy_mainwp_live_periodic::get_catalog();
		echo '<textarea readonly="readonly" style="width: 100%;" wrap="off" cols="65" rows="20">' . print_r( $catalog, true ) . '</textarea>';
		echo '<br><br><br>';

	} elseif ( 'view_signatures_raw' == $action ) {

		echo '<h3>Local Catalog File Signatures (raw - contents and file count may fluctuate if periodic files process is not pasued):</h3>';
		$catalog = backupbuddy_mainwp_live_periodic::get_catalog();
		echo '<textarea readonly="readonly" style="width: 100%;" wrap="off" cols="65" rows="20">' . print_r( $catalog, true ) . '</textarea>';
		echo '<br><br><br>';

	} elseif ( 'troubleshooting' == $action ) {

		echo '<h3>Stash Live Troubleshooting:</h3>';

//		require( '_troubleshooting.php' );
//
//		mainwp_backupbuddy_live_troubleshooting::run();
//		$results = mainwp_backupbuddy_live_troubleshooting::get_raw_results();
//
//		$download_button = '<div style="text-align: center; margin: 15px;">
//			<button class="button button-primary" onClick="mainwp_backupbuddy_save_textarea_as_file(\'#backupbuddy_live_troubleshooting_results\', \'stash_live_troubleshooting\' );" style="margin-left: auto; margin-right: auto; display: inherit; font-size: 0.9em;">Download Troubleshooting Log (.txt)</button>
//		</div>';
//		echo $download_button;
//		echo '<textarea readonly="readonly" style="width: 100%;" wrap="off" cols="65" rows="30" id="backupbuddy_live_troubleshooting_results">' . print_r( $results, true ) . '</textarea>';
//		echo $download_button;

		echo '<br><br><br>';


	} elseif ( 'last_snapshot_details' == $action ) {
		if ( '' == $state['stats']['last_remote_snapshot_id'] ) {
			pb_mainwp_backupbuddy::alert( 'No Snapshot creations have been requested yet.' );
		} else {
			$destination_settings = backupbuddy_mainwp_live_periodic::get_destination_settings();
			$additionalParams = array(
				'snapshot' => $state['stats']['last_remote_snapshot_id'],
			);

			echo '<h3>Last Snapshot Details</h3>';
			echo '<b>Status as reported from server as of just now:</b><br>';
			$response = pb_mainwp_backupbuddy_destination_live::stashAPI( $destination_settings, 'live-snapshot-status', $additionalParams );
			if ( ! is_array( $response ) ) {
				pb_mainwp_backupbuddy::alert( 'Error #3497943: Unable to get Live snapshot status. Details: `' . $response . '`.' );
			} else {
				echo '<textarea readonly="readonly" style="width: 100%;" wrap="off" cols="65" rows="15">' . print_r( $response, true ) . '</textarea>';
				echo '<br><br>';
			}

			echo '<b>Server response to request to initiate ( ' . pb_mainwp_backupbuddy::$format->date( pb_mainwp_backupbuddy::$format->localize_time( $state['stats']['last_remote_snapshot_response_time'] ) ) . '; ' . pb_mainwp_backupbuddy::$format->time_ago( $state['stats']['last_remote_snapshot_response_time'] ) . ' ago):</b><br>';
			echo '<textarea readonly="readonly" style="width: 100%;" wrap="off" cols="65" rows="15">' . print_r( $state['stats']['last_remote_snapshot_response'], true ) . '</textarea>';
			echo '<br><br><br>';
		}
	} elseif ( 'view_tables_raw' == $action ) {

		echo '<h3>Local Catalog Tables (raw):</h3>';
		$tables = backupbuddy_mainwp_live_periodic::get_tables();
		echo '<textarea readonly="readonly" style="width: 100%;" wrap="off" cols="65" rows="20">' . print_r( $tables, true ) . '</textarea>';
		echo '<br><br><br>';

	} elseif ( 'view_signatures' == $action ) {

		echo '<h3>Local Files Catalog (contents and file count may fluctuate if periodic files process is not pasued):</h3>';
		$siteSize = 0;
		$catalog = backupbuddy_mainwp_live_periodic::get_catalog();
		$catalogTable = array();
		foreach( $catalog as $filename => $signature ) {
			if ( 0 != $signature['b'] ) {
				$sent = $signature['b'];
			} else {
				$sent = __( 'Pending', 'it-l10n-mainwp-backupbuddy' );
			}
			if ( isset( $signature['d'] ) && ( true === $signature['d'] ) ) {
				$delete = __( 'Yes', 'it-l10n-mainwp-backupbuddy' );
			} else {
				$delete = __( 'No', 'it-l10n-mainwp-backupbuddy' );
				$siteSize += $signature['s']; // File not marked for deletion.
			}
			if ( '' == $signature['h'] ) {
				$hash = 'n/a';
			} else {
				$hash = $signature['h'];
			}
			if ( 0 == $signature['m'] ) {
				$modified = '<span class="description">Pending...</span>';
			} else {
				$modified = $signature['m'];
			}
			if ( 0 == $signature['v'] ) {
				$audited = '<span class="description">Pending...</span>';
			} else {
				$audited = $signature['v'];
			}
			$catalogTable[ $filename ] = array(
				$filename,
				(string)$signature['s'],
				(string)$signature['a'],
				$modified,
				$sent,
				$audited,
				(string)$signature['t'],
				$delete,
				$hash,
			);
		}
		unset( $catalog );

		$catalogInfo = 'Total catalog site size: `' . pb_mainwp_backupbuddy::$format->file_size( $siteSize ) . '`. Total files in catalog: `' . count( $catalogTable ) . '`. Catalog file size: `' . pb_mainwp_backupbuddy::$format->file_size( filesize( mainwp_backupbuddy_core::getLogDirectory() . 'live/catalog-' . pb_mainwp_backupbuddy::$options['log_serial'] . '.txt' ) ) . '`.';
		echo $catalogInfo;

		pb_mainwp_backupbuddy::$ui->list_table(
			$catalogTable, // Array of cron items set in code section above.
			array(
				'live_action'					=>	pb_mainwp_backupbuddy::page_url() . '#pb_backupbuddy_getting_started_tab_tools',
				'columns'					=>	array(
													__( 'Files', 'it-l10n-mainwp-backupbuddy' ),
													__( 'Size', 'it-l10n-mainwp-backupbuddy' ),
													__( 'Added', 'it-l10n-mainwp-backupbuddy' ),
													__( 'Modified', 'it-l10n-mainwp-backupbuddy' ),
													__( 'Sent', 'it-l10n-mainwp-backupbuddy' ),
													__( 'Audited', 'it-l10n-mainwp-backupbuddy' ),
													__( 'Send Tries', 'it-l10n-mainwp-backupbuddy' ),
													__( 'Delete?', 'it-l10n-mainwp-backupbuddy' ),
													__( 'Hash', 'it-l10n-mainwp-backupbuddy' ),
												),
				'css'						=>		'width: 100%;',
			)
		); // end list_table.
		unset( $catalogTable );

		echo $catalogInfo;
		echo '<br><br><br>';

	} elseif ( 'reset_send_attempts' == $action ) {

		if ( false === backupbuddy_mainwp_live_periodic::reset_send_attempts() ) {
			pb_mainwp_backupbuddy::alert( 'Error attempting to reset send attempt counts. The catalog may be busy. Try again in a moment or see the Status Log for details.' );
		} else {
			pb_mainwp_backupbuddy::alert( 'Success resetting send attempt counts back to zero for all files and global recent send fail counter.' );
		}


	} elseif ( 'reset_last_activity' == $action ) {
		pb_mainwp_backupbuddy::alert( 'Reset last activity timestamp.' );
		backupbuddy_mainwp_live_periodic::reset_last_activity();
	} elseif ( 'reset_file_audit_times' == $action ) {
		pb_mainwp_backupbuddy::alert( 'Reset file audit timestamps.' );
		backupbuddy_mainwp_live_periodic::reset_file_audit_times();
	} elseif ( 'reset_first_completion' == $action ) {
		pb_mainwp_backupbuddy::alert( 'Reset first completion timestamp.' );
		backupbuddy_mainwp_live_periodic::reset_first_completion();
	} elseif ( 'reset_last_remote_snapshot' == $action ) {
		pb_mainwp_backupbuddy::alert( 'Reset last remote snapshot timestamp.' );
		backupbuddy_mainwp_live_periodic::reset_last_remote_snapshot();
	} elseif ( 'view_state' == $action ) {

		echo '<h3>State Data:</h3>';
		echo '<textarea readonly="readonly" style="width: 100%;" wrap="off" cols="65" rows="20">' . print_r( $state, true ) . '</textarea>';
		echo '<br><br><br>';

	} elseif ( 'view_log' == $action ) {

		$sumLogFile = mainwp_backupbuddy_core::getLogDirectory() . 'status-live_periodic_' . pb_mainwp_backupbuddy::$options['log_serial'] . '.txt';
		echo '<div style="padding: 4px;">';
			echo '<b>Status Log</b> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp; File size: ' . pb_mainwp_backupbuddy::$format->file_size( @filesize( $sumLogFile ) ) . ' ';
			?>
			<a href="<?php echo pb_mainwp_backupbuddy::nonce_url( $admin_url . '&live_action=clear_log' ); ?>" class="button button-secondary button-tertiary" style="margin-left: 11px; vertical-align: 1px;">Clear Status Log</a>
		</div>
		<script>
			jQuery(document).ready( function(){
				jQuery('#backupbuddy_live_log' ).scrollTop( jQuery('#backupbuddy_live_log')[0].scrollHeight );
			});
		</script>
		<?php
		echo '<textarea readonly="readonly" style="width: 100%;" wrap="off" cols="65" rows="20" id="backupbuddy_live_log">';
		if ( ! file_exists( $sumLogFile ) ) {
			echo __( 'Nothing has been logged.', 'it-l10n-mainwp-backupbuddy' );
		} else {
			$mtime = @filemtime( $sumLogFile );
			$time_ago = pb_mainwp_backupbuddy::$format->time_ago( $mtime );
			$lines = file_get_contents( $sumLogFile );
			if ( false === $lines ) {
				echo 'Error #49834839: Unable to read log file `' . $sumLogFile . '`.';
			} else {
				$lines = explode( "\n", $lines );
				foreach( (array)$lines as $rawline ) {
					$line = json_decode( $rawline, true );
					//print_r( $line );
					if ( is_array( $line ) ) {
						$u = '';
						if ( isset( $line['u'] ) ) { // As off v4.2.15.6. TODO: Remove this in a couple of versions once old logs without this will have cycled out.
							$u = '.' . $line['u'];
						}
						echo pb_mainwp_backupbuddy::$format->date( $line['time'], 'G:i:s' ) . $u . "\t\t";
						echo $line['run'] . "sec\t";
						echo $line['mem'] . "MB\t";
						echo $line['event'] . "\t";
						echo $line['data'] . "\n";
					} else {
						echo $rawline . "\n";
					}
				}
			}
		}
		?></textarea>
		<div style="display: inline-block; margin-left: 8px; margin-top: 5px;"><span class="description">Current Time: <?php echo pb_mainwp_backupbuddy::$format->date( pb_mainwp_backupbuddy::$format->localize_time( microtime( true ) ), 'G:i:s' ); ?>. &nbsp; &nbsp; &nbsp; Modified: <?php echo $time_ago; ?> ago.</span></div>
		<br><br>
		<?php
	} elseif ( 'delete_catalog' == $action ) {

		$catalogFile = mainwp_backupbuddy_core::getLogDirectory() . 'live/catalog-' . pb_mainwp_backupbuddy::$options['log_serial'] . '.txt';
		@unlink( $catalogFile );
		sleep( 1 );
		@unlink( $catalogFile );
		sleep( 1 );
		@unlink( $catalogFile );

		if ( file_exists( $catalogFile ) ) {
			pb_mainwp_backupbuddy::alert( 'Error #3927273: Unable to delete catalog file `' . $catalogFile . '`. Check permissions or manually delete.' );
		} else {
			pb_mainwp_backupbuddy::alert( 'Catalog deleted.' );
		}

		$stateFile = mainwp_backupbuddy_core::getLogDirectory() . 'live/state-' . pb_mainwp_backupbuddy::$options['log_serial'] . '.txt';
		@unlink( $stateFile );
		sleep( 1 );
		@unlink( $stateFile );
		sleep( 1 );
		@unlink( $stateFile );

		if ( file_exists( $stateFile ) ) {
			pb_mainwp_backupbuddy::alert( 'Error #434554: Unable to delete state file `' . $stateFile . '`. Check permissions or manually delete.' );
		} else {
			pb_mainwp_backupbuddy::alert( 'State file deleted.' );
		}

	} elseif ( 'pause_periodic' == $action ) {
		mainwp_backupbuddy_api::setLiveStatus( $pause_continuous = '', $pause_periodic = true );
		$destination = pb_mainwp_backupbuddy::$options['remote_destinations'][$destination_id]; // Update local var.
		pb_mainwp_backupbuddy::disalert( '', __( 'Live File Backup paused. It may take a moment for current processes to finish.', 'it-l10n-mainwp-backupbuddy' ) );
		include( '_stats.php' ); // Recalculate stats.
	} elseif ( 'resume_periodic' == $action ) {
		$launchNowText = ' ' . __( 'Unpaused but not running now.', 'it-l10n-mainwp-backupbuddy' );
		$start_run = false;
		if ( '1' != pb_mainwp_backupbuddy::_GET( 'skip_run_live_now' ) ) {
			$launchNowText = '';
			$start_run = true;
		}

		mainwp_backupbuddy_api::setLiveStatus( $pause_continuous = '', $pause_periodic = false, $start_run );
		pb_mainwp_backupbuddy::disalert( '', __( 'Live File Backup has resumed.', 'it-l10n-mainwp-backupbuddy' ) . $launchNowText );

		include( '_stats.php' ); // Recalculate stats.
	} elseif ( 'pause_continuous' == $action ) {
		mainwp_backupbuddy_api::setLiveStatus( $pause_continuous = true, $pause_periodic = '' );
		$destination = pb_mainwp_backupbuddy::$options['remote_destinations'][$destination_id]; // Update local var.
		include( '_stats.php' ); // Recalculate stats.
		pb_mainwp_backupbuddy::disalert( '', __( 'Live Database Backup paused.', 'it-l10n-mainwp-backupbuddy' ) );
	} elseif ( 'resume_continuous' == $action ) {
		mainwp_backupbuddy_api::setLiveStatus( $pause_continuous = false, $pause_periodic = '' );
		$destination = pb_mainwp_backupbuddy::$options['remote_destinations'][$destination_id]; // Update local var.
		include( '_stats.php' ); // Recalculate stats.
		pb_mainwp_backupbuddy::disalert( '', __( 'Live Database Backup resumed.', 'it-l10n-mainwp-backupbuddy' ) );
	} elseif ( 'view_raw_settings' == $action ) {
		echo '<h3>Raw Settings:</h3>';
		echo '<textarea readonly="readonly" style="width: 100%;" wrap="off" cols="65" rows="20">' . print_r( pb_mainwp_backupbuddy::$options['remote_destinations'][$destination_id], true ) . '</textarea>';
		echo '<br><br><br>';
	} elseif ( 'view_stats' == $action ) {
		echo '<h3>Raw Stats:</h3>';
		echo '<textarea readonly="readonly" style="width: 100%;" wrap="off" cols="65" rows="20">' . print_r( $stats, true ) . '</textarea>';
		echo '<br><br><br>';
	}

} // end if action.



// Backup types' Status.
$database_status = '<span class="backpbuddy-live-stats-enabled">' .__( 'Enabled', 'it-l10n-mainwp-backupbuddy' ) . '</span>';
$database_status_row = '';
if ( '1' == $destination['pause_continuous'] ) {
	$database_status = '<span class="backpbuddy-live-stats-paused">' . __( 'Paused', 'it-l10n-mainwp-backupbuddy' ) . '</span>';
	$database_status_row = 'backupbuddy-live-stats-paused-row';
}


$files_status = '<span class="backpbuddy-live-stats-enabled">' . __( 'Enabled', 'it-l10n-mainwp-backupbuddy' ) . '</span>';
$files_status_row = '';
if ( '1' == $destination['pause_periodic'] ) {
	$files_status = '<span class="backpbuddy-live-stats-paused">' . __( 'Paused', 'it-l10n-mainwp-backupbuddy' ) . '</span>';
	$files_status_row = 'backupbuddy-live-stats-paused-row';
}


// Database total size.
if ( 0 == $state['stats']['files_total_size'] ) {
	$totalDatabaseSizeDisplay = '<span class="description">Calculating...</span>';
} else {
	$totalDatabaseSizeDisplay = pb_mainwp_backupbuddy::$format->file_size( $state['stats']['tables_total_size'] );
}

// Calculate tables pending deletion.
$tablesPendingDelete = '';
if ( 0 != $state['stats']['tables_pending_delete'] ) {
	$tablesPendingDelete = ', ' . $state['stats']['tables_pending_delete'] . ' ' . __( 'pending deletion', 'it-l10n-mainwp-backupbuddy' );
}

// Database tables sent.
$tablesSent = ( $state['stats']['tables_total_count'] - $state['stats']['tables_pending_send'] );

// Tables percent sent (by count).
if ( $state['stats']['tables_total_count'] > 0 ) {
	$tablesSentPercent = ceil( ( $tablesSent / $state['stats']['tables_total_count'] ) * 100 );
	if ( ( 100 == $tablesSentPercent ) && ( $tablesSent < $state['stats']['tables_total_count'] ) ) { // If we were to display 100% sent but files still remain, convert to 99.9% to help indicate the gap.
		$tablesSentPercent = 99.9;
	}
} else {
	$tablesSentPercent = 0;
}

// Files total size.
if ( 0 == $state['stats']['files_total_size'] ) {
	$totalFilesSizeDisplay = '<span class="description">Calculating...</span>';
} else {
	$totalFilesSizeDisplay = '<span class="description">' . pb_mainwp_backupbuddy::$format->file_size( $state['stats']['files_total_size'] ) . '</span>';
}

// Files sent.
$filesSent = ( $state['stats']['files_total_count'] - $state['stats']['files_pending_send'] );

// Files percent sent (by count).
if ( $state['stats']['files_total_count'] > 0 ) {
	$filesSentPercent = ceil( ( $filesSent / $state['stats']['files_total_count'] ) * 100 );
	if ( ( 100 == $filesSentPercent ) && ( $filesSent < $state['stats']['files_total_count'] ) ) { // If we were to display 100% sent but files still remain, convert to 99.9% to help indicate the gap.
		$filesSentPercent = 99.9;
	}
} else {
	$filesSentPercent = 0;
}

// Calculate files pending deletion.
$filesPendingDelete = '';
if ( 0 != $state['stats']['files_pending_delete'] ) {
	$filePendingDelete = ', ' . $state['stats']['files_pending_delete'] . ' ' . __( 'pending deletion', 'it-l10n-mainwp-backupbuddy' );
}

?>


<script>

	var backupbuddy_live_snapshot_status_pretty = '';
	var backupbuddy_live_snapshot_step = 1;
	function mainwp_backupbuddy_live_stats( stats ) {
		if ( stats && stats.error_alert && stats.error_alert.length > 0 ) {
			jQuery( '.pb_backupbuddy_alert[rel="stash_live_error_alert"]' ).html( '<h3><?php _e( 'Oops, something may have gone wrong (most errors try to fix themselves after a bit of time)', 'it-l10n-mainwp-backupbuddy' ); ?>:</h3><br>' + stats.error_alert ).show();
		} else {
			jQuery( '.pb_backupbuddy_alert[rel="stash_live_error_alert"]' ).text( '' ).hide();
		}

		// Display progress bar if needed. When not on daily_init AND ( during first completion OR during manual snapshot )
		if ( ( ( 'daily_init' != stats.current_function ) && ( '0' == stats.first_completion || 2 === backupbuddy_live_snapshot_step ) ) || ( ( 'undefined' != typeof window.backupbuddy_live_snapshot_request_time ) && ( '' != window.backupbuddy_live_snapshot_request_time ) ) ) {
			//jQuery( '.pb_backupbuddy_alert' ).hide();
			//jQuery( '.pb_backupbuddy_alert[rel="live_first_completion"]' ).show();
			jQuery( '.backupbuddy-live-snapshot-progress-bar' ).show();

			// if we're on db step, update UI
			if ( ( 'database_snapshot' == stats.current_function ) || ( 'send_pending_db_snapshots' == stats.current_function ) || ( 'process_table_deletions' == stats.current_function ) ) {
				jQuery( '.bb_progress-step-completed' ).removeClass( 'bb_progress-step-completed' ); // Reset.
				jQuery( '.bb_progress-step-database' ).addClass('bb_progress-step-active'); // DB active.
			} else if ( ( 'update_files_list' == stats.current_function ) || ( 'update_files_signatures' == stats.current_function ) || ( 'process_file_deletions' == stats.current_function ) || ( 'send_pending_files' == stats.current_function ) || ( 'audit_remote_files' == stats.current_function ) ) { // if we're on files step, update UI
				jQuery( '.bb_progress-step-database' ).removeClass('bb_progress-step-active').addClass( 'bb_progress-step-completed' ); // DB done.
				jQuery( '.bb_progress-step-files' ).addClass('bb_progress-step-active'); // FILES active.
			} else if ( ( 'run_remote_snapshot' == stats.current_function ) || ( stats.last_remote_snapshot_response_time > window.backupbuddy_live_snapshot_request_time ) ) { // or last snapshot trigger time is since this snapshot began. in case we miss the run_remote_snapshot step.
				jQuery( '.bb_progress-step-database' ).removeClass('bb_progress-step-active').addClass( 'bb_progress-step-completed' ); // DB done.
				jQuery( '.bb_progress-step-files' ).removeClass('bb_progress-step-active').addClass( 'bb_progress-step-completed' ); // FILES done.
				jQuery( '.bb_progress-step-snapshot' ).addClass('bb_progress-step-active' ); // SNAPSHOT active.
			}

			// While 'SnapShot' portion of progress bar is active, replace current function details to reflect this.
			if ( jQuery( '.bb_progress-step-snapshot' ).hasClass( 'bb_progress-step-active' ) ) {
				stats.current_function_pretty = '<?php _e( 'Building Snapshot', 'it-l10n-mainwp-backupbuddy' ); ?>' + backupbuddy_live_snapshot_status_pretty; // backupbuddy_live_snapshot_status_pretty contains snapshot details returned from Stash server during snapshot building.
			}
		} else {
			// If first backup and on daily_init, reset status bar in case things got reset.
			if ( ( '0' == stats.first_completion ) && ( 'daily_init' == stats.current_function ) ) {
				jQuery( '.bb_progress-step-database' ).removeClass('bb_progress-step-active').removeClass( 'bb_progress-step-completed' );
				jQuery( '.bb_progress-step-files' ).removeClass('bb_progress-step-active').removeClass( 'bb_progress-step-completed' );
				jQuery( '.bb_progress-step-snapshot' ).removeClass('bb_progress-step-active').removeClass( 'bb_progress-step-completed' );
			}
		}


		// Is manual snapshot pending?
		if ( 'undefined' != typeof window.backupbuddy_live_snapshot_request_time ) {

			// On remote snapshot function?
			if ( ( 1 == backupbuddy_live_snapshot_step ) && ( ( 'run_remote_snapshot' == stats.current_function ) || ( stats.last_remote_snapshot_response_time > window.backupbuddy_live_snapshot_request_time ) ) ) {
				jQuery( '.pb_backupbuddy_alert' ).hide();

				jQuery( '.bb_progress-step-files' ).removeClass('bb_progress-step-active').addClass( 'bb_progress-step-completed' );
				jQuery( '.bb_progress-step-snapshot' ).addClass('bb_progress-step-active');
				backupbuddy_live_snapshot_step = 2;
			}
			if ( ( 2 == backupbuddy_live_snapshot_step ) && ( stats.last_remote_snapshot_response_time > window.backupbuddy_live_snapshot_request_time ) && ( 'object' == typeof stats.last_remote_snapshot_response ) ) {
				<?php if ( pb_mainwp_backupbuddy::$options['log_level'] == '3' ) { // Full logging enabled. ?>
					console.log( 'Last snapshot response:' );
					console.dir( stats.last_remote_snapshot_response );
				<?php } ?>
				setTimeout( 'mainwp_backupbuddy_live_snapshot_status_check( "' + stats.last_remote_snapshot_response.snapshot + '" )', 3000 );

				jQuery( '.bb_progress-step-files' ).removeClass('bb_progress-step-active').addClass( 'bb_progress-step-completed' );
				backupbuddy_live_snapshot_step = 3;
			}
		}

		// If new snapshot has begun since loading the page (and it's automatic triggered), then start watching for the status to update.
		stash_iframe = jQuery( '#backupbuddy_live-stash_iframe' );
		if ( ( ( parseInt( stash_iframe.attr( 'data-refreshed' ) ) < ( stats.last_remote_snapshot ) ) ) && ( 'automatic' == stats.last_remote_snapshot_trigger ) ) {
			setTimeout( 'mainwp_backupbuddy_live_snapshot_status_check( "' + stats.last_remote_snapshot_response.snapshot + '" )', 3000 );
		}

		// Has there been a snapshot since the Stash frame was last refreshed?
		/*
		stash_iframe = jQuery( '#backupbuddy_live-stash_iframe' );
		if ( ( parseInt( stash_iframe.attr( 'data-refreshed' ) ) < ( stats.last_remote_snapshot ) ) ) {
			refresh_delay_min = (60*15);
			refresh_time = stats.current_time + refresh_delay_min;

			// Refresh in `refresh_delay_min` minutes.
			setTimeout(
				function(refresh_time){
					jQuery( '#backupbuddy_live-stash_iframe' ).attr( 'src', jQuery( '#backupbuddy_live-stash_iframe' ).attr( 'src' ) );
					jQuery( '#backupbuddy_live-stash_iframe' ).attr( 'data-refreshed', refresh_time ); // Update refresh timestamp.
				},
				( refresh_delay_min*1000 ),
				refresh_time
			);
		}
		*/

		// This grabs the template, and inserts HTML ( with appropriate data ) into the DOM
		_.templateSettings.variable    = 'stats';
		_.templateSettings.evaluate    = /<#([\s\S]+?)#>/g;
		_.templateSettings.interpolate = /\{\{\{([\s\S]+?)\}\}\}/g;
		_.templateSettings.escape      = /\{\{([^\}]+?)\}\}(?!\})/g;
		var template = _.template( jQuery( '#backupbuddy-live-stats-tmpl' ).html() );
		jQuery( '.backupbuddy-live-stats-container' ).html( template(stats) );


		// First backup completion.
		if ( stats.first_completion > 0 ) {
			if ( jQuery( '.pb_backupbuddy_alert[rel="live_first_completion"]' ).is( ':visible' ) ) {
				jQuery( '.pb_backupbuddy_alert[rel="live_first_completion_done"]' ).show();
			}
			jQuery( '.pb_backupbuddy_alert[rel="live_first_completion"]' ).remove();
		}

	} // End mainwp_backupbuddy_live_stats().



	var snapshot_infected_warning = false; // Set true if malware is found to warn on download attempt.
	function mainwp_backupbuddy_live_snapshot_status_check( snapshot_id ) {
		if ( '' == snapshot_id ) {
			return false;
		}
		loadingIndicator.show();

		console.log( 'live_snapshot_status_check' );

		jQuery.ajax({

			url:	snapshotStatusURL,
			type:	'post',
			data:	{ snapshot_id: snapshot_id },
			context: document.body,

			success: function( data ) {
				if ( 0 != loadingIndicator.length ) {
					loadingIndicator.hide();
				}
				jQuery( '.pb_backupbuddy_alert' ).hide();
				jQuery( '.pb_backupbuddy_alert[rel="live_first_completion"]' ).show();

				try {
					snapshotStatus = jQuery.parseJSON( data );
				} catch(e) { // NOT json or some error.
					alert( 'Unable to get snapshot status. Details here and in console: `' + data + '`.' );
					console.log( 'Live Stats Response (ERROR #48943745):' );
					console.dir( data );
					return false;
				}

				<?php if ( pb_mainwp_backupbuddy::$options['log_level'] == '3' ) { // Full logging enabled. ?>
					console.log( 'BackupBuddy Snapshot Status:' );
					console.dir( snapshotStatus );
				<?php } ?>

				if ( '1' == snapshotStatus.complete ) { // Snapshot FINISHED.
					window.backupbuddy_live_snapshot_request_time = ''; // Unset.

					// Error encountered.
					if ( 'error' == snapshotStatus.status ) {
						alert( 'An unexpected error was encountered while creating your Snapshot: `' + snapshotStatus.message + '`. Check your Snapshot listing below to check whether the Snapshot was created or not.' );
					}

					// Snapshot info is missing from response.
					if ( 'undefined' == typeof snapshotStatus.snapshot ) {
						jQuery( '.backupbuddy-live-snapshot-progress-bar' ).hide(); // No download info available so hide bar.

						// Refresh Stash iFrame to show new file IF it happened to work...
						jQuery( '.backupbuddy_live_iframe_load' ).show();
						jQuery( '#backupbuddy_live-stash_iframe' ).attr( 'src', jQuery( '#backupbuddy_live-stash_iframe' ).attr( 'src' ) );
						jQuery( '#backupbuddy_live-stash_iframe' ).attr( 'data-refreshed', snapshotStatus.current_time ); // Update refresh timestamp.

						return false;
					}

					jQuery( '.bb_progress-step-snapshot, .bb_progress-step-files' ).removeClass('bb_progress-step-active').addClass( 'bb_progress-step-completed' );
					jQuery( '.bb_progress-step-finished' ).addClass('bb_progress-step-completed');

					jQuery( '#backupbuddy_live_snapshot-working' ).hide();
					jQuery( '#backupbuddy_live_snapshot-success' ).show();

					// Refresh Stash iFrame to show new file.
					jQuery( '.backupbuddy_live_iframe_load' ).show();
					jQuery( '#backupbuddy_live-stash_iframe' ).attr( 'src', jQuery( '#backupbuddy_live-stash_iframe' ).attr( 'src' ) );
					jQuery( '#backupbuddy_live-stash_iframe' ).attr( 'data-refreshed', snapshotStatus.current_time ); // Update refresh timestamp.

					// Malware scanning.
					jQuery.each( snapshotStatus.snapshot.malware.stats, function(index,value){
						jQuery( '#backupbuddy_live_snapshot-success-malware .backupbuddy_live_malware_result[data-result="' + index + '"]' ).text( value );
					});

					if ( jQuery( snapshotStatus.snapshot.malware.files ).size() > 0 ) {
						snapshot_infected_warning = true;
						jQuery( '.backupbuddy_live_malware_result[data-result="infected_files"]' ).css( 'color', 'red' );
						jQuery( '#backupbuddy_live_snapshot-success-malware-files' ).show();
						jQuery.each( snapshotStatus.snapshot.malware.files, function(index,value){
							jQuery( '#backupbuddy_live_snapshot-success-malware-files ul' ).append( '<li>' + index + '<ul><li style="list-style-type: circle;">' + value + '</li></ul></li>' );
						});
					} else {
						snapshot_infected_warning = false;
					}

					jQuery( '#backupbuddy_live_snapshot-success-duration' ).text( snapshotStatus.duration ).attr( 'title', 'Start: `' + snapshotStatus.timestamp_start + '`. Finish: `' + snapshotStatus.timestamp_finish + '`.' );;

					if ( true === snapshotStatus.snapshot.stash_copy ) {
						jQuery( '#backupbuddy_live_snapshot-stashed' ).show();
					}

					if ( 'undefined' != typeof snapshotStatus.snapshot.zips.full ) {
						jQuery( '#backupbuddy_live_snapshot-success-backup_full' ).show().find('a').attr( 'href', snapshotStatus.snapshot.zips.full );
					}
					if ( 'undefined' != typeof snapshotStatus.snapshot.zips.db ) {
						jQuery( '#backupbuddy_live_snapshot-success-backup_db' ).show().find('a').attr( 'href', snapshotStatus.snapshot.zips.db );
					}
					if ( 'undefined' != typeof snapshotStatus.snapshot.zips.plugins ) {
						jQuery( '#backupbuddy_live_snapshot-success-backup_plugins' ).show().find('a').attr( 'href', snapshotStatus.snapshot.zips.plugins );
					}
					if ( 'undefined' != typeof snapshotStatus.snapshot.zips.themes ) {
						jQuery( '#backupbuddy_live_snapshot-success-backup_themes' ).show().find('a').attr( 'href', snapshotStatus.snapshot.zips.themes );
					}
					if ( ( false === snapshotStatus.snapshot.missing_ib ) && ( 'undefined' != typeof snapshotStatus.snapshot.importbuddy ) ) {
						jQuery( '#backupbuddy_live_snapshot-success-backup_importbuddy' ).show().find('a').attr( 'href', snapshotStatus.snapshot.importbuddy.url );
					}
				} else { // Snapshot IN PROGRESS.
					jQuery( '#backupbuddy_live_snapshot-success' ).hide();
					//jQuery( '#backupbuddy_live_snapshot-working' ).show();

					backupbuddy_live_snapshot_status_pretty = ' - ' + snapshotStatus.message;
					//jQuery( '#backupbuddy_live_snapshot-working-status' ).text( snapshotStatus.message );
					//jQuery( '#backupbuddy_live_snapshot-working-duration' ).text( snapshotStatus.duration );

					setTimeout( 'mainwp_backupbuddy_live_snapshot_status_check( "' + snapshot_id + '" )', 5000 );
				}
			}

		});
	} // End mainwp_backupbuddy_live_snapshot_status_check().
</script>

<?php require_once( pb_mainwp_backupbuddy::plugin_path() . '/destinations/live/_statsPoll.php' ); ?>


<div class="bb_progress-bar backupbuddy-live-snapshot-progress-bar clearfix">
	<div class="bb_progress-step bb_progress-step-database">
		<div class="bb_progress-step-icon"></div>
		<div class="bb_progress-step-title">Database</div>
		<span class="bb_progress-loading"></span>
	</div>
		<div class="bb_progress-step bb_progress-step-files">
		<div class="bb_progress-step-icon"></div>
		<div class="bb_progress-step-title">Files</div>
		<span class="bb_progress-loading"></span>
	</div>
		<div class="bb_progress-step bb_progress-step-snapshot">
		<div class="bb_progress-step-icon"></div>
		<div class="bb_progress-step-title">Remote Snapshot</div>
		<span class="bb_progress-loading"></span>
	</div>
	<div class="bb_progress-step bb_progress-step-finished">
		<div class="bb_progress-step-icon"></div>
		<div class="bb_progress-step-title">Finished!</div>
		<span class="bb_progress-loading"></span>
	</div>
</div>



<div class="backupbuddy-live-stats-container postbox"></div>
<script type="text/template" id="backupbuddy-live-stats-tmpl">
	<div class="backupbuddy-live-stats-grid">
		<div class="col col-3-3">
			<div class="backupbuddy-live-stats-currently">
				<span class="backupbuddy-pulsing-orb"></span>
				<span class="backupbuddy-live-stats-currently-text">
					<span class="backupbuddy-inline-label"><?php _e( 'Currently', 'it-l10n-mainwp-backupbuddy' ); ?></span>: {{ stats.current_function_pretty }}
				</span>
			</div>
		</div>
		<div class="col col-2-3">
			<div class="col col-1-3">
				<div class="backupbuddy-live-stats-database backupbuddy-live-stats-column <# if ( stats.continuous_status == '0' ) { #>paused <# } #>">
					<div class="backupbudy-live-stats-data-container">
						<div class="backupbuddy-live-stats-meta-overlay">
							<div class="backupbuddy-live-stats-meta-section">
								<span><?php _e( 'Last Activity', 'it-l10n-mainwp-backupbuddy' ); ?></span>
								{{ stats.last_database_live_activity_ago }}
							</div>
							<div class="backupbuddy-live-stats-meta-section">
								<span><?php _e( 'Next Full Scan', 'it-l10n-mainwp-backupbuddy' ); ?></span>
								{{ stats.next_db_snapshot_pretty }}
							</div>
						</div>
						<div class="backupbuddy-live-stats-column-heading">
							<?php _e( 'Database', 'it-l10n-mainwp-backupbuddy' ); ?>
						</div>
						<div class="backupbuddy-live-stats-big-number">
							{{ stats.database_tables_sent }}
						</div>
						<div class="backupbuddy-live-stats-sub-numbers">
							<?php _e( 'of', 'it-l10n-mainwp-backupbuddy' ); ?> {{ stats.database_tables_total }}<br>
							<?php _e( 'Tables', 'it-l10n-mainwp-backupbuddy' ); ?>
						</div>
						<div class="backupbuddy-live-stats-progress-bar-container">
							<div class="backupbuddy-live-stats-progress-bar">
								<div class="backupbuddy-live-stats-progress-bar-highlight <# if ( '100' != stats.database_tables_sent_percent ) { #>animate<# } #>" title="{{stats.database_tables_sent_percent }}%" style="width:{{ stats.database_tables_sent_percent }}%"></div>
							</div>
							<div class="backupbuddy-live-stats-progress-bar-percentage">
								{{{ Math.floor(stats.database_tables_sent_percent) }}}%
							</div>
						</div>
						<div class="backupbuddy-live-stats-total">
							{{ stats.database_size_pretty }}
						</div>
					</div>
					<div class="backupbuddy-live-stats-action">
						<# if ( stats.continuous_status == '0' ) { #>
							<a href="<?php echo pb_mainwp_backupbuddy::nonce_url( $admin_url . '&live_action=resume_continuous' ); ?>" class="backupbuddy-live-button primary"><span class="dashicons dashicons-controls-play"></span><?php _e( 'Resume', 'it-l10n-mainwp-backupbuddy' ); ?></a>
						<# } else { #>
							<a href="<?php echo pb_mainwp_backupbuddy::nonce_url( $admin_url . '&live_action=pause_continuous' ); ?>" class="backupbuddy-live-button secondary"><span class="dashicons dashicons-controls-pause"></span><?php _e( 'Pause', 'it-l10n-mainwp-backupbuddy' ); ?></a>
						<# } #>
					</div>
				</div>
			</div>
			<div class="col col-1-3">
				<div class="backupbuddy-live-stats-files backupbuddy-live-stats-column <# if ( stats.periodic_status == '0' ) { #>paused <# } #>">
					<div class="backupbudy-live-stats-data-container">
						<div class="backupbuddy-live-stats-meta-overlay">
							<div class="backupbuddy-live-stats-meta-section">
								<span><?php _e( 'Last Activity', 'it-l10n-mainwp-backupbuddy' ); ?></span>
								{{ stats.last_periodic_activity_ago }}
							</div>
							<div class="backupbuddy-live-stats-meta-section">
								<span><?php _e( 'Next Full Scan', 'it-l10n-mainwp-backupbuddy' ); ?></span>
								{{ stats.next_periodic_restart_pretty }}
							</div>
						</div>
						<div class="backupbuddy-live-stats-column-heading">
							<?php _e( 'Files', 'it-l10n-mainwp-backupbuddy' ); ?>
						</div>
						<div class="backupbuddy-live-stats-big-number">
							{{ stats.files_sent }}
						</div>
						<div class="backupbuddy-live-stats-sub-numbers">
							<?php _e( 'of', 'it-l10n-mainwp-backupbuddy' ); ?> {{ stats.files_total }}<br>
							<?php _e( 'Files', 'it-l10n-mainwp-backupbuddy' ); ?>
						</div>
						<div class="backupbuddy-live-stats-progress-bar-container">
							<div class="backupbuddy-live-stats-progress-bar">
								<div class="backupbuddy-live-stats-progress-bar-highlight <# if ( '100' != stats.files_sent_percent ) { #>animate<# } #>" title="{{ stats.files_sent_percent }}%"style="width:{{ stats.files_sent_percent }}%"></div>
							</div>
							<div class="backupbuddy-live-stats-progress-bar-percentage">
								{{{ Math.floor(stats.files_sent_percent) }}}%
							</div>
						</div>
						<div class="backupbuddy-live-stats-total">
							{{ stats.files_size_pretty }}
						</div>
					</div>
					<div class="backupbuddy-live-stats-action">
						<# if ( stats.periodic_status == '0' ) { #>
							<a href="<?php echo pb_mainwp_backupbuddy::nonce_url( $admin_url . '&live_action=resume_periodic' ); ?>" class="backupbuddy-live-button primary"><span class="dashicons dashicons-controls-play"></span><?php _e( 'Resume', 'it-l10n-mainwp-backupbuddy' ); ?></a>
						<# } else { #>
							<a href="<?php echo pb_mainwp_backupbuddy::nonce_url( $admin_url . '&live_action=pause_periodic' ); ?>" class="backupbuddy-live-button secondary"><span class="dashicons dashicons-controls-pause"></span><?php _e( 'Pause', 'it-l10n-mainwp-backupbuddy' ); ?></a>
						<# } #>
					</div>

				</div>
			</div>
			<div class="col col-1-3">
				<div class="backupbuddy-live-stats-storage backupbuddy-live-stats-column last">
					<div class="backupbuddy-live-stats-column-heading">
						<?php _e( 'Storage', 'it-l10n-mainwp-backupbuddy' ); ?>
					</div>
					<div class="backupbuddy-live-stats-big-number">
						<# if ( stats.stash ) { #>
							{{ stats.stash.quota_used_nice }}
						<# } else { #>
							<?php _e( 'Pending', 'it-l10n-mainwp-backupbuddy' ); ?>
						<# } #>
					</div>
					<div class="backupbuddy-live-stats-sub-numbers">
						<# if ( stats.stash ) { #>
							<?php _e( 'of', 'it-l10n-mainwp-backupbuddy' ); ?> {{ stats.stash.quota_total_nice }}<br>
							<?php _e( 'Used', 'it-l10n-mainwp-backupbuddy' ); ?>
						<# } else { #>
							<?php echo sprintf( __( 'Storage Amount %s Currently Unavailable', 'it-l10n-mainwp-backupbuddy' ), '<br>' ); ?>
						<# } #>
					</div>
					<div class="backupbuddy-live-stats-progress-bar-container">
						<# if ( stats.stash ) { #>
						<div class="backupbuddy-live-stats-progress-bar">
							<div class="backupbuddy-live-stats-progress-bar-highlight" title="{{ stats.stash.quota_used_percent }}%" style="width:{{ stats.stash.quota_used_percent }}%"></div>
						</div>
						<# } #>
						<div class="backupbuddy-live-stats-progress-bar-percentage">
							<# if ( stats.stash ) { #>
								{{{ Math.floor(stats.stash.quota_used_percent) }}}%
							<# } #>
						</div>
					</div>
					<div class="backupbuddy-live-stats-total"></div>
					<div class="backupbuddy-live-stats-action">
						<a href="https://sync.ithemes.com/stash" target="_blank" class="backupbuddy-live-button primary"><?php _e( 'Manage Remote Files', 'it-l10n-mainwp-backupbuddy' ); ?></a><br>
						<a href="https://ithemes.com/backupbuddy-stash/" target="_blank" class="backupbuddy-live-button secondary need-more"><?php _e( 'Need More Storage?', 'it-l10n-mainwp-backupbuddy' ); ?></a>
					</div>
				</div>
			</div>
		</div>
		<div class="col col-1-3">
			<div class="backupbuddy-live-stats-overview">
				<h3><?php _e( 'BackupBuddy Stash Live created new zip files for you as of', 'it-l10n-mainwp-backupbuddy' ); ?>:</h3>
				<div class="backupbuddy-stats-time-ago">{{ stats.last_remote_snapshot_ago }}</div>
				<a href="#" class="backupbuddy-stats-help-link">
					<?php _e( 'What does this mean?', 'it-l10n-mainwp-backupbuddy' ); ?>
					<span class="backupbuddy-stats-time-ago-explanation">
						<?php _e( 'This is the time since your latest full Snapshot was taken by BackupBuddy Stash Live. Stash Live continuously watches for changes and pushes them up for safe storage. Periodically a "Snapshot" in time is created which is a recording of the state of your site at that time. You can download your latest Snapshot zip files from the Sync dashboard.', 'it-l10n-mainwp-backupbuddy' ); ?>
					</span>
				</a>

				<div class="backupbuddy-stats-overview-create-snapshot">
					<p><?php _e( 'Need a more recent snapshot?', 'it-l10n-mainwp-backupbuddy' ); ?></p>
					<a href="<?php echo pb_mainwp_backupbuddy::nonce_url( $admin_url . '&live_action=create_snapshot' ); ?>" class="backupbuddy-live-button primary"><?php _e( 'Create Manual Snapshot', 'it-l10n-mainwp-backupbuddy' ); ?></a>
				</div>
			</div>
		</div>
	</div>
</script>



<script>
	var snapshotStatusURL = '<?php echo pb_mainwp_backupbuddy::ajax_url( 'live_snapshot_status' ); ?>'; // AJAX status check URL.

	jQuery(document).ready(function() {

		mainwp_backupbuddy_live_stats( jQuery.parseJSON( '<?php echo json_encode( $stats ); ?>' ) );
		loadingIndicator = jQuery( '.pb_backupbuddy_loading' );

		jQuery(document).on( 'click', '.backupbuddy-stats-help-link', function(e) {
			e.preventDefault();
			jQuery( '.backupbuddy-stats-time-ago-explanation' ).addClass('visible');
		});

		jQuery(document).on( 'mouseleave', '.backupbuddy-stats-time-ago-explanation', function() {
			jQuery( '.backupbuddy-stats-time-ago-explanation' ).removeClass('visible');
		});
	});
</script>



<?php // Display remote files stored in Stash. ?>
<br style="clear: both;"><br>
<h3><?php _e( 'Stash Live Remote Snapshot Files', 'it-l10n-mainwp-backupbuddy' ); ?></h3>
<p class="description restrict-length">
	<?php echo __( 'Below is a listing of your Snapshot zip files stored in Stash. You can copy these files locally, download them for use, or manage them in iThemes Sync, including traditional backups sent to a Stash destination.', 'it-l10n-mainwp-backupbuddy'); ?>
</p>

<div class="backupbuddy_live_iframe_load">
    <i class="fa fa-spinner fa-pulse fa-2x"></i> <?php _e( 'Loading remote Snapshot files list...', 'it-l10n-mainwp-backupbuddy' ); ?>
</div>
<div id="backupbuddy_live-stash_iframe" data-refreshed="<?php echo time(); ?>" ></div>
<?php $dest_live_id = backupbuddy_mainwp_live::getLiveID(); ?>
<script type="text/javascript">
        jQuery.post( '<?php echo pb_mainwp_backupbuddy::ajax_url( 'live_stash_files' ); ?>', {buddy_manage_site_id: <?php echo intval( $site_id ); ?>, destination_id: <?php echo intval($dest_live_id); ?>, live_mode: 1},
                            function(data) {
                                    jQuery( '.backupbuddy_live_iframe_load' ).hide()
                                    if ( data ) {
                                            if (data.result) {
                                                jQuery('#backupbuddy_live-stash_iframe').html(data.result);
                                                return;
                                            } else if (data.error) {
                                                error = data.error;
                                            } else {
                                                error = 'Undefined error.';
                                            }
                                    } else {
                                            error = "Error: \n\n" + data;
                                    }
                                    if (error != '') {
                                        jQuery('#backupbuddy_live-stash_iframe').html('<div class="mainwp_info-box-red">' + error + '</div>');
                                    }
                            }, 'json'
                    );


</script>

<br style="clear: both;"><br><br>
<?php
 $troub_url = 'admin.php?page=SiteOpen&newWindow=yes&websiteid=' . $site_id . '&location=' . base64_encode('admin.php?page=pb_backupbuddy_live');
?>
<a href="<?php echo $troub_url; ?>" target="_blank" class="button button-secondary button-tertiary">Advanced Troubleshooting Options</a>
<a href="<?php echo pb_mainwp_backupbuddy::ajax_url( 'live_troubleshooting_download' ) . '&site_id=' . $site_id; ?>" class="button button-secondary button-tertiary">Download Troubleshooting Data (.txt)</a>

<?php
// Handles thickbox auto-resizing. Keep at bottom of page to avoid issues.
if ( !wp_script_is( 'media-upload' ) ) {
	wp_enqueue_script( 'media-upload' );
	wp_print_scripts( 'media-upload' );
}
