<?php // This code runs whenever in the wp-admin. pb_mainwp_backupbuddy::$options preloaded.



/********** MISC **********/



// Needed for retina icons in menu.
//add_action( 'admin_enqueue_scripts', create_function( '',
//	"wp_enqueue_style( 'pb_mainwp_backupbuddy-wp-admin', '" . pb_mainwp_backupbuddy::plugin_url() . "/css/wp-admin.css', array(), pb_mainwp_backupbuddy::settings( 'version' ) );"
//	)
//);

function pb_mainwp_mainwp_backupbuddy_admin_enqueue_scripts() {
    wp_enqueue_style( 'pb_mainwp_backupbuddy-wp-admin', pb_mainwp_backupbuddy::plugin_url() . "/css/wp-admin.css", array(), pb_mainwp_backupbuddy::settings( 'version' ) );
}
add_action( 'admin_enqueue_scripts', 'pb_mainwp_mainwp_backupbuddy_admin_enqueue_scripts');


global $wp_version;
//if ( $wp_version >= 3.8 ) {
//	add_action( 'admin_enqueue_scripts', create_function( '',
//		"wp_enqueue_style( 'pb_mainwp_backupbuddy-wp-admin-fonticon', '" . pb_mainwp_backupbuddy::plugin_url() . "/css/wp-admin-fonticon.css', array(), pb_mainwp_backupbuddy::settings( 'version' ) );"
//		)
//	);
//}


// Enqueue styles for Dashboard Widget
function enqueue_mainwp_dashboard_stylesheet($hook) {
	if( 'index.php' != $hook )
		return;
	wp_enqueue_style( 'bub_mainwp_dashboard_widget', pb_mainwp_backupbuddy::plugin_url() . '/css/dashboard_widget.css' );
}
add_action( 'admin_enqueue_scripts', 'enqueue_mainwp_dashboard_stylesheet' );




// Load backupbuddy class with helper functions.
if ( ! class_exists( 'mainwp_backupbuddy_core' ) ) {
	require_once( pb_mainwp_backupbuddy::plugin_path() . '/classes/core.php' );
}



/* BEGIN HANDLING DATA STRUCTURE UPGRADE */
$default_options = pb_mainwp_backupbuddy::settings( 'default_options' );
if ( pb_mainwp_backupbuddy::$options['data_version'] < $default_options['data_version'] ) {
	mainwp_backupbuddy_core::verify_directories( $skipTempGeneration = true );
	pb_mainwp_backupbuddy::status( 'details', 'Data structure version of `' . pb_mainwp_backupbuddy::$options['data_version'] . '` behind current version of `' . $default_options['data_version'] . '`. Running activation upgrade.' );
	require_once( pb_mainwp_backupbuddy::plugin_path() . '/controllers/activation.php' );
}
/* END HANDLING DATA STRUCTURE UPGRADE */



// Schedule daily housekeeping.
mainwp_backupbuddy_core::verifyHousekeeping();
mainwp_backupbuddy_core::verifyLiveCron();


/********** ACTIONS (admin) **********/

// Display warning to network activate if running in normal mode on a MultiSite Network.
if ( is_multisite() && !mainwp_backupbuddy_core::is_network_activated() ) {
	pb_mainwp_backupbuddy::add_action( array( 'all_admin_notices', 'multisite_network_warning' ) ); // BB should be network activated while on Multisite.
}



/********** AJAX (admin) **********/



pb_mainwp_backupbuddy::add_ajax( 'backupbuddy' ); // New AJAX wrapper to begin passing all AJAX through this single call to reduce number of registered hooks. POST or GET the var function containing the function.php file to run within controllers/ajax.
//pb_mainwp_backupbuddy::add_ajax( 'ajax_controller_callback_function' ); // Tell WordPress about this AJAX callback.

// Register BackupBuddy API. As of BackupBuddy v5.0. Access credentials will be checked within callback.
add_action( 'wp_ajax_backupbuddy_api', array( pb_mainwp_backupbuddy::$_ajax, 'api' ) );
add_action( 'wp_ajax_nopriv_backupbuddy_api', array( pb_mainwp_backupbuddy::$_ajax, 'api' ) );



/********** DASHBOARD (admin) **********/



// Display stats in Dashboard.
if ( ( !is_multisite() ) || ( is_multisite() && is_network_admin() ) ) { // Only show if standalone OR in main network admin.
	//pb_mainwp_backupbuddy::add_dashboard_widget( 'stats', 'BackupBuddy v' . pb_mainwp_backupbuddy::settings( 'version' ), 'godmode' );
}



/********** FILTERS (admin) **********/



pb_mainwp_backupbuddy::add_filter( 'plugin_row_meta', 10, 2 );



/********** PAGES (admin) **********/



$icon = '';


//pb_mainwp_backupbuddy::add_page( '', 'backup', array( pb_mainwp_backupbuddy::settings( 'name' ), __( 'Backup', 'it-l10n-mainwp-backupbuddy' ) ), pb_mainwp_backupbuddy::$options['role_access'], $icon );
//if ( '1' !== pb_mainwp_backupbuddy::$options['hide_live'] ) {
//	pb_mainwp_backupbuddy::add_page( 'backup', 'live', __( 'Stash Live', 'it-l10n-mainwp-backupbuddy' ), pb_mainwp_backupbuddy::$options['role_access'] );
//}
//pb_mainwp_backupbuddy::add_page( 'backup', 'migrate_restore', __( 'Restore / Migrate', 'it-l10n-mainwp-backupbuddy' ), pb_mainwp_backupbuddy::$options['role_access'] );
//pb_mainwp_backupbuddy::add_page( 'backup', 'destinations', __( 'Remote Destinations', 'it-l10n-mainwp-backupbuddy' ), pb_mainwp_backupbuddy::$options['role_access'] );
//pb_mainwp_backupbuddy::add_page( 'backup', 'server_tools', __( 'Server Tools', 'it-l10n-mainwp-backupbuddy' ), pb_mainwp_backupbuddy::$options['role_access'] );
//pb_mainwp_backupbuddy::add_page( 'backup', 'malware_scan', __( 'Malware Scan', 'it-l10n-mainwp-backupbuddy' ), pb_mainwp_backupbuddy::$options['role_access'] );
//pb_mainwp_backupbuddy::add_page( 'backup', 'scheduling', __( 'Schedules', 'it-l10n-mainwp-backupbuddy' ), pb_mainwp_backupbuddy::$options['role_access'] );
//pb_mainwp_backupbuddy::add_page( 'backup', 'settings', __( 'Settings', 'it-l10n-mainwp-backupbuddy' ), pb_mainwp_backupbuddy::$options['role_access'] );




/***** BEGIN STASH LIVE ADMIN BAR *****/
function mainwp_backupbuddy_live_admin_bar_menu( $wp_admin_bar ) {
	if ( ! current_user_can( pb_mainwp_backupbuddy::$options['role_access'] ) ) {
		return;
	}

    $args = array(
        'id'    => 'backupbuddy_stash_live_admin_bar',
        'title' => 'BackupBuddy Stash Live',
    );
    $wp_admin_bar->add_node( $args );

    $child_args = array();

    array_push( $child_args, array(
        'id'     => 'backupbuddy_stash_live_admin_bar_stats',
        'title'  => '<div class="backupbuddy-stash-live-admin-bar-stats-container"><span class="backupbuddy-pulsing-orb"></span><span class="backupbuddy-stash-live-admin-bar-stats-text">' . __( 'Loading...', 'it-l10n-mainwp-backupbuddy' ) . '</span></div>',
        'href'   =>  admin_url( 'admin.php?page=pb_backupbuddy_live' ),
        'parent' => 'backupbuddy_stash_live_admin_bar',
    ));

    foreach ( $child_args as $args ) {
        $wp_admin_bar->add_node($args);
    }

}
function mainwp_backupbuddy_live_admin_bar_script() {
	if ( ! current_user_can( pb_mainwp_backupbuddy::$options['role_access'] ) ) {
		return;
	}

	wp_register_script( 'mainwp_backupbuddy_live_admin_bar', pb_mainwp_backupbuddy::plugin_url() . '/destinations/live/admin_bar.js', array( 'jquery') );
	wp_localize_script(
		'mainwp_backupbuddy_live_admin_bar',
		'backupbuddy_live_admin_bar_translations',
		array(
			'currently' => __( 'Currently', 'it-l10n-mainwp-backupbuddy' )
		)
	);
	wp_enqueue_script( 'mainwp_backupbuddy_live_admin_bar' );
	wp_enqueue_style( 'mainwp_backupbuddy_live_admin_bar_style', pb_mainwp_backupbuddy::plugin_url() . '/destinations/live/admin_bar.css' );
}
function mainwp_backupbuddy_live_statsPoll() {
	if ( ! current_user_can( pb_mainwp_backupbuddy::$options['role_access'] ) ) {
		return;
	}

	include( pb_mainwp_backupbuddy::plugin_path() . '/destinations/live/_statsPoll.php' );
}
if ( 'disconnect' != pb_mainwp_backupbuddy::_GET( 'live_action' ) ) { // If not disconnecting from Live this pageload.
	foreach( pb_mainwp_backupbuddy::$options['remote_destinations'] as $destination ) { // Look for Live destination.
		if ( ( 'live' == $destination['type'] ) && ( isset( $destination['show_admin_bar'] ) ) && ( '1' == $destination['show_admin_bar'] ) ) {
			add_action( 'admin_bar_menu', 'mainwp_backupbuddy_live_admin_bar_menu', 999 );
			add_action( 'admin_enqueue_scripts', 'mainwp_backupbuddy_live_admin_bar_script' );
			add_action( 'admin_footer', 'mainwp_backupbuddy_live_statsPoll', 999 );
			break;
		}
	}
}
/***** END STASH LIVE ADMIN BAR *****/

// Global admin javascript files.
function mainwp_backupbuddy_global_admin_scripts() {
	wp_register_script( 'mainwp_backupbuddy_global_admin_scripts', pb_mainwp_backupbuddy::plugin_url() . '/js/global_admin.js', array( 'jquery') );
	wp_enqueue_script( 'mainwp_backupbuddy_global_admin_scripts' );
}
add_action( 'admin_enqueue_scripts', 'mainwp_backupbuddy_global_admin_scripts' );

