<?php // This code runs everywhere. pb_mainwp_backupbuddy::$options preloaded.


/***** BEGIN BackupBuddy Stash Live Init *****/
//pb_mainwp_backupbuddy::load();
foreach( pb_mainwp_backupbuddy::$options['remote_destinations'] as $destination ) { // See if we have Live activated.
	if ( 'live' == $destination['type'] ) {
		include( 'destinations/live/live_continuous.php' );
		//backupbuddy_mainwp_live_continuous::init();
		break;
	}
}
/***** END BackupBuddy Stash Live Init *****/



include( 'classes/constants.php' );
include( 'classes/api.php' );

// Handle API calls if backupbuddy_api_key is posted. If anything fails security checks pretend nothing at all happened.
if ( '' != pb_mainwp_backupbuddy::_POST( 'backupbuddy_api_key' ) ) { // Remote API access.
	if ( isset( pb_mainwp_backupbuddy::$options['remote_api'] ) && ( count( pb_mainwp_backupbuddy::$options['remote_api']['keys'] ) > 0 ) && defined( 'BACKUPBUDDY_API_ENABLE' ) && ( TRUE == BACKUPBUDDY_API_ENABLE ) ) { // Verify API is enabled. && defined( 'BACKUPBUDDY_API_SALT' ) && ( 'CHANGEME' != BACKUPBUDDY_API_SALT ) && ( strlen( BACKUPBUDDY_API_SALT ) >= 5 )
		include( 'classes/remote_api.php' );
		mainwp_backupbuddy_remote_api::localCall( $secure = true );
		die();
	}
}

// Internal cron (disabled by default).
if ( ( '1' == pb_mainwp_backupbuddy::$options['use_internal_cron'] ) && ( 'process_backup' == pb_mainwp_backupbuddy::_POST( 'backupbuddy_cron_action' ) ) ) {
	// Verify access to trigger cron.
	if ( pb_mainwp_backupbuddy::$options['log_serial'] != pb_mainwp_backupbuddy::_POST( 'backupbuddy_key' ) ) {
		die( 'Access Denied.' );
	}

	// Ignore anything older than 5 min.
	$max_cron_age = 60 * 5;
	if ( time() - pb_mainwp_backupbuddy::_POST( 'backupbuddy_time' ) > ( $max_cron_age ) ) {
		die( 'Cron action too old.' );
	}

	// Try to prevent any caching layer.
	@header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
	@header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
	@header("Cache-Control: no-store, no-cache, must-revalidate");
	@header("Cache-Control: post-check=0, pre-check=0", false);
	@header("Pragma: no-cache");

	// Process.
	require_once( pb_mainwp_backupbuddy::plugin_path() . '/classes/core.php' );
	mainwp_backupbuddy_core::process_backup( pb_mainwp_backupbuddy::_POST( 'backupbuddy_serial' ) );
	die( '`' . microtime( true ) . '`' );
}


// Make localization happen.
if ( ( ! defined( 'PB_MAINWP_STANDALONE' ) ) && ( '1' != pb_mainwp_backupbuddy::$options['disable_localization'] ) ) {
	load_plugin_textdomain( 'it-l10n-mainwp-backupbuddy', false, dirname( plugin_basename( __FILE__ ) ) . '/lang' );
}



/********** ACTIONS (global) **********/



/********** AJAX (global) **********/



/********** CRON (global) **********/
pb_mainwp_backupbuddy::add_cron( 'cron', mainwp_backupbuddy_constants::DEFAULT_CRON_PRIORITY, 3 ); // Master CRON handler as of v6.4.0.9. Pass all cron functionality through this. Params: cron_method, args, reschedulecount(optional).



/********** FILTERS (global) **********/
pb_mainwp_backupbuddy::add_filter( 'cron_schedules' ); // Add schedule periods such as bimonthly, etc into cron. By default passes 1 param at priority 10.
//if ( '1' == pb_mainwp_backupbuddy::$options['disable_https_local_ssl_verify'] ) {
//	$disable_local_ssl_verify_anon_function = create_function( '', 'return false;' );
//	add_filter( 'https_local_ssl_verify', $disable_local_ssl_verify_anon_function, 100 );
//}



/********** OTHER (global) **********/



// WP-CLI tool support for command line access to BackupBuddy. http://wp-cli.org/
//if ( defined( 'WP_CLI' ) && WP_CLI ) {
//	include( pb_mainwp_backupbuddy::plugin_path() . '/classes/wp-cli.php' );
//}

/*
add_filter( 'cron_request', 'mainwp_backupbuddy_spoof_cron_agent' );
function mainwp_backupbuddy_spoof_cron_agent( $cron ) {
	$cron['args']['user-agent'] = 'Mozilla';
	return $cron;
}
*/



/*
add_filter( 'cron_request', 'mainwp_backupbuddy_spoof_cron_agent' );
function mainwp_backupbuddy_spoof_cron_agent( $cron ) {
	$cron['args']['user-agent'] = 'Mozilla';
	return $cron;
}
*/


// Sync notices.
function mainwp_backupbuddy_sync_add_notices( $arguments, $urgent = false ) {
	require_once( pb_mainwp_backupbuddy::plugin_path() . '/classes/core.php' );

	$notifications = mainwp_backupbuddy_core::getNotifications();
	foreach( $notifications as &$notification ) {
		// Skip if in the inapplicable mode.
		if ( ( false === $urgent ) && ( true === $notification['urgent'] ) ) { // If NOT seeking urgents, skip urgents.
			continue;
		}
		if ( ( true === $urgent ) && ( false === $notification['urgent'] ) ) { // If seeking urgents, skip non-urgents.
			continue;
		}
		if ( true === $notification['syncSent'] ) { // Only send once.
			continue;
		}

		$notification['syncSent'] = true;
		$notification['data']['datestamp'] = date( 'Y-m-d', $notification['time'] ); // Added v6.3.3.10.

		// Send notice.
		if ( false === $urgent ) {
			ithemes_sync_add_notice( 'backupbuddy', $notification['slug'], $notification['title'], $notification['message'], $notification['data'] );
		} elseif ( true === $urgent ) {
			ithemes_sync_send_urgent_notice( 'backupbuddy', $notification['slug'], $notification['title'], $notification['message'], $notification['data'] );
		}
	}
	mainwp_backupbuddy_core::replaceNotifications( $notifications ); // Save with syncSent updates for all notifications.
	return true;
}
function mainwp_backupbuddy_sync_send_urgent_notice( $arguments ) {
	return mainwp_backupbuddy_sync_add_notices( $arguments, $urgent = true );
}
add_action( 'ithemes_sync_add_notices', 'mainwp_backupbuddy_sync_add_notices' );
//add_action( 'init', 'mainwp_backupbuddy_sync_send_urgent_notice' );


