jQuery( document ).ready(function ($) {
         $( '#mainwp_backupbuddy_override_general_settings' ).on('change', function () {
                var statusEl = jQuery( '#mwp_backupbuddy_perform_individual_status' );
		var loaderEl = jQuery( '#backupbuddy_site_settings i.loader' );
		statusEl.hide();
		loaderEl.show();
                var overrideValue = $( '#mainwp_backupbuddy_override_general_settings' ).is( ":checked" ) ? 1 : 0;
		data = {
			action: 'mainwp_backupbuddy_site_override_settings',
			backupbuddyRequestSiteID: $( 'input[name=mainwp_backupbuddy_settings_site_id]' ).val(),
			override: overrideValue,
			_backupbuddyNonce: mainwp_backupbuddy_loc.nonce
		};
		jQuery.post(ajaxurl, data, function (response) {
			loaderEl.hide();
			if (response) {
				if (response.error) {
					statusEl.css( 'color', 'red' );
					statusEl.html( response.error );
				} else if (response.result == 'success') {
					statusEl.css( 'color', '#21759B' );
					statusEl.html( __( 'Saved' ) );
          jQuery( '#mainwp_backupbuddy_override_settings_value' ).val(overrideValue);
				} else {
					statusEl.css( 'color', 'red' );
					statusEl.html( '<i class="fa fa-exclamation-circle"></i> ' + 'Undefined Error' );
				}
			} else {
				statusEl.css( 'color', 'red' );
				statusEl.html( '<i class="fa fa-exclamation-circle"></i> ' + 'Undefined Error' );
			}
			statusEl.fadeIn();
		}, 'json');

		return false;
	});

});


jQuery( document ).ready(function ($) {

	$( '.mwp_backupbuddy_active_plugin' ).on('click', function () {
		mainwp_backupbuddy_plugin_active_start_specific( $( this ), false );
		return false;
	});

	$( '.mwp_backupbuddy_upgrade_plugin' ).on('click', function () {
		mainwp_backupbuddy_plugin_upgrade_start_specific( $( this ), false );
		return false;
	});

	$( '.mwp_backupbuddy_showhide_plugin' ).on('click', function () {
		mainwp_backupbuddy_plugin_showhide_start_specific( $( this ), false );
		return false;
	});

	$( '#backupbuddy_plugin_doaction_btn' ).on('click', function () {
		var bulk_act = $( '#mwp_backupbuddy_plugin_action' ).val();
		mainwp_backupbuddy_plugin_do_bulk_action( bulk_act );
	});

});

var backupbuddy_bulkMaxThreads = 3;
var backupbuddy_bulkTotalThreads = 0;
var backupbuddy_bulkCurrentThreads = 0;
var backupbuddy_bulkFinishedThreads = 0;

mainwp_backupbuddy_plugin_do_bulk_action = function (act) {
	var selector = '';
	switch (act) {
		case 'activate-selected':
			selector = '#mainwp-buddy-sites-table tbody tr.negative';
			jQuery( selector ).addClass( 'queue' );
			mainwp_backupbuddy_plugin_active_start_next( selector );
			break;
		case 'update-selected':
			selector = '#mainwp-buddy-sites-table tbody tr.warning';
			jQuery( selector ).addClass( 'queue' );
			mainwp_backupbuddy_plugin_upgrade_start_next( selector );
			break;
		case 'hide-selected':
			selector = '#mainwp-buddy-sites-table tbody tr .mwp_backupbuddy_showhide_plugin[showhide="hide"]';
			jQuery( selector ).addClass( 'queue' );
			mainwp_backupbuddy_plugin_showhide_start_next( selector );
			break;
		case 'show-selected':
			selector = '#mainwp-buddy-sites-table tbody tr .mwp_backupbuddy_showhide_plugin[showhide="show"]';
			jQuery( selector ).addClass( 'queue' );
			mainwp_backupbuddy_plugin_showhide_start_next( selector );
			break;
	}
}

mainwp_backupbuddy_plugin_showhide_start_next = function (selector) {
	while ((objProcess = jQuery( selector + '.queue:first' )) && (objProcess.length > 0) && (backupbuddy_bulkCurrentThreads < backupbuddy_bulkMaxThreads)) {
		objProcess.removeClass( 'queue' );
		if (objProcess.closest( 'tr' ).find( '.check-column input[type="checkbox"]:checked' ).length == 0) {
			continue;
		}
		mainwp_backupbuddy_plugin_showhide_start_specific( objProcess, true, selector );
	}
}

mainwp_backupbuddy_plugin_showhide_start_specific = function (pObj, bulk, selector) {
  var parent = pObj.closest( 'tr' );
  var showhide = pObj.attr( 'showhide' );
  var pluginName = parent.attr( 'plugin-name' );
  var statusEl = parent.find( '.visibility' );
  var pluginName = parent.attr( 'plugin-name' );
	if (bulk) {
		backupbuddy_bulkCurrentThreads++;
  }

	var data = {
		action: 'mainwp_backupbuddy_showhide_plugin',
		backupbuddyRequestSiteID: parent.attr( 'website-id' ),
		showhide: showhide
	}
	statusEl.html( '<i class="notched circle loading icon"></i>' );
	jQuery.post(ajaxurl, data, function (response) {
    pObj.removeClass( 'queue' );
    if (response && response['error']) {
      statusEl.html( '<i class="red times icon"></i>' );
    } else if (response && response['result'] == 'SUCCESS') {
      if (showhide == 'show') {
        pObj.text( "Hide Plugin" );
        pObj.attr( 'showhide', 'hide' );
        parent.find( '.wp-staging-visibility' ).html( __( 'No' ) );
      } else {
        pObj.text( "Unhide Plugin" );
        pObj.attr( 'showhide', 'show' );
        parent.find( '.wp-staging-visibility' ).html( __( 'Yes' ) );
      }
    } else {
      statusEl.html( '<i class="red times icon"></i>' );
    }

		if (bulk) {
			backupbuddy_bulkCurrentThreads--;
			backupbuddy_bulkFinishedThreads++;
			mainwp_backupbuddy_plugin_showhide_start_next( selector );
		}

	}, 'json');
	return false;
}

mainwp_backupbuddy_plugin_upgrade_start_next = function (selector) {
	while ((objProcess = jQuery( selector + '.queue:first' )) && (objProcess.length > 0) && (objProcess.length > 0) && (backupbuddy_bulkCurrentThreads < backupbuddy_bulkMaxThreads)) {
		objProcess.removeClass( 'queue' );
		if (objProcess.closest( 'tr' ).find( '.check-column input[type="checkbox"]:checked' ).length == 0) {
			continue;
		}
		mainwp_backupbuddy_plugin_upgrade_start_specific( objProcess, true, selector );
	}
}

mainwp_backupbuddy_plugin_upgrade_start_specific = function (pObj, bulk, selector) {
  var parent = pObj.closest( 'tr' );
	var statusEl = parent.find( '.updating' );
	var slug = parent.attr( 'plugin-slug' );
	var data = {
		action: 'mainwp_backupbuddy_upgrade_plugin',
		backupbuddyRequestSiteID: parent.attr( 'website-id' ),
		type: 'plugin',
		'slugs[]': slug
	}

	if (bulk) {
		backupbuddy_bulkCurrentThreads++; }

	statusEl.html( '<i class="notched circle loading icon"></i>' );
	jQuery.post(ajaxurl, data, function (response) {
    statusEl.html( '' );
    pObj.removeClass( 'queue' );

    if (response && response['error']) {
      statusEl.html( '<i class="red times icon"></i>' );
    } else if (response && response['upgrades'][slug]) {
      pObj.remove();
      parent.removeClass( 'warning' );
    } else {
      statusEl.html( '<i class="red times icon"></i>' );
    }

		if (bulk) {
			backupbuddy_bulkCurrentThreads--;
			backupbuddy_bulkFinishedThreads++;
			mainwp_backupbuddy_plugin_upgrade_start_next( selector );
		}

	}, 'json');
	return false;
}

mainwp_backupbuddy_plugin_active_start_next = function (selector) {
	while ((objProcess = jQuery( selector + '.queue:first' )) && (objProcess.length > 0) && (objProcess.length > 0) && (backupbuddy_bulkCurrentThreads < backupbuddy_bulkMaxThreads)) {
		objProcess.removeClass( 'queue' );
		if (objProcess.closest( 'tr' ).find( '.check-column input[type="checkbox"]:checked' ).length == 0) {
			continue;
		}
		mainwp_backupbuddy_plugin_active_start_specific( objProcess, true, selector );
	}
}

mainwp_backupbuddy_plugin_active_start_specific = function (pObj, bulk, selector) {
  var parent = pObj.closest( 'tr' );
  var statusEl = parent.find( '.updating' );
  var slug = parent.attr( 'plugin-slug' );
	var data = {
		action: 'mainwp_backupbuddy_active_plugin',
		backupbuddyRequestSiteID: parent.attr( 'website-id' ),
		'plugins[]': [slug]
	}

	if (bulk) {
		backupbuddy_bulkCurrentThreads++; }

	statusEl.html( '<i class="notched circle loading icon"></i>' );
	jQuery.post(ajaxurl, data, function (response) {
    statusEl.html( '' );
    pObj.removeClass( 'queue' );
    if (response && response['error']) {
      statusEl.html( '<i class="red times icon"></i>' );
    } else if (response && response['result']) {
      parent.removeClass( 'negative' );
      pObj.remove();
    }
		if (bulk) {
			backupbuddy_bulkCurrentThreads--;
			backupbuddy_bulkFinishedThreads++;
			mainwp_backupbuddy_plugin_active_start_next( selector );
		}

	}, 'json');
	return false;
}

var backupbuddy_workingBox = '';

mainwp_backupbuddy_bulk_load_sites = function (pWhat, args) {
        var data = {
                action:'mainwp_backupbuddy_load_sites',
                what: pWhat,
                _backupbuddyNonce: mainwp_backupbuddy_loc.nonce
        };

        if (pWhat == 'general_settings' || pWhat == 'reset_defaults') {
            backupbuddy_workingBox = 'pb_backupbuddy_settings_tab_general';
        } else if (pWhat == 'advanced_settings') {
            backupbuddy_workingBox = 'pb_backupbuddy_settings_tab_advanced';
        } else if ('remote_save' == pWhat || 'remote_delete' == pWhat) {
            backupbuddy_workingBox = 'pb_backupbuddy_bulk_perform_content';
        } else if ('settings_other' == pWhat) {
            backupbuddy_workingBox = 'pb_backupbuddy_bulk_settings_other_content';
            data.other_action = args.other_action;
        } else if ('activate_package' == pWhat || 'save_license_settings' == pWhat) {
            backupbuddy_workingBox = 'pb_backupbuddy_bulk_license_settings_content';
        }

        jQuery('#' + backupbuddy_workingBox).html('<h2><i class="fa fa-spinner fa-pulse" style=""></i> Loading sites...<h2>');

        jQuery.post(ajaxurl, data, function (response) {
                if (response) {
                        jQuery('#' + backupbuddy_workingBox).html(response);
                        backupbuddy_bulkTotalThreads = jQuery('.siteItemProcess[status=queue]').length;
                        if (backupbuddy_bulkTotalThreads > 0) {
                            if (pWhat == 'general_settings' || pWhat == 'reset_defaults' || pWhat == 'advanced_settings' ) {
                                mainwp_backupbuddy_save_settings_start_next(pWhat);
                            } else if (pWhat == 'remote_save' || pWhat == 'remote_delete') {
                                mainwp_backupbuddy_remote_save_start_next(pWhat, args);
                            } else if ('settings_other' == pWhat) {
                                mainwp_backupbuddy_settings_other_start_next(pWhat, args);
                            } else if ('activate_package' == pWhat || 'save_license_settings' == pWhat) {
                                mainwp_backupbuddy_license_settings_start_next(pWhat, args);
                            }
                        }
                } else {
                        jQuery('#' + backupbuddy_workingBox).html('<div class="mainwp_info-box-red">' + __("Undefined error.") + '</div>');

                }
        })
}

mainwp_backupbuddy_save_settings_start_next = function(pType) {
	while ((objProcess = jQuery( '.siteItemProcess[status=queue]:first' )) && (objProcess.length > 0) && (backupbuddy_bulkCurrentThreads < backupbuddy_bulkMaxThreads)) {
		objProcess.attr( 'status', 'processed' );
		mainwp_backupbuddy_save_settings_start_specific( objProcess , pType );
	}
	if (backupbuddy_bulkFinishedThreads > 0 && backupbuddy_bulkFinishedThreads == backupbuddy_bulkTotalThreads) {
            jQuery( '#' + backupbuddy_workingBox ).append( '<div class="mainwp_info-box">' + __( "Save Settings finished." ) + '</div>' + '<p><a class="button-primary" href="admin.php?page=Extensions-Mainwp-Buddy-Extension&subpage=settings">Return to Settings</a></p>' );
	}


}

mainwp_backupbuddy_save_settings_start_specific = function(objProcess, pType) {
	var loadingEl = objProcess.find( 'i' );
	var statusEl = objProcess.find( '.status' );
	backupbuddy_bulkCurrentThreads++;
	var data = {
		action: 'mainwp_backupbuddy_save_settings',
                type: pType,
                backupbuddyRequestSiteID: objProcess.attr( 'site-id' ),
                _backupbuddyNonce: mainwp_backupbuddy_loc.nonce
	};
        if (pType == 'reset_defaults')
            data['keep_destinations'] = jQuery('input[name="buddy_keep_destinations"]').val();

	statusEl.html( '' );
	loadingEl.show();
	jQuery.post( ajaxurl, data, function ( response ) {
			loadingEl.hide();
                        if ( response) {
                                if (response.error) {
                                        statusEl.css( 'color', 'red' );
                                        statusEl.html( '<i class="fa fa-exclamation-circle"></i> ' + response.error );
                                } else if (response.result == 'SUCCESS') {
                                        var msg = __( 'Settings saved successfully to child site.' );
                                        if (response.message) {
                                            msg = response.message;
                                        }
                                        statusEl.css( 'color', '#21759B' );
                                        statusEl.html( '<i class="fa fa-check-circle"></i> ' + msg );
                                } else if (response.result == 'noupdate') {
                                        statusEl.css( 'color', '#21759B' );
                                        statusEl.html( __( 'No change.' ) );
                                } else if (response.message) {
                                        statusEl.css( 'color', '#21759B' );
                                        statusEl.html( response.message );
                                } else {
                                        statusEl.css( 'color', 'red' );
                                        statusEl.html( '<i class="fa fa-exclamation-circle"></i> ' + 'Undefined error' );
                                }
                        } else {
                                statusEl.css( 'color', 'red' );
                                statusEl.html( '<i class="fa fa-exclamation-circle"></i> ' + 'Undefined error' );
                        }

			backupbuddy_bulkCurrentThreads--;
			backupbuddy_bulkFinishedThreads++;
			mainwp_backupbuddy_save_settings_start_next( pType );
	}, 'json' );
}

mainwp_backupbuddy_bulk_perform_scheduled_backup = function (pScheId, pPerform, selectedSites, selectedGroups) {
        var data = {
                action:'mainwp_backupbuddy_load_sites',
                what: pPerform,
//                sites: selectedSites,
//                groups: selectedGroups,
                _backupbuddyNonce: mainwp_backupbuddy_loc.nonce
        };

        if (pPerform == 'save_scheduled_backup') {
            selectedSites = selectedSites.split(';');
            selectedGroups = selectedGroups.split(';');
            data['sites'] = selectedSites;
            data['groups'] = selectedGroups;
        }

        backupbuddy_workingBox = 'mwp_backupbuddy_edit_scheduled_backup_wrap';
        jQuery('#' + backupbuddy_workingBox).html('<h2><i class="fa fa-spinner fa-pulse" style=""></i> Loading sites...<h2>');
        jQuery.post(ajaxurl, data, function (response) {
                if (response) {
                        jQuery('#' + backupbuddy_workingBox).html(response);
                        backupbuddy_bulkTotalThreads = jQuery('.siteItemProcess[status=queue]').length;
                        if (backupbuddy_bulkTotalThreads > 0)
                                mainwp_backupbuddy_perform_scheduled_backup_start_next(pScheId, pPerform);
                } else {
                        jQuery('#' + backupbuddy_workingBox).html('<div class="mainwp_info-box-red">' + __("Undefined error.") + '</div>');

                }
        })
}

mainwp_backupbuddy_perform_scheduled_backup_start_next = function(pScheId, pPerform) {
	while ((objProcess = jQuery( '.siteItemProcess[status=queue]:first' )) && (objProcess.length > 0) && (backupbuddy_bulkCurrentThreads < backupbuddy_bulkMaxThreads)) {
		objProcess.attr( 'status', 'processed' );
		mainwp_backupbuddy_perform_scheduled_backup_start_specific( objProcess , pScheId, pPerform);
	}
	if (backupbuddy_bulkFinishedThreads > 0 && backupbuddy_bulkFinishedThreads == backupbuddy_bulkTotalThreads) {
            jQuery( '#' + backupbuddy_workingBox ).append( '<div class="mainwp_info-box">' + __( "Save Schedule finished." ) + '</div>' + '<p><a class="button-primary" href="admin.php?page=Extensions-Mainwp-Buddy-Extension&subpage=scheduling">Return to Schedules</a></p>' );
	}


}

mainwp_backupbuddy_perform_scheduled_backup_start_specific = function(objProcess, pScheId, pPerform) {
	var loadingEl = objProcess.find( 'i' );
	var statusEl = objProcess.find( '.status' );
	backupbuddy_bulkCurrentThreads++;
        var delSchedule = objProcess.attr('action') == 'delete' ? true : false; // delete schedule for unselected site
        var data = {
		action: 'mainwp_backupbuddy_perform_scheduled_backup',
                schedule_ids: pScheId,
                what: delSchedule ? 'delete_scheduled_backup' : pPerform,
                backupbuddyRequestSiteID: objProcess.attr( 'site-id' ),
                _backupbuddyNonce: mainwp_backupbuddy_loc.nonce
	};

	statusEl.html( '' );
	loadingEl.show();
	jQuery.post( ajaxurl, data, function ( response ) {
			loadingEl.hide();
                        if ( response) {
                                if (response.error) {
                                        statusEl.css( 'color', 'red' );
                                        statusEl.html( '<i class="fa fa-exclamation-circle"></i> ' + response.error );
                                } else if (response.result == 'SUCCESS') {
                                        var msg;
                                        if (delSchedule || pPerform == 'delete_scheduled_backup')
                                            msg = 'Deleted scheduled backup(s) successful.';
                                        else
                                            msg = 'Schedule saved successfully to child site.';
                                        statusEl.css( 'color', '#21759B' );
                                        statusEl.html( '<i class="fa fa-check-circle"></i> ' + msg );
                                } else {
                                        statusEl.css( 'color', 'red' );
                                        statusEl.html( '<i class="fa fa-exclamation-circle"></i> ' + 'Undefined error' );
                                }
                        } else {
                                statusEl.css( 'color', 'red' );
                                statusEl.html( '<i class="fa fa-exclamation-circle"></i> ' + 'Undefined error' );
                        }

			backupbuddy_bulkCurrentThreads--;
			backupbuddy_bulkFinishedThreads++;
			mainwp_backupbuddy_perform_scheduled_backup_start_next(pScheId, pPerform);
	}, 'json' );
}

mainwp_backupbuddy_general_save_profile = function(pItemId) {

    var errors = [];
    var selected_sites = [];
    var selected_groups = [];

    jQuery("input[name='selected_sites[]']:checked").each(function (i) {
        selected_sites.push(jQuery(this).val());
    });

    if (selected_sites.length == 0) {
        jQuery("input[name='selected_groups[]']:checked").each(function (i) {
            selected_groups.push(jQuery(this).val());
        });
    }

    if (selected_sites.length == 0 && selected_groups.length == 0 ) {
        jQuery('#select_by').val('site');
        errors.push('Please select websites or groups.');
        jQuery('#selected_sites').addClass('form-invalid');
    } else {
        jQuery('#selected_sites').removeClass('form-invalid');
    }

    jQuery('#mwp_backupbuddy_backup_errors').hide();

    if (errors.length > 0) {
        jQuery('#mwp_backupbuddy_backup_errors').html(errors.join('<br />')).show();
        return false;
    }
    mainwp_backupbuddy_bulk_perform_profile_action(pItemId, 'save_profile', '', '', selected_sites, selected_groups);
    return false;
}


mainwp_backupbuddy_bulk_perform_profile_action = function (pItemId, pWhatPerform, afterDest, deleteAfter, selectedSites, selectedGroups) {
        var data = {
                action:'mainwp_backupbuddy_load_sites',
                what: pWhatPerform,
                sites: selectedSites,
                groups: selectedGroups,
                _backupbuddyNonce: mainwp_backupbuddy_loc.nonce
        };
        backupbuddy_workingBox = 'mwp_backupbuddy_profile_box';
        jQuery('#' + backupbuddy_workingBox).html('<h2><i class="fa fa-spinner fa-pulse" style=""></i> Loading sites...<h2>');
        jQuery.post(ajaxurl, data, function (response) {
                if (response) {
                        jQuery('#' + backupbuddy_workingBox).html(response);
                        backupbuddy_bulkTotalThreads = jQuery('.siteItemProcess[status=queue]').length;
                        if (backupbuddy_bulkTotalThreads > 0) {
                            mainwp_backupbuddy_bulk_perform_profile_action_start_next(pItemId, pWhatPerform, afterDest, deleteAfter);
                        } else {

                        }
                } else {
                        jQuery('#' + backupbuddy_workingBox).html('<div class="mainwp_info-box-red">' + __("Undefined error.") + '</div>');

                }
        })
        return false;
}

mainwp_backupbuddy_bulk_perform_profile_action_start_next = function(pItemId, pWhatPerform, afterDest, deleteAfter) {
	while ((objProcess = jQuery( '.siteItemProcess[status=queue]:first' )) && (objProcess.length > 0) && (backupbuddy_bulkCurrentThreads < backupbuddy_bulkMaxThreads)) {
		objProcess.attr( 'status', 'processed' );
		mainwp_backupbuddy_bulk_perform_profile_action_start_specific( objProcess , pItemId, pWhatPerform, afterDest, deleteAfter);
	}
	if (backupbuddy_bulkFinishedThreads > 0 && backupbuddy_bulkFinishedThreads == backupbuddy_bulkTotalThreads) {
            var msg = __( "Saving profile finished." );
            if (pWhatPerform == 'create_backup')
               msg = __( "Creating backup(s) started." )
            jQuery( '#' + backupbuddy_workingBox ).append( '<div class="mainwp_info-box">' + msg + '</div>' + '<p><a class="button-primary" href="admin.php?page=Extensions-Mainwp-Buddy-Extension&subpage=backup">Return to Backup</a></p>' );
	}


}

mainwp_backupbuddy_bulk_perform_profile_action_start_specific = function(objProcess, pItemId, pWhatPerform, afterDest, deleteAfter) {
	var loadingEl = objProcess.find( 'i' );
	var statusEl = objProcess.find( '.status' );
	backupbuddy_bulkCurrentThreads++;

        var data = {
		action: 'mainwp_backupbuddy_perform_profile_action',
                profile_id: pItemId,
                what: pWhatPerform,
                backupbuddyRequestSiteID: objProcess.attr( 'site-id' ),
                _backupbuddyNonce: mainwp_backupbuddy_loc.nonce
	};

        if (typeof afterDest !== undefined) {
            data.after_destination = afterDest;
        }

        if (typeof deleteAfter !== undefined) {
            data.delete_after = deleteAfter;
        }

	statusEl.html( '' );
	loadingEl.show();
	jQuery.post( ajaxurl, data, function ( response ) {
			loadingEl.hide();
                        if ( response) {
                                if (response.error) {
                                        statusEl.css( 'color', 'red' );
                                        statusEl.html( '<i class="fa fa-exclamation-circle"></i> ' + response.error );
                                } else if (response.result == 'SUCCESS') {
                                        var msg;
                                        if (pWhatPerform == 'delete_profile')
                                            msg = 'Deleted profile successful.';
                                        else if (pWhatPerform == 'create_backup')
                                            msg = 'Create backup started.';
                                        else
                                            msg = 'Profile saved successfully to child site.';
                                        statusEl.css( 'color', '#21759B' );
                                        statusEl.html( '<i class="fa fa-check-circle"></i> ' + msg );
                                } else {
                                        statusEl.css( 'color', 'red' );
                                        statusEl.html( '<i class="fa fa-exclamation-circle"></i> ' + 'Undefined error' );
                                }
                        } else {
                                statusEl.css( 'color', 'red' );
                                statusEl.html( '<i class="fa fa-exclamation-circle"></i> ' + 'Undefined error' );
                        }

			backupbuddy_bulkCurrentThreads--;
			backupbuddy_bulkFinishedThreads++;
			mainwp_backupbuddy_bulk_perform_profile_action_start_next(pItemId, pWhatPerform, afterDest, deleteAfter);
	}, 'json' );
}

mainwp_backupbuddy_bulk_run_scheduled_backup = function(sche_id) {
        var data = {
            action:'mainwp_backupbuddy_load_sites',
            what: 'run_schedule',
            schedule_id: sche_id,
            _backupbuddyNonce: mainwp_backupbuddy_loc.nonce
        };
        backupbuddy_workingBox = 'mwp_backupbuddy_edit_scheduled_backup_wrap';
        jQuery('#' + backupbuddy_workingBox).html('<h2><i class="fa fa-spinner fa-pulse" style=""></i> Loading sites...<h2>');
        jQuery.post(ajaxurl, data, function (response) {
                if (response) {
                        jQuery('#' + backupbuddy_workingBox).html(response);
                        backupbuddy_bulkTotalThreads = jQuery('.siteItemProcess[status=queue]').length;
                        if (backupbuddy_bulkTotalThreads > 0)
                                mainwp_backupbuddy_bulk_run_scheduled_start_next(sche_id);
                } else {
                        jQuery('#' + backupbuddy_workingBox).html('<div class="mainwp_info-box-red">' + __("Undefined error.") + '</div>');

                }
        })
}

mainwp_backupbuddy_bulk_run_scheduled_start_next = function(sche_id) {
        while ((objProcess = jQuery( '.siteItemProcess[status=queue]:first' )) && (objProcess.length > 0) && (backupbuddy_bulkCurrentThreads < backupbuddy_bulkMaxThreads)) {
                objProcess.attr( 'status', 'processed' );
                mainwp_backupbuddy_bulk_run_scheduled_start_specific( objProcess, sche_id );
        }
        if (backupbuddy_bulkFinishedThreads > 0 && backupbuddy_bulkFinishedThreads == backupbuddy_bulkTotalThreads) {
                jQuery( '#' + backupbuddy_workingBox ).append( '<div class="mainwp_info-box">' + __( "Run Scheduled Backup finished." ) + '</div>' + '<p><a class="button-primary" href="admin.php?page=Extensions-Mainwp-Buddy-Extension&subpage=scheduling">Return to Schedules</a></p>' );
        }
}

mainwp_backupbuddy_bulk_run_scheduled_start_specific = function(objProcess, sche_id) {
        var loadingEl = objProcess.find( 'i' );
        var statusEl = objProcess.find( '.status' );
        backupbuddy_bulkCurrentThreads++;

        var data = {
                action: 'mainwp_backupbuddy_run_scheduled_backup',
                backupbuddyRequestSiteID: objProcess.attr( 'site-id' ),
                schedule_id: sche_id,
                _backupbuddyNonce: mainwp_backupbuddy_loc.nonce,
        };

        statusEl.html( '' );
        loadingEl.show();
        jQuery.post( ajaxurl, data, function ( response ) {
            loadingEl.hide();
            if (response) {
                    if (response.error) {
                        statusEl.css('color', 'red');
                        statusEl.html('<i class="fa fa-exclamation-circle"></i> ' + response.error);
                    } else if (response.result == 'SUCCESS') {
                        statusEl.css('color', '#21759B');
                        statusEl.html('<i class="fa fa-check-circle"></i> ' + 'Successful');
                    } else {
                        statusEl.css('color', 'red');
                        statusEl.html('<i class="fa fa-exclamation-circle"></i> ' + 'Undefined Error');
                    }
            } else {
                    statusEl.css('color', 'red');
                    statusEl.html('<i class="fa fa-exclamation-circle"></i> ' + 'Undefined Error');
            }
            backupbuddy_bulkCurrentThreads--;
            backupbuddy_bulkFinishedThreads++;
            mainwp_backupbuddy_bulk_run_scheduled_start_next(sche_id);
        }, 'json' );
}

mainwp_backupbudd_open_child_site = function(website_id, url) {
        $http.post(ajaxurl, {
            'action': 'mainwp_backwpup_open_child_site',
            'website_id': website_id,
            'open_location': url,
            'wp_nonce': backwpup_extension_security_nonce['open_child_site']
        }).success(function (d) {
            if (mainwp_backwpup_check_error_in_request(d, "open_child_site")) {
                window.open(d.data.url);
            }
        }).error(function () {
            mainwp_backwpup_display_error(mainwp_backwpup_generic_error("open_child_site.error"));
        });

         var data = {
                action: 'mainwp_backupbuddy_open_child_site',
                backupbuddyRequestSiteID: website_id,
                open_location: url,
                _backupbuddyNonce: mainwp_backupbuddy_loc.nonce,
        };

        jQuery.post( ajaxurl, data, function ( response ) {
            loadingEl.hide();
            if (response) {
                    if (response.error) {
                        statusEl.css('color', 'red');
                        statusEl.html('<i class="fa fa-exclamation-circle"></i> ' + response.error);
                    } else if (response.result == 'SUCCESS') {
                        statusEl.css('color', '#21759B');
                        statusEl.html('<i class="fa fa-check-circle"></i> ' + 'Successful');
                    } else {
                        statusEl.css('color', 'red');
                        statusEl.html('<i class="fa fa-exclamation-circle"></i> ' + 'Undefined Error');
                    }
            } else {
                    statusEl.css('color', 'red');
                    statusEl.html('<i class="fa fa-exclamation-circle"></i> ' + 'Undefined Error');
            }
            backupbuddy_bulkCurrentThreads--;
            backupbuddy_bulkFinishedThreads++;
            mainwp_backupbuddy_bulk_run_scheduled_start_next(sche_id);
        }, 'json' );

}


mainwp_backupbuddy_remote_save_start_next = function(pWhat, args) {
        while ((objProcess = jQuery( '.siteItemProcess[status=queue]:first' )) && (objProcess.length > 0) && (backupbuddy_bulkCurrentThreads < backupbuddy_bulkMaxThreads)) {
                objProcess.attr( 'status', 'processed' );
                mainwp_backupbuddy_remote_save_start_specific( objProcess , pWhat, args );
        }
        if (backupbuddy_bulkFinishedThreads > 0 && backupbuddy_bulkFinishedThreads == backupbuddy_bulkTotalThreads) {
            var msg = __( "Save Remote Destinations finished." );
            if (pWhat == 'remote_delete')
                msg = __( "Delete Remote Destinations finished." );
            jQuery('#' + backupbuddy_workingBox ).append( '<div class="mainwp_info-box">' + msg + '</div>' + '<p><a class="button-primary" href="admin.php?page=Extensions-Mainwp-Buddy-Extension&subpage=destinations">Return to Remote Destinations</a></p>' );
        }


}

mainwp_backupbuddy_remote_save_start_specific = function(objProcess, pWhat, args) {
        var loadingEl = objProcess.find( 'i' );
        var statusEl = objProcess.find( '.status' );
        backupbuddy_bulkCurrentThreads++;
        var data = {
                action: 'mainwp_backupbuddy_perform_action',
                what: pWhat,
                destination_id: args.destination_id,
                backupbuddyRequestSiteID: objProcess.attr( 'site-id' ),
                _backupbuddyNonce: mainwp_backupbuddy_loc.nonce
        };

        statusEl.html( '' );
        loadingEl.show();
        jQuery.post( ajaxurl, data, function ( response ) {
                        loadingEl.hide();
                        if ( response) {
                                if (response.error) {
                                        statusEl.css( 'color', 'red' );
                                        statusEl.html( '<i class="fa fa-exclamation-circle"></i> ' + response.error );
                                } else if (response.ok == 1) {
                                        var msg = __( 'Remote Destination saved successfully to child site.' );
                                        if (pWhat == 'remote_delete')
                                            var msg = __( 'Remote Destination deleted successfully on child site.' );

                                        if (response.message) {
                                            msg = response.message;
                                        }
                                        statusEl.css( 'color', '#21759B' );
                                        statusEl.html( '<i class="fa fa-check-circle"></i> ' + msg );
                                } else {
                                        statusEl.css( 'color', 'red' );
                                        statusEl.html( '<i class="fa fa-exclamation-circle"></i> ' + 'Undefined error' );
                                }
                        } else {
                                statusEl.css( 'color', 'red' );
                                statusEl.html( '<i class="fa fa-exclamation-circle"></i> ' + 'Undefined error' );
                        }

                        backupbuddy_bulkCurrentThreads--;
                        backupbuddy_bulkFinishedThreads++;
                        mainwp_backupbuddy_remote_save_start_next( pWhat, args );
        }, 'json' );
}

mainwp_backupbuddy_settings_other_start_next = function(pWhat, args) {
        while ((objProcess = jQuery( '.siteItemProcess[status=queue]:first' )) && (objProcess.length > 0) && (backupbuddy_bulkCurrentThreads < backupbuddy_bulkMaxThreads)) {
                objProcess.attr( 'status', 'processed' );
                mainwp_backupbuddy_settings_other_start_specific( objProcess , pWhat, args );
        }
        if (backupbuddy_bulkFinishedThreads > 0 && backupbuddy_bulkFinishedThreads == backupbuddy_bulkTotalThreads) {
            var msg = __( "Finished." );
            jQuery('#' + backupbuddy_workingBox ).append( '<div class="mainwp_info-box">' + msg + '</div>' + '<p><a class="button-primary" href="admin.php?page=Extensions-Mainwp-Buddy-Extension&subpage=settings&tab=2">Return to Settings Other</a></p>' );
        }


}

mainwp_backupbuddy_settings_other_start_specific = function(objProcess, pWhat, args) {
        var loadingEl = objProcess.find( 'i' );
        var statusEl = objProcess.find( '.status' );
        backupbuddy_bulkCurrentThreads++;
        var data = {
                  action: 'mainwp_backupbuddy_perform_action',
                  what: 'settings_other',
                  other_action: args.other_action,
                  backupbuddyRequestSiteID: objProcess.attr( 'site-id' ),
                  _backupbuddyNonce: mainwp_backupbuddy_loc.nonce
              }
        statusEl.html( '' );
        loadingEl.show();

        jQuery.post(ajaxurl, data, function (response) {
                loadingEl.hide();
                var err = '', msg = '';
                if ( response) {
                    if (response.error) {
                        err = response.error;
                    } else if (response._error) {
                        err = response._error;
                    } else if (response._message) {
                        msg = response._message;
                    } else {
                        err = __('Undefined error');
                    }
                } else {
                    err = __('Undefined error');
                }

                if (err) {
                    statusEl.css( 'color', 'red' );
                    statusEl.html( '<i class="fa fa-exclamation-circle"></i> ' + err ).show();
                } else if (msg) {
                    statusEl.css( 'color', '#21759B' );
                    statusEl.html( '<i class="fa fa-check-circle"></i> ' + msg ).show();
                }

                backupbuddy_bulkCurrentThreads--;
                backupbuddy_bulkFinishedThreads++;
                mainwp_backupbuddy_settings_other_start_next( pWhat, args );

        }, 'json')
}

mainwp_backupbuddy_license_settings_start_next = function(pWhat, args) {
        while ((objProcess = jQuery( '.siteItemProcess[status=queue]:first' )) && (objProcess.length > 0) && (backupbuddy_bulkCurrentThreads < backupbuddy_bulkMaxThreads)) {
                objProcess.attr( 'status', 'processed' );
                mainwp_backupbuddy_license_settings_start_specific( objProcess , pWhat, args );
        }
        if (backupbuddy_bulkFinishedThreads > 0 && backupbuddy_bulkFinishedThreads == backupbuddy_bulkTotalThreads) {
            var msg = __( "Finished." );
            jQuery('#' + backupbuddy_workingBox ).append( '<div class="mainwp_info-box">' + msg + '</div>' + '<p><a class="button-primary" href="admin.php?page=Extensions-Mainwp-Buddy-Extension&subpage=settings&tab=3">Return to Licensing</a></p>' );
        }
}

mainwp_backupbuddy_license_settings_start_specific = function(objProcess, pWhat, args) {
        var loadingEl = objProcess.find( 'i' );
        var statusEl = objProcess.find( '.status' );
        backupbuddy_bulkCurrentThreads++;
        var data = {
                  action: 'mainwp_backupbuddy_perform_action',
                  what: 'license_settings',
                  post_data: args.post_data,
                  backupbuddyRequestSiteID: objProcess.attr( 'site-id' ),
                  _backupbuddyNonce: mainwp_backupbuddy_loc.nonce
              }
        statusEl.html( '' );
        loadingEl.show();

        jQuery.post(ajaxurl, data, function (response) {
                loadingEl.hide();
                var err = '', msg = '';
                if ( response) {
                    if (response.error) {
                        err = response.error;
                    } else if (response.errors) {
                        err = response.error;
                    } else if (response.soft_errors) {
                        err = response.soft_errors;
                    } else if (response.messages) {
                        msg = response.messages;
                    } else if (response.ok) {
                        msg = __('Successful');
                    } else {
                        err = __('Undefined error');
                    }
                } else {
                    err = __('Undefined error');
                }

                if (err) {
                    statusEl.css( 'color', 'red' );
                    statusEl.html( '<i class="fa fa-exclamation-circle"></i> ' + err ).show();
                } else if (msg) {
                    statusEl.css( 'color', '#21759B' );
                    statusEl.html( '<i class="fa fa-check-circle"></i> ' + msg ).show();
                }

                backupbuddy_bulkCurrentThreads--;
                backupbuddy_bulkFinishedThreads++;
                mainwp_backupbuddy_license_settings_start_next( pWhat, args );

        }, 'json')
}
