<?php
// Incoming variables: $backup from controllers/pages/_backup_home.php

if ( '1' == pb_mainwp_backupbuddy::_GET( 'skip_quicksetup' ) ) {
	pb_mainwp_backupbuddy::$options['skip_quicksetup'] = '1';
	pb_mainwp_backupbuddy::save();
}

$addition_url = '&subpage=backup';
$addition_popup_url = '';
$site_id= 0;

if(MainWP_BackupBuddy::is_manage_site()) {
	$site_id = MainWP_BackupBuddy::get_manager_site_id();
	$addition_url .='&id=' . $site_id;
	$addition_popup_url= '&buddy_manage_site_id=' . $site_id;
}
if ( $site_id ) {
	?>
	<div class="mainwp-actions-bar">
		<div class="ui grid">
			<div class="ui right aligned column">
				<a href="#" id="mwp_backupbuddy_reload_backups_list" site-id="<?php echo $site_id; ?>" class="ui mini green button"><?php _e('Reload BackupBuddy Data', 'it-l10n-mainwp-backupbuddy'); ?></a>
				<span class="working" style="display: none">
					<div class="ui active inverted dimmer">
					 <div class="ui text loader">Loading</div>
				 </div>
				</span>
			</div>
		</div>
	</div>


	<?php
}


wp_enqueue_script( 'thickbox' );
wp_print_scripts( 'thickbox' );
wp_print_styles( 'thickbox' );


// Handle deleting profile.
if ( ( pb_mainwp_backupbuddy::_GET( 'delete_profile' ) != '' ) && ( is_numeric( pb_mainwp_backupbuddy::_GET( 'delete_profile' ) ) ) ) {
	if ( pb_mainwp_backupbuddy::_GET( 'delete_profile' ) > 2 ) {
                $error = '';
                if ($site_id) {
                    $error = MainWP_BackupBuddy::ajax_check_individual_action( $site_id, $individual = true, $return = true );
                }
                if (!empty($error)) {
                    pb_mainwp_backupbuddy::alert( $error, true );
                } else {
                    if ( isset( pb_mainwp_backupbuddy::$options['profiles'][pb_mainwp_backupbuddy::_GET( 'delete_profile' )] ) ) {
                            $_old_profile = pb_mainwp_backupbuddy::$options['profiles'][pb_mainwp_backupbuddy::_GET( 'delete_profile' )];
                            $profile_title = $_old_profile ['title'];
                            unset( pb_mainwp_backupbuddy::$options['profiles'][pb_mainwp_backupbuddy::_GET( 'delete_profile' )] );
                            pb_mainwp_backupbuddy::save();
                            pb_mainwp_backupbuddy::alert( 'Deleted profile "' . htmlentities( $profile_title ) . '".' );
                            $_sites = $_groups = '';
                            if (empty($site_id)) {
                                $_sites = isset($_old_profile ['sites']) ?  $_old_profile ['sites'] : '';
                                $_groups = isset($_old_profile ['groups']) ?  $_old_profile ['groups'] : '';
                            }
                            $action_value = array('what' => 'delete_profile', 'profile_id' => pb_mainwp_backupbuddy::_GET( 'delete_profile' ), 'sites' => $_sites, 'groups' => $_groups );
                            add_option('mainwp_backbuddy_perform_profile_action', $action_value);
                    }
                }
	} else {
		pb_mainwp_backupbuddy::alert( 'Invalid profile ID. Cannot delete base profiles.' );
	}
}


// Quickwizard just completed.
//if ( isset( $_GET['quickstart_wizard'] ) && ( '' != $_GET['quickstart_wizard'] ) ) {
//	pb_mainwp_backupbuddy::disalert( 'quickstart_wizard_finished', __( 'Quick Setup Wizard complete. Select a backup profile below to start backing up. See the <a href="admin.php?page=pb_backupbuddy_settings" target="_blank">Settings</a> page for all configuration options.', 'it-l10n-mainwp-backupbuddy' ) );
//}

// Add new profile.
if ( pb_mainwp_backupbuddy::_POST( 'add_profile' ) == 'true' ) {
        $error_overrided = '';
        if ($site_id) {
            $error_overrided = MainWP_BackupBuddy::ajax_check_individual_action( $site_id, $individual = true, $return = true );
                if (!empty($error_overrided)) {
                    pb_mainwp_backupbuddy::alert( $error_overrided, true );
                }
        }
        if (empty($error_overrided)) {
            pb_mainwp_backupbuddy::verify_nonce();
            $error = false;
            if ( pb_mainwp_backupbuddy::_POST( 'title' ) == '' ) {
                    pb_mainwp_backupbuddy::alert( 'Error: You must provide a new profile title.', true );
                    $error = true;
            }
            if ( false === $error ) {
                    $profile = array(
                            'title'		=> htmlentities( pb_mainwp_backupbuddy::_POST( 'title' ) ),
                            'type'		=> pb_mainwp_backupbuddy::_POST( 'type' ),
                    );
                    $profile = array_merge( pb_mainwp_backupbuddy::settings( 'profile_defaults' ), $profile );

                    if (empty($site_id)) {
                        $profile['sites'] = $_POST['mainwp_backupbuddy_backup_sites'];
                        $profile['groups'] = $_POST['mainwp_backupbuddy_backup_groups'];
                    }

                    pb_mainwp_backupbuddy::$options['profiles'][] = $profile;
                    pb_mainwp_backupbuddy::save();
                    pb_mainwp_backupbuddy::alert( 'New profile "' . htmlentities( pb_mainwp_backupbuddy::_POST( 'title' ) ) . '" added. Select it from the list below to customize its settings and override global defaults.' );
                    $action_value = array('what' => 'save_profile', 'profile_id' => max( array_keys( pb_mainwp_backupbuddy::$options['profiles'])));
                    add_option('mainwp_backbuddy_perform_profile_action', $action_value);
            }
        }
} // end if add profile.


?>

<script type="text/javascript">
	jQuery(document).ready(function() {
		jQuery( '.profile_item_select' ).click( function() {
                    <?php if ($site_id) { ?>
                                jQuery('#mwp_backupbuddy_backup_errors').hide();
                                if (jQuery('#mainwp_backupbuddy_override_settings_value').val() == 0) {
                                    jQuery('#mwp_backupbuddy_backup_errors').html('To Run a backup for this site, you need to set the Override General Settings option to Yes.').fadeIn(1000);
                                    return false;
                                }
                                var url = jQuery(this).attr( 'href' );
                                url = url + '&after_destination=' + jQuery( '#pb_backupbuddy_backup_remotedestination' ).val();
                                url = url + '&delete_after=' + jQuery( '#pb_backupbuddy_backup_deleteafter' ).val();
                                window.location.href = url;
                    <?php  } else { ?>
                            var errors = [];
                            if (jQuery('#select_by').val() == 'site') {
                                var selected_sites = [];
                                jQuery("input[name='selected_sites[]']:checked").each(function (i) {
                                    selected_sites.push(jQuery(this).val());
                                });
                                if (selected_sites.length == 0) {
                                    errors.push('Please select websites or groups.');

                                }
                                else {

                                }
                            }
                            else {
                                var selected_groups = [];
                                jQuery("input[name='selected_groups[]']:checked").each(function (i) {
                                    selected_groups.push(jQuery(this).val());
                                });
                                if (selected_groups.length == 0) {
                                    errors.push(__('Please select websites or groups.'));

                                }
                                else {

                                }
                            }
                            jQuery('#mwp_backupbuddy_backup_errors').hide();
                            if (errors.length > 0) {
                                jQuery('#mwp_backupbuddy_backup_errors').html(errors.join('<br />')).show();
                            } else {
                                jQuery('.mainwp_bb_left_select_sites_wrap').remove();
                                mainwp_backupbuddy_bulk_perform_profile_action( jQuery(this).attr( 'profile-id' ), 'create_backup', jQuery( '#pb_backupbuddy_backup_remotedestination' ).val(), jQuery( '#pb_backupbuddy_backup_deleteafter' ).val(), selected_sites, selected_groups );
                            }

                    <?php  } ?>
			return false;

		});



		// Click label for after backup remote send.
		jQuery( '#pb_backupbuddy_afterbackupremote' ).click( function(e) {
			var checkbox = jQuery( '#pb_backupbuddy_afterbackupremote_box' );
			checkbox.prop('checked', !checkbox[0].checked);

			if ( checkbox[0].checked ) { // Only show if just checked.
				afterbackupremote();
			}
			return false;
		});


		// Click checkbox for after backup remote send.
		jQuery( '#pb_backupbuddy_afterbackupremote_box' ).click( function(e) {
			var checkbox = jQuery( '#pb_backupbuddy_afterbackupremote_box' );
			if ( checkbox[0].checked ) { // Only show if just checked.
				afterbackupremote();
			}
		});


		// Click profile config gear next to a profile to pop up modal for editing its settings.
		jQuery( '.profile_settings' ).click( function(e) {
			tb_show( 'BackupBuddy', '<?php echo pb_mainwp_backupbuddy::ajax_url( 'profile_settings' ) . $addition_popup_url ; ?>&profile=' + jQuery(this).attr( 'rel' ) + '&callback_data=' + jQuery(this).attr('rel') + '&TB_iframe=1&width=640&height=455', null );
			return false;
		});


		// Clicked + sign to add a new profile.
		jQuery( '#pb_backupbuddy_profileadd_plusbutton' ).click( function() {
			jQuery(this).hide();
			jQuery( '#pb_backupbuddy_profileadd' ).slideDown();
			return false;
		});


		// Click meta option in backup list to send a backup to a remote destination.
		jQuery( '.pb_backupbuddy_hoveraction_send' ).click( function(e) {
			tb_show( 'BackupBuddy', '<?php echo pb_mainwp_backupbuddy::ajax_url( 'destination_picker' ) . $addition_popup_url; ?>&callback_data=' + jQuery(this).attr('rel') + '&sending=1&action_verb=to%20send%20to<?php echo $addition_popup_url; ?>&TB_iframe=1&width=640&height=455', null );
			return false;
		});


		// Backup listing View Hash meta clicked.
		jQuery( '.pb_backupbuddy_hoveraction_hash' ).click( function(e) {
			tb_show( 'BackupBuddy', '<?php echo pb_mainwp_backupbuddy::ajax_url( 'hash' ); ?>&callback_data=' + jQuery(this).attr('rel') + '<?php echo $addition_popup_url; ?>&TB_iframe=1&width=640&height=455', null );
			return false;
		});

		// Click the meta option in the backup list to apply a note to a backup.
		jQuery( '.pb_backupbuddy_hoveraction_note' ).click( function(e) {

			var existing_note = jQuery(this).parents( 'td' ).find('.pb_backupbuddy_notetext').text();
			if ( existing_note == '' ) {
				existing_note = 'My first backup';
			}

			var note_text = prompt( '<?php _e( 'Enter a short descriptive note to apply to this archive for your reference. (175 characters max)', 'it-l10n-mainwp-backupbuddy' ); ?>', existing_note );
			if ( ( note_text == null ) || ( note_text == '' ) ) {
				// User cancelled.
			} else {
                                jQuery( '.pb_backupbuddy_backuplist_loading' ).show();
				var args = {
						backupbuddyRequestSiteID: <?php echo intval($site_id); ?>,
						backup_file: jQuery(this).attr('rel'),
						note: note_text
					};
				jQuery.post( '<?php echo pb_mainwp_backupbuddy::ajax_url( 'set_backup_note' ); ?>', args,
					function(data) {
						data = jQuery.trim( data );
						jQuery( '.pb_backupbuddy_backuplist_loading' ).hide();
						if ( data != '1' ) {
							alert( "<?php _e('Error', 'it-l10n-mainwp-backupbuddy' );?>: " + data );
						}
						javascript:location.reload(true);
					}
				);
			}
			return false;
		});

                jQuery( '.mwp_bb_download_backup_lnk, .pb_backupbuddy_hoveraction_download_archive' ) .click( function(e) {
                    var workingEl = jQuery( this ).closest('tr').find('span.working');
                    var url = jQuery( this ).closest('tr').find('a.mwp_bb_download_backup_lnk').attr('download-url');

                    workingEl.html('<i class="fa fa-spinner fa-pulse" style=""></i> Running...').show();
                    var args = {
                                    backupbuddyRequestSiteID: <?php echo intval($site_id); ?>,
                                    url: url
                            };
                    jQuery.post( '<?php echo pb_mainwp_backupbuddy::ajax_url( 'download_archive' ); ?>', args,
                            function(data) {
                                    workingEl.hide();
                                    if ( data && data.url) {
                                         window.open(data.url);
                                    } else {
                                        alert( "<?php _e('Error', 'it-l10n-mainwp-backupbuddy' );?>: " + data );
                                    }
                            }
                    , 'json');
                    return false;
                })

		jQuery( '.mainwp_bb_view_details_lnk' ).on('click', function () {
			tb_show( 'Backup Status', '<?php echo pb_mainwp_backupbuddy::ajax_url( 'integrity_status' ); ?>&serial=' + jQuery(this).attr('serial') + '<?php echo $addition_popup_url; ?>&TB_iframe=1&width=640&height=600', null );
		});

		jQuery( '.mainwp_bb_view_log_lnk' ).on('click', function () {
			tb_show( 'View Backup Log', '<?php echo pb_mainwp_backupbuddy::ajax_url( 'view_log' ); ?>&serial=' + jQuery(this).attr('serial') + '<?php echo $addition_popup_url; ?>&TB_iframe=1&width=640&height=600', null );
		});

                jQuery( '.mwp_bb_reset_integrity_lnk' ) .click( function(e) {
                    var workingEl = jQuery( this ).closest('tr').find('span.working');
                    workingEl.html('<i class="fa fa-spinner fa-pulse" style=""></i> Running...').show();

                    var args = {
                                    backupbuddyRequestSiteID: <?php echo intval($site_id); ?>,
                                    reset_integrity: jQuery(this).attr('serial')
                            };
                    jQuery.post( '<?php echo pb_mainwp_backupbuddy::ajax_url( 'reset_integrity' ); ?>', args,
                            function(data) {
                                    workingEl.hide();
                                    data = jQuery.trim( data );
                                    if ( data != '1' ) {
                                            alert( "<?php _e('Error', 'it-l10n-mainwp-backupbuddy' );?>: " + data );
                                    }
                                    javascript:location.reload(true);
                            }
                    );
                    return false;
                })

                jQuery( '#mwp_backupbuddy_reload_backups_list' ) .click( function(e) {
                        var workingEL = jQuery( this ).closest('span').find('.working');
                        workingEL.css( 'color', '#21759B' );
                        data = {
                                action: 'mainwp_backupbuddy_reload_backups_list',
                                backupbuddyRequestSiteID: jQuery( this ).attr('site-id'),
                                _backupbuddyNonce: mainwp_backupbuddy_loc.nonce,
                        };

                        workingEL.html('<i class="fa fa-spinner fa-pulse"></i>').show();
                        jQuery.post(ajaxurl, data, function (response) {
                                    workingEL.hide();
                                    var str_err = '';
                                    var str_mess = '';
                                    if (response) {
                                            if (response.error) {
                                                    str_err = '<i class="fa fa-exclamation-circle"></i> ' + response.error;
                                            } else if (response.result == 'SUCCESS') {
                                                    str_mess = '<i class="fa fa-check-circle"></i> ' + __( 'Finished' );
                                                    location.href = location.href;
                                            } else {
                                                    str_err = '<i class="fa fa-exclamation-circle"></i> ' + 'Undefined Error';
                                            }
                                    } else {
                                                    str_err = '<i class="fa fa-exclamation-circle"></i> ' + 'Undefined Error';
                                    }

                                    if (str_err != '') {
                                            workingEL.css( 'color', 'red' );
                                            workingEL.html(str_err).show();
                                    } else if (str_mess != '') {
                                            workingEL.css( 'color', '#21759B' );
                                            workingEL.html(str_mess).show();
                                            setTimeout(function ()
                                            {
                                                    workingEL.fadeOut();
                                            }, 3000);
                                    }
                            }, 'json');
                            return false;
                });



                    jQuery('#mwp_bb_save_backup_btn').click(function(e) {
                     <?php if (empty($site_id)) { ?>
                                var errors = [];
                                var selected_sites = [];
                                var selected_groups = [];

                                if (jQuery('#select_by').val() == 'site') {
                                    jQuery("input[name='selected_sites[]']:checked").each(function (i) {
                                        selected_sites.push(jQuery(this).val());
                                    });
                                    if (selected_sites.length == 0) {
                                        errors.push('Please select websites or groups.');
                                        jQuery('#selected_sites').addClass('form-invalid');
                                    }
                                    else {
                                        jQuery('#selected_sites').removeClass('form-invalid');
                                    }
                                }
                                else {
                                    jQuery("input[name='selected_groups[]']:checked").each(function (i) {
                                        selected_groups.push(jQuery(this).val());
                                    });
                                    if (selected_groups.length == 0) {
                                        errors.push(__('Please select websites or groups.'));
                                        jQuery('#selected_groups').addClass('form-invalid');
                                    }
                                    else {
                                        jQuery('#selected_groups').removeClass('form-invalid');
                                    }
                                }

                                jQuery('#mwp_backupbuddy_backup_errors').hide();

                                if (errors.length > 0) {
                                    jQuery('#mwp_backupbuddy_backup_errors').html(errors.join('<br />')).show();
                                    return false;
                                }
                                jQuery('#mainwp_backupbuddy_backup_sites').val(selected_sites.join(';'));
                                jQuery('#mainwp_backupbuddy_backup_groups').val(selected_groups.join(';'));

                            <?php } else { ?>
                                    jQuery('#mwp_backupbuddy_backup_errors').hide();
                                    if (jQuery('#mainwp_backupbuddy_override_settings_value').val() == 0) {
                                        jQuery('#mwp_backupbuddy_backup_errors').html('To Add a backup for this site, you need to set the Override General Settings option to Yes.').fadeIn(1000);
                                        return false;
                                    }
                            <?php } ?>
                    });



	}); // end jquery document ready.

	function pb_backupbuddy_profile_updated( profileID, profileTitle ) {
		jQuery( '#profile_title_' + profileID ).text( profileTitle );
	}


	function pb_mainwp_backupbuddy_selectdestination( destination_id, destination_title, callback_data, delete_after, mode ) {

		if ( ( callback_data != '' ) && ( callback_data != 'delayed_send' ) ) {
			jQuery.post( '<?php echo pb_mainwp_backupbuddy::ajax_url( 'remote_send' ); ?>', { destination_id: destination_id, destination_title: destination_title, file: callback_data, trigger: 'manual', delete_after: delete_after, buddy_manage_site_id: <?php echo intval($site_id); ?>  },
				function(data) {
					data = jQuery.trim( data );
					if ( data.charAt(0) != '1' ) {
						alert( "<?php _e("Error starting remote send", 'it-l10n-mainwp-backupbuddy' ); ?>:" + "\n\n" + data );
					} else {
						if ( delete_after == true ) {
							var delete_alert = "<?php _e( 'The local backup will be deleted upon successful transfer as selected.', 'it-l10n-mainwp-backupbuddy' ); ?>";
						} else {
							var delete_alert = '';
						}
						alert( "<?php _e('Your file has been scheduled to be sent now. It should arrive shortly.', 'it-l10n-mainwp-backupbuddy' ); ?> <?php _e( 'You will be notified by email if any problems are encountered.', 'it-l10n-mainwp-backupbuddy' ); ?>" + " " + delete_alert + "\n\n" + data.slice(1) );
						/* Try to ping server to nudge cron along since sometimes it doesnt trigger as expected. */
						jQuery.post( '<?php echo admin_url('admin-ajax.php'); ?>',
							function(data) {
							}
						);
					}
				}
			);
		} else if ( callback_data == 'delayed_send' ) { // Specified a destination to send to later.
			jQuery( '#pb_backupbuddy_backup_remotedestination' ).val( destination_id );
			jQuery( '#pb_backupbuddy_backup_deleteafter' ).val( delete_after );
			jQuery( '#pb_backupbuddy_backup_remotetitle' ).html( 'Destination: "' + destination_title + '".' );
			jQuery( '#pb_backupbuddy_backup_remotetitle' ).slideDown();
		} else {
			window.location.href = '<?php
			if ( is_network_admin() ) {
				echo network_admin_url( 'admin.php' );
			} else {
				echo admin_url( 'admin.php' );
			}
			?>?page=pb_backupbuddy_backup&custom=remoteclient&destination_id=' + destination_id;
		}
	} // end pb_mainwp_backupbuddy_selectdestination().


	function afterbackupremote() {
		tb_show( 'BackupBuddy', '<?php echo pb_mainwp_backupbuddy::ajax_url( 'destination_picker' ); ?><?php echo $addition_popup_url; ?>&callback_data=delayed_send&sending=1&action_verb=to%20send%20to&TB_iframe=1&width=640&height=455', null );
	} // end afterbackupremote().


	mainwp_backupbuddy_individual_perform_profile_action = function (pSiteId, pProfId, pPerform) {
			var messageEl = jQuery( '#mwp_backupbuddy_message_zone' );
			var errorEl = jQuery( '#mwp_backupbuddy_error_zone' );
			messageEl.hide();
			errorEl.hide();
			data = {
				action: 'mainwp_backupbuddy_perform_profile_action',
				profile_id: pProfId,
				what: pPerform,
				backupbuddyRequestSiteID: pSiteId,
				isIndividual: 1,
				_backupbuddyNonce: mainwp_backupbuddy_loc.nonce,
			};
			if (pPerform == 'delete_profile')
				messageEl.html('<i class="fa fa-spinner fa-pulse"></i> ' + 'Deleting the scheduled backup on child site...').show();
			else
				messageEl.html('<i class="fa fa-spinner fa-pulse"></i> ' + 'Saving to child site...').show();
			jQuery.post(ajaxurl, data, function (response) {
				messageEl.hide();
				var str_err = '';
				var str_mess = '';
				if (response) {
					if (response.error) {
						str_err = '<i class="fa fa-exclamation-circle"></i> ' + response.error;
					} else if (response.result == 'SUCCESS') {
						var msg;
						if (pPerform == 'delete_profile')
							msg = 'Deleted profile successful.';
						else
							msg = 'Profile saved successfully to child site.';
						str_mess = '<i class="fa fa-check-circle"></i> ' + msg;
					} else {
						str_err = '<i class="fa fa-exclamation-circle"></i> ' + 'Undefined Error';
					}
				} else {
						str_err = '<i class="fa fa-exclamation-circle"></i> ' + 'Undefined Error';
				}

				if (str_err != '') {
					errorEl.html(str_err).show();
				} else if (str_mess != '') {
					messageEl.html(str_mess).show();
				}
			}, 'json');
	}


	mainwp_backupbuddy_individual_perform_action = function (pSiteId, pItemId, pPerform) {
			var messageEl = jQuery( '#mwp_backupbuddy_message_zone' );
			var errorEl = jQuery( '#mwp_backupbuddy_error_zone' );
			messageEl.hide();
			errorEl.hide();
			data = {
				action: 'mainwp_backupbuddy_perform_action',
				item_id: pItemId,
				what: pPerform,
				backupbuddyRequestSiteID: pSiteId,
				isIndividual: 1,
				_backupbuddyNonce: mainwp_backupbuddy_loc.nonce,
			};
			if (pPerform == 'delete_backup')
				messageEl.html('Deleting Backup(s) on child site...').show();

			jQuery.post(ajaxurl, data, function (response) {
				messageEl.hide();
				var str_err = '';
				var str_mess = '';
				if (response) {
					if (response.error) {
						str_err = response.error;
					} else if (response.result == 'SUCCESS') {
						var msg;
						if (pPerform == 'delete_backup')
							msg = 'Deleted Backup(s) successful.';
						str_mess =  msg;
					} else {
						str_err = 'Undefined Error';
					}
				} else {
						str_err = 'Undefined Error';
				}

				if (str_err != '') {
					errorEl.html(str_err).show();
				} else if (str_mess != '') {
					messageEl.html(str_mess).show();
				}
			}, 'json');
	}

</script>

<style>
	.profile_box {
		background: #F8F8F8;
		margin: 0;
		display: block;
		border-radius: 5px;
		padding: 10px 10px 0px 10px;
		margin-bottom: 40px;
		border-radius: 5px;
		border: 1px solid #d6d6d6;
		border-top: 1px solid #ebebeb;
		box-shadow: 0px 3px 0px 0px #aaaaaa;
		box-shadow: 0px 3px 0px 0px #CFCFCF;
		font-size: auto;
	}
	.profile_text {
		display: block;
		float: left;
		line-height: 26px;
		padding-right: 8px;
	}
	.profile_type {
		display: block;
		float: left;
		line-height: 26px;
		margin-right: 10px;
		color: #aaa;

		padding-right: 10px;
		border-right: 1px solid #EBEBEB;
	}

	.profile_item_select,.profile_item_noselect {
		display: inline-block;
		background: #fff;
		border: 1px solid #e7e7e7;
		border-top: 1px solid #ebebeb;
		border-bottom: 1px solid #c9c9c9;
		border-radius: 4px 0 0 4px;
		padding: 10px 15px;
		margin-bottom: 10px;
		text-decoration: none;
		color: #252525;
		line-height: 2;
		font-size: medium;
	}

	.bb-dest-option .info.add-new {
		width: 95%;
		padding-right: 3%;
		border-radius: 4px;
	}

	.profile_item_select:hover,.profile_item_noselect:hover {
		color: #da2828;
	}
	.profile_item_select:active, .profile_item_select:focus,.profile_item_noselect:active, .profile_item_noselect:focus {
		box-shadow: inset 0 0 5px #da2828;
	}

	.profile_item {
		margin-right: 0;
		display: inline-block;
		white-space: nowrap;
	}
	.profile_item:hover {
		color: #da2828;
		cursor: pointer;
	}

	.profile_item_add_select {
		border-radius: 4px 4px 4px 4px;
		padding: 7px;
	}

	.profile_item_selected {
		border-bottom: 3px solid #da2828;
		margin-bottom: 10px;
	}

	.profile_choose {
		font-size: 20px;
		font-family: "HelveticaNeue-Light","Helvetica Neue Light","Helvetica Neue",sans-serif;
		padding: 5px 0 15px 5px;
		color: #464646;
	}
	.backupbuddyFileTitle {
		//color: #0084CB;
		color: #000;
		font-size: 1.2em;
	}

.profile_settings {
		display: inline-block;
		height: 48px;
		color: #cdcdcd;
		/*
		width: 20px;
		padding: 11px;
		*/
		padding: 12px 12px 0 11px;
		width: 45px;
		margin-top: 0;
		margin-right: 12px;
		margin-bottom: 10px;
		background-size: 20px 20px;
		border-radius: 0 4px 4px 0;
		border-right: 1px solid #e7e7e7;
		border-top: 1px solid #ebebeb;
		border-bottom: 1px solid #c9c9c9;

		background-position: center;
		background-repeat:no-repeat;
		background-color: #fff;
		background-size: 20px 20px;

		font-size: 1.7em;
	}
	.profile_settings:hover {
		background-color: #a8a8a8;
		background-size: 20px 20px;
		box-shadow: inset 0 0 8px #666;
	}
	.profile_add {
		display: block;
		width: 32px;
		height: 32px;
		background: transparent url('<?php echo pb_mainwp_backupbuddy::plugin_url(); ?>/images/dest_plus.png') top left no-repeat;
		vertical-align: -3px;
	}
	.profile_add:hover {
		background: transparent url('<?php echo pb_mainwp_backupbuddy::plugin_url(); ?>/images/dest_plus.png') bottom left no-repeat;
	}
</style>

<?php if ($site_id) { ?>
	<div class="backupbuddy-recent-backups" style="display: none;">
		<?php
		$recentBackups_list = pb_mainwp_backupbuddy::get_the_plugin_data_of_site($site_id, 'recent_backup_list');
		if ( ! is_array( $recentBackups_list ) ) {
			$recentBackups_list = array();
		}
		if ( count( $recentBackups_list ) == 0 ) {
			_e( 'No backups have been created recently.', 'it-l10n-mainwp-backupbuddy' );
		} else {
			// Read in list of backups.
			$recent_backup_count_cap = 5; // Max number of recent backups to list.

			$recentBackups = array_slice( $recentBackups_list, 0, $recent_backup_count_cap ); // Only display most recent X number of backups in list.

			pb_mainwp_backupbuddy::$ui->list_table(
				$recentBackups,
				array(
					'action'		=>	pb_mainwp_backupbuddy::page_url() . $addition_url,
					'columns'		=>	$columns,
					'css'			=>	'width: 100%;',
          'site_id'               =>      $site_id
				)
			);

			echo '<div class="alignright actions">';
			pb_mainwp_backupbuddy::$ui->note( 'Hover over items above for additional options.' );
			echo '</div>';
		}
		?>
		<br><br>
    </div>

<?php } ?>

<?php
$do_profile_action = get_option('mainwp_backbuddy_perform_profile_action');
$what = '';
$selected_sites = $selected_groups = array();
if (is_array($do_profile_action) && isset($do_profile_action['what'])) {
	delete_option('mainwp_backbuddy_perform_profile_action');
	$what = $do_profile_action['what'];
	$_profile_id = $do_profile_action['profile_id'];
	if ( $_profile_id && ( 'save_profile' == $what || 'delete_profile' == $what ) ) {
            $_profile = pb_mainwp_backupbuddy::$options['profiles'][$_profile_id];

            if ('delete_profile' == $what) {
                $_sites = isset($do_profile_action['sites']) ? $do_profile_action['sites'] : '';
                $_groups = isset($do_profile_action['groups']) ? $do_profile_action['groups'] : '';
            } else {
                $_sites = isset($_profile['sites']) ? $_profile['sites'] : '';
                $_groups = isset($_profile['groups']) ? $_profile['groups'] : '';
                $selected_sites = explode(';', $_sites);
                $selected_groups = explode(';', $_groups);
            }
?>
	<script type="text/javascript">
                var selected_sites = '<?php echo $_sites; ?>';
                var selected_groups = '<?php echo $_groups; ?>';
		jQuery(document).ready(function() {
			<?php if ($site_id) { ?>
					mainwp_backupbuddy_individual_perform_profile_action(<?php echo MainWP_BackupBuddy::get_manager_site_id(); ?>, '<?php echo $_profile_id; ?>', '<?php echo $what; ?>' );
			<?php } else {
                        if ('save_profile' == $what) {
                        ?>
                            jQuery('#mwp_backupbuddy_profile_box div.profile_box').hide();
                            jQuery('#mwp_save_profile_wrap').show();
                    <?php } else { ?>
                            mainwp_backupbuddy_bulk_perform_profile_action( '<?php echo $_profile_id; ?>', '<?php echo $what; ?>', '', '', selected_sites.split(';'), selected_groups.split(';') );
                    <?php }
                }
                        ?>
		})
</script>
<?php
	}
}

?>

<?php
$do_action = get_option('mainwp_backbuddy_perform_action', false);

if (is_array($do_action) && isset($do_action['what'])) {
	delete_option('mainwp_backbuddy_perform_action');
	$what = $do_action['what'];
	$_item_id = $do_action['item_id'];
	if ('delete_backup' == $what ) {
?>
	<script type="text/javascript">
		jQuery(document).ready(function() {
                    <?php if ($site_id) { ?>
                            mainwp_backupbuddy_individual_perform_action(<?php echo MainWP_BackupBuddy::get_manager_site_id(); ?>, '<?php echo $_item_id; ?>', '<?php echo $what; ?>' );
                    <?php } ?>
		})
</script>
<?php
	}
}

?>

<div class="ui alt segment">
	<div class="mainwp-main-content">
		<div class="ui hidden divider"></div>
<div id="mwp_backupbuddy_backup_errors" class="ui red message" style="display: none"></div>

<div id="mwp_backupbuddy_profile_box" <?php echo $site_id ? '' : 'class="mainwp-bb-postbox"'; ?>>
<?php
if (empty($site_id) && 'save_profile' == $what) {
    ?>
    <div id="mwp_save_profile_wrap" style="display:none">
        <div><?php _e('Saving profile to child sites, please select child sites on the left if need to change, and clicking on the "Save to child sites" button.', 'mainwp-buddy-extension'); ?></div>
        <p><a class="button-primary" href="#" onclick="return mainwp_backupbuddy_general_save_profile('<?php echo $_profile_id; ?>');"><?php _e('Save to child sites', 'mainwp-buddy-extension'); ?></a></p>
    </div>
    <?php
}
?>
<div class="bb-profilebox-wrap profile_box">
	<?php if( MainWP_BackupBuddy::is_manage_site() ) { ?>
	<div class="profile_choose">
		<?php _e( 'Choose a backup profile to run:', 'it-l10n-mainwp-backupbuddy' ); ?>
	</div>
	<?php } ?>
	<?php
	if ( true === $disableBackingUp ) {
		echo '&nbsp;&nbsp;<span class="description">' . __( 'Backing up disabled due to errors listed above. This often caused by permission problems on files/directories. Please correct the errors above and refresh to try again.', 'it-l10n-mainwp-backupbuddy' ) . '</span><br>';
	} else {

        function bb_mainwp_home_show_profiles( $profile_id, $profile, $addition_url = '' ) {

      if( MainWP_BackupBuddy::is_manage_site() ) {
				$backup_href = pb_mainwp_backupbuddy::page_url() .'&backupbuddy_backup=' . $profile_id . $addition_url;
				$backup_title = 'Create this ' . $profile['type'] . ' backup.';
			} else {
				$backup_href = '#';
				$backup_title = '';
			}

			?>
			<div class="profile_item">
				<a class="profile_item_select" profile-id="<?php echo $profile_id; ?>" href="<?php echo $backup_href; ?>" title="<?php echo $backup_title; ?>">
					<span class="profile_type profile_type-<?php echo  $profile['type']; ?>" title="><?php
						_e( mainwp_backupbuddy_core::pretty_backup_type( $profile['type'] ), 'it-l10n-mainwp-backupbuddy' );
					?>"></span>
					<span <?php if ( ( 1 == $profile_id ) || ( 2 == $profile_id ) ) { echo 'style="font-weight: 600 !important;"'; } ?> class="profile_text" id="profile_title_<?php echo $profile_id; ?>"><?php echo htmlentities( $profile['title'] ); ?></span>
				</a><a href="#settings" rel="<?php echo $profile_id; ?>" class="profile_settings dashicons dashicons-admin-generic" title="<?php _e( "Configure this profile's settings.", 'it-l10n-mainwp-backupbuddy' ); ?>"></a>
			</div>
			<?php
		}
		// Show full and db profiles first.
		bb_mainwp_home_show_profiles( 1, pb_mainwp_backupbuddy::$options['profiles'][1], $addition_url );
		bb_mainwp_home_show_profiles( 2, pb_mainwp_backupbuddy::$options['profiles'][2], $addition_url );

        echo '<div class="bb_profile_divider"></div>';
		foreach( pb_mainwp_backupbuddy::$options['profiles'] as $profile_id => $profile ) {
			if ( ( 1 == $profile_id ) || ( 2 == $profile_id ) ) { // skip full and db since shown above.
				continue;
			}
			if ( 0 == $profile_id ) { // Skip showing defaults here...
				if ( isset( pb_mainwp_backupbuddy::$options['profiles'][3] ) ) {
					echo '<div class="bb_profile_divider"></div>';
				}
				continue;
			}
			bb_mainwp_home_show_profiles( $profile_id, $profile, $addition_url );

		}

        // old code
        if (false) {
            foreach( pb_mainwp_backupbuddy::$options['profiles'] as $profile_id => $profile ) {
                if ( ( 1 == $profile_id ) || ( 2 == $profile_id ) ) { // skip full and db since shown above.
                    continue;
                }

                if ( $profile['type'] == 'defaults' ) { continue; } // Skip showing defaults here...
                if( MainWP_BackupBuddy::is_manage_site() ) {
                    $backup_href = pb_mainwp_backupbuddy::page_url() .'&backupbuddy_backup=' . $profile_id . $addition_url;
                    $backup_title = 'Create this ' . $profile['type'] . ' backup.';
                } else {
                    $backup_href = '#';
                    $backup_title = '';
                }
                ?>
                <div class="profile_item">
                    <a class="profile_item_select" profile-id="<?php echo $profile_id; ?>" href="<?php echo $backup_href; ?>" title="<?php echo $backup_title; ?>">
                        <span class="profile_type"><?php
                            if ( $profile['type'] == 'db' ) {
                                _e( 'Database', 'it-l10n-mainwp-backupbuddy' );
                            } elseif ( $profile['type'] == 'full' ) {
                                _e( 'Full', 'it-l10n-mainwp-backupbuddy' );
                            } elseif( $profile['type'] == 'files' ) {
                                _e( 'Files', 'it-l10n-mainwp-backupbuddy' );
                            } else {
                                echo 'unknown(' . htmlentities( $profile['type'] ). ')';
                            }
                        ?></span>
                        <span class="profile_text" id="profile_title_<?php echo $profile_id; ?>"><?php echo htmlentities( $profile['title'] ); ?></span>
                    </a>
                    <a href="#settings" rel="<?php echo $profile_id; ?>" class="profile_settings" style="background-image: url('<?php echo pb_mainwp_backupbuddy::plugin_url(); ?>/images/dest_gear.png');" title="<?php _e( "Configure this profile's settings.", 'it-l10n-mainwp-backupbuddy' ); ?>"></a>
                </div>
                <?php
            }
        }
		?>

		<div class="profile_item" id="pb_backupbuddy_profileadd_plusbutton">
			<a class="profile_item_noselect profile_item_add_select" title="<?php _e( 'Create new profile.', 'it-l10n-mainwp-backupbuddy' ); ?>">
				<span class="profile_add"></span>
			</a>
		</div>

		<div class="profile_item" id="pb_backupbuddy_profileadd" style="display: none;" href="<?php echo pb_mainwp_backupbuddy::ajax_url( 'backup_profile_settings' ); ?>&profile=<?php echo $profile_id; ?>">
			<div class="profile_item_noselect" style="padding: 6px;">
				<form method="post" action="<?php echo pb_mainwp_backupbuddy::page_url() . $addition_url; ?>" style="white-space:nowrap;">
					<?php pb_mainwp_backupbuddy::nonce(); ?>
					<input type="hidden" id="mainwp_backupbuddy_backup_sites" name="mainwp_backupbuddy_backup_sites" value="">
                    <input type="hidden" id="mainwp_backupbuddy_backup_groups" name="mainwp_backupbuddy_backup_groups" value="">
                    <input type="hidden" name="add_profile" value="true">
                    <span class="profile_text"><input type="text" name="title" style="padding: 6px;" maxlength="20" placeholder="<?php _e( 'New profile title...', 'it-l10n-mainwp-backupbuddy' ); ?>"></span>
                    <span class="profile_type" style="margin-right: 0;">
						<select name="type">
						    <option value="db"><?php _e( 'Database Only', 'it-l10n-mainwp-backupbuddy' ); ?></option>
							<option value="full"><?php _e( 'Full (Files & Database)', 'it-l10n-mainwp-backupbuddy' ); ?></option>
							<option disabled="disabled">---------------</option>
							<option value="themes"><?php _e( 'Themes Only', 'it-l10n-mainwp-backupbuddy' ); ?></option>
							<option value="plugins"><?php _e( 'Plugins Only', 'it-l10n-mainwp-backupbuddy' ); ?></option>
							<option value="media"><?php _e( 'Media Only', 'it-l10n-mainwp-backupbuddy' ); ?></option>
							<option disabled="disabled">---------------</option>
							<option value="files"><?php _e( 'Custom Files', 'it-l10n-mainwp-backupbuddy' ); ?></option>
						</select>
					</span>
					<input type="submit" id="mwp_bb_save_backup_btn" name="submit" value="+ <?php _e( 'Add', 'it-l10n-mainwp-backupbuddy' ); ?>" class="button button-primary" style="vertical-align: 0;">
				</form>
			</div>
		</div>

		<br style="clear: both;">

		<!-- Remote send after successful backup? -->
		<div class="bb-remote-checkbox" style="clear: both; padding-left: 4px;">
			<input type="checkbox" name="pb_backupbuddy_afterbackupremote" id="pb_backupbuddy_afterbackupremote_box"> <label id="pb_backupbuddy_afterbackupremote" for="pb_backupbuddy_afterbackupremote">Send to remote destination as part of backup process. <span id="pb_backupbuddy_backup_remotetitle"></span></label>
			<input type="hidden" name="remote_destination" id="pb_backupbuddy_backup_remotedestination">
			<input type="hidden" name="delete_after" id="pb_backupbuddy_backup_deleteafter">

		</div>
	<?php } // end disabling backups ?>
	<br style="clear: both;">

</div>

</div>

</div>
<div class="mainwp-side-content mainwp-no-padding">
	<div class="mainwp-select-sites">

		<?php
		if( !MainWP_BackupBuddy::is_manage_site() ) {
			MainWP_BackupBuddy::site_settings_box($site_id);
			echo '<h3 class="ui header">Select Sites</h3>';
		    echo '<div class="mainwp_bb_left_select_sites_wrap">';
		    do_action( 'mainwp_select_sites_box', __( 'Select Site', 'mainwp' ), 'checkbox', true, true, 'mainwp_select_sites_box_left', '', $selected_sites, $selected_groups );
		    echo '</div>';
		} else {
			echo '<div class="ui info message"><a href="https://ithemes.com/tutorial/category/backupbuddy/" target="_blank">Click here</a> if you need help with the BackupBuddy plugin.</div>';
		}
		?>

	</div>
</div>
<div class="ui hidden clearing divider"></div>

<?php
pb_mainwp_backupbuddy::flush();
if(MainWP_BackupBuddy::is_manage_site()) {
	$listing_mode = 'default';
	require_once( '_backup_listing.php' );
}

/*
echo '<br><br>';
echo '<a href="';
if ( is_network_admin() ) {
	echo network_admin_url( 'admin.php' );
} else {
	echo admin_url( 'admin.php' );
}
echo '?page=pb_backupbuddy_destinations" class="button button-primary">View & Manage remote destination files</a>';
*/



echo '</div>';

// Handles thickbox auto-resizing. Keep at bottom of page to avoid issues.
if ( !wp_script_is( 'media-upload' ) ) {
	wp_enqueue_script( 'media-upload' );
	wp_print_scripts( 'media-upload' );
}
