<?php
if ( !is_admin() ) { die( 'Access Denied.' ); }


/*
IMPORTANT INCOMING VARIABLES (expected to be set before this file is loaded):
$profile	Index number of profile.
*/
if ( isset( pb_mainwp_backupbuddy::$options['profiles'][$profile] ) ) {
	$profile_id = $profile;
	$profile_array = &pb_mainwp_backupbuddy::$options['profiles'][$profile];
	$profile_array = array_merge( pb_mainwp_backupbuddy::settings( 'profile_defaults' ), $profile_array );
} else {
	die( 'Error #565676756. Invalid profile ID index.' );
}

$current_site_id = 0;
$plugins_root = $themes_root = $media_root = $abspath = '';

if (MainWP_BackupBuddy::is_manage_site()) {
    $current_site_id = MainWP_BackupBuddy::get_manager_site_id();    
    $plugin_data = pb_mainwp_backupbuddy::get_the_plugin_data_of_site($current_site_id);    
    if (is_array($plugin_data) && isset($plugin_data['plugins_root'])) {
        $plugins_root = $plugin_data['plugins_root'];
        $themes_root = $plugin_data['themes_root'];
        $media_root = $plugin_data['media_root'];        
        $abspath = $plugin_data['abspath'];      
        $abslen = strlen($abspath);
    }
} else {
    $abslen = strlen( ABSPATH );
}

?>
<script type="text/javascript">
	jQuery(document).ready(function() {
		
		jQuery( '.pb_backupbuddy_filetree_exclude' ).click( function() { alert( 'Error #3484578347843873. Not implemented here. Deprecated.' ); } );
		
		/* Begin Directory / File Selector */
		jQuery(document).on( 'click', '.pb_backupbuddy_filetree_exclude', function(){
			text = jQuery(this).parent().parent().find( 'a' ).attr( 'rel' );
			if ( ( text == 'wp-config.php' ) || ( text == '/wp-content/' ) || ( text == '/wp-content/uploads/' ) || ( text == '<?php echo '/' . str_replace( ABSPATH, '', mainwp_backupbuddy_core::getBackupDirectory() ); ?>' ) || ( text == '<?php echo '/' . str_replace( ABSPATH, '', mainwp_backupbuddy_core::getTempDirectory() ); ?>' ) ) {
				alert( "<?php _e('You cannot exclude /wp-content/, the uploads directory, or BackupBuddy directories which will be automatically excluded.  However, you may exclude subdirectories within these. BackupBuddy directories such as backupbuddy_backups are automatically excluded and cannot be added to exclusion list.', 'it-l10n-mainwp-backupbuddy' );?>" );
			} else {
				jQuery('#pb_backupbuddy_excludes').val( text + "\n" + jQuery('#pb_backupbuddy_excludes').val() );
			}
			return false;
		});
	});
</script>



<?php

global $filetree_root;


if ($current_site_id) {
    if ( 'files' == $profile_array['type'] ) {
        if ( '' != $profile_array['custom_root'] ) {
            $filetree_root = rtrim( $profile_array['custom_root'], '\\/' ) . '/';
        } else {
            $filetree_root = '/';
        }
    } elseif ( 'media' == $profile_array['type'] ) {
        $filetree_root = substr( $media_root, $abslen-1 ) . '/'; // substr( backupbuddy_core::get_media_root(), $abslen-1 ) . '/';
    } elseif ( 'plugins' == $profile_array['type'] ) {
        $filetree_root = substr( $plugins_root, $abslen-1 ) . '/'; //substr( backupbuddy_core::get_plugins_root(), $abslen-1 ) . '/';
    } elseif ( 'themes' == $profile_array['type'] ) {
        $filetree_root = substr( $themes_root, $abslen-1 ) . '/'; //substr( backupbuddy_core::get_themes_root(), $abslen-1 ) . '/';
    } else {
        $filetree_root = '/';
    } 
}

require_once( '_filetree.php' );



if ( $profile_array['type'] == 'defaults' ) {
	$before_text = __('<b>Default</b> excluded files & directories (relative to WordPress root)' , 'it-l10n-mainwp-backupbuddy' );
} else {
	$before_text = __('Excluded files & directories for this profile', 'it-l10n-mainwp-backupbuddy' );
		//'<br><span class="description">' . __( '(Global defaults do not apply; relative to WordPress root)' , 'it-l10n-mainwp-backupbuddy' ) . '</span>';
}

if ( 'files' == $profile_array['type'] ) {
    $settings_form->add_setting( array(
        'type'		=>		'text',
        'name'		=>		'profiles#' . $profile_id . '#custom_root',
        'classes'		=>		'custom_root_input',
        'title'		=>		__('Custom backup root path', 'it-l10n-mainwp-backupbuddy' ),
        'tip'		=>		__('[Default: blank] - If set then data will be backed up starting at the specified path, RELATIVE to your site\'s ABSPATH (WordPress root). You may use /../ to enter parent directories ABOVE the site\'s ABSPATH (WordPress root), eg: /../aparentdir/. IMPORTANT: If entering profile-specific exclusions these exclusions should also be entered relative to the custom root. Global exclusions are still relative to the ABSPATH and will automatically be translated to the relative path and applied.' ),
        'rules'		=>		'',
        'css'		=>		'width: 100%;',
        'before'		=>		'<span style="white-space: nowrap;">',
        'after'		=>		'<br>Enter RELATIVE to you site ABSPATH:<br><div class="code" style="background: #EAEAEA; white-space: normal; width: 100%; overflow: auto;">' . $abspath . '</div><span id="custom_root-changed_notice" style="display: none; color: red;">Save Profile Settings to update directory exclusion picker.</span>',
    ) );
}
    
if ( 'media' == $profile_array['type'] ) {
    $settings_form->add_setting( array(
        'type'		=>		'plaintext',
        'name'		=>		'profiles#' . $profile_id . '#mediadirtext',
        'title'		=>		__('Media Directory (profile backup root)', 'it-l10n-mainwp-backupbuddy' ),
        'tip'		=>		__( 'The Media backup type is a "smart" profile which automatically selects your WordPress media directory root as its backup root to simplify backing up just your media.' ),
        'rules'		=>		'',
        'css'		=>		'width: 100%;',
        'before'		=>		'<span style="white-space: nowrap;">',
        'after'		=>		'<div class="code" style="background: #EAEAEA; white-space: normal; width: 100%; overflow: auto;">' . $media_root . '</div>',
    ) );
}

if ( 'plugins' == $profile_array['type'] ) {
    $settings_form->add_setting( array(
        'type'		=>		'plaintext',
        'name'		=>		'profiles#' . $profile_id . '#pluginsdirtext',
        'title'		=>		__('Plugins Directory (profile backup root)', 'it-l10n-mainwp-backupbuddy' ),
        'tip'		=>		__( 'The Plugins backup type is a "smart" profile which automatically selects your WordPress plugins directory root as its backup root to simplify backing up just your media.' ),
        'rules'		=>		'',
        'css'		=>		'width: 100%;',
        'before'		=>		'<span style="white-space: nowrap;">',
        'after'		=>		'<div class="code" style="background: #EAEAEA; white-space: normal; width: 100%; overflow: auto;">' . $plugins_root . '</div>',
    ) );
}

if ( 'themes' == $profile_array['type'] ) {
    $settings_form->add_setting( array(
        'type'		=>		'plaintext',
        'name'		=>		'profiles#' . $profile_id . '#themesdirtext',
        'title'		=>		__('Themes Directory (profile backup root)', 'it-l10n-mainwp-backupbuddy' ),
        'tip'		=>		__( 'The Themes backup type is a "smart" profile which automatically selects your WordPress themes directory root as its backup root to simplify backing up just your media.' ),
        'rules'		=>		'',
        'css'		=>		'width: 100%;',
        'before'		=>		'<span style="white-space: nowrap;">',
        'after'		=>		'<div class="code" style="background: #EAEAEA; white-space: normal; width: 100%; overflow: auto;">' . $themes_root . '</div>',
    ) );
}



if ( $profile_array['type'] != 'defaults' ) {
	$settings_form->add_setting( array(
		'type'		=>		'checkbox',
		'name'		=>		'profiles#' . $profile_id . '#profile_globalexcludes',
		'options'	=>		array( 'unchecked' => '0', 'checked' => '1' ),
		'title'		=>		'Use global defaults for files to backup?',
		'after'		=>		' Use global defaults<br><span class="description" style="padding-left: 25px;">Uncheck to customize files.</span>',
		'css'		=>		'',
	) );
}

if (!$current_site_id && $profile_id == 0) {
    $settings_form->add_setting( array(
            'type'		=>		'checkbox',
            'name'		=>		'use_individual_excludes',
            'options'	=>                      array( 'unchecked' => '0', 'checked' => '1' ),
            'title'		=>		__( 'Default excluded files & directories', 'it-l10n-mainwp-backupbuddy' ),
            'tip'		=>		__( 'Use Default excluded files & directories value from individual site settings. Uncheck will do not update the value.', 'it-l10n-mainwp-backupbuddy' ),
            'css'		=>		'',
            'after'		=>		'  <span class="description">' . __( 'Use Default excluded files & directories value from individual site settings', 'it-l10n-mainwp-backupbuddy' ) . '</span>',
            'rules'		=>		'required',
    ) );
} else {
    $settings_form->add_setting( array(
            'type'		=>		'textarea',
            'name'		=>		'profiles#' . $profile_id . '#excludes',
            'title'		=>		'Hover & select to navigate, <img src="' . pb_mainwp_backupbuddy::plugin_url() .'/images/redminus.png" style="vertical-align: -3px;"> to exclude.' . ' ' .
                                                    pb_mainwp_backupbuddy::tip( __('Click on a directory name to navigate directories. Click the red minus sign to the right of a directory to place it in the exclusion list. /wp-content/, the uploads directory, and BackupBuddy backup & temporary directories cannot be excluded. BackupBuddy directories are automatically excluded.', 'it-l10n-mainwp-backupbuddy' ), '', false ) .
                                                    '<br><div id="exlude_dirs" class="jQueryOuterTree"></div>',
            //'tip'		=>		,
            'rules'		=>		'string[0-9000]',
            'css'		=>		'width: 100%; height: 135px;',
            'before'	=>		$before_text . pb_mainwp_backupbuddy::tip( __('List paths relative to the WordPress installation directory to be excluded from backups.  You may use the directory selector to the left to easily exclude directories by ctrl+clicking them.  Paths are relative to root, for example: /wp-content/uploads/junk/', 'it-l10n-mainwp-backupbuddy' ), '', false ) . '<br>',
            'after'		=>		'<span class="description">' . __( 'One file or directory exclusion per line.', 'it-l10n-mainwp-backupbuddy' ) . '</span>',
    ) );
}


if ( ( 'full' == $profile_array['type'] ) || ( 'files' == $profile_array['type'] ) ) {
	if ( 'full' != $profile_array['type'] ) {
		$settings_form->add_setting( array(
			'type'		=>		'checkbox',
			'name'		=>		'profiles#' . $profile_id . '#exclude_media',
			'options'	=>		array( 'unchecked' => '0', 'checked' => '1' ),
			'title'		=>		'Auto-exclude Media Directory',
			'css'		=>		'',
			'tip'		=>		__( 'When enabled the current WordPress Media directory will be automatically excluded from backups made with this profile, even if the directory changes in the future. Current directory:', 'it-l10n-mainwp-backupbuddy' ) ,
		) );
	}
	$settings_form->add_setting( array(
		'type'		=>		'checkbox',
		'name'		=>		'profiles#' . $profile_id . '#exclude_themes',
		'options'	=>		array( 'unchecked' => '0', 'checked' => '1' ),
		'title'		=>		'Auto-exclude Themes Directory',
		'css'		=>		'',
		'tip'		=>		__( 'When enabled the current WordPress Themes directory will be automatically excluded from backups made with this profile, even if the directory changes in the future. Current directory:', 'it-l10n-mainwp-backupbuddy' ),
	) );
	$settings_form->add_setting( array(
		'type'		=>		'checkbox',
		'name'		=>		'profiles#' . $profile_id . '#exclude_plugins',
		'options'	=>		array( 'unchecked' => '0', 'checked' => '1' ),
		'title'		=>		'Auto-exclude Plugins Directory',
		'css'		=>		'',
		'tip'		=>		__( 'When enabled the current WordPress Plugins directory will be automatically excluded from backups made with this profile, even if the directory changes in the future. Current directory:', 'it-l10n-mainwp-backupbuddy' ),
	) );
}

