<?php

$otherAction = '';

if ( '' != pb_mainwp_backupbuddy::_GET( 'other_action' ) ) {
    $otherAction = pb_mainwp_backupbuddy::_GET( 'other_action' );
}

if ($site_id)
    $addition_url = '&tab=3&id=' . $site_id;
else
    $addition_url = '&tab=2';
$addition_url .= '&other_nonce=' . wp_create_nonce( 'other_nonce' );


if (in_array($otherAction, array('cleanup_now', 'delete_tempfiles_now', 'reset_log', 'reset_disalerts', 'cancel_running_backups')) &&
        isset($_GET['other_nonce']) && wp_verify_nonce($_GET['other_nonce'], 'other_nonce')
        ){

        if ($site_id) {
            $sub_title = '';
            switch ($otherAction) {
                case 'cleanup_now':
                    $sub_title = 'Cleanup OLD temporary data & perform housekeeping on the child site';
                    break;
                case 'delete_tempfiles_now':
                    $sub_title = 'Deleting ALL data files (including resetting Stash Live catalog) on the child site';
                    break;
                case 'reset_disalerts':
                    $sub_title = 'Resetting Dismissed Alerts on the child site';
                    break;
                case 'cancel_running_backups':
                    $sub_title = 'Forcing Cancel of all Backups & Transfers on the child site';
                    break;
                case 'reset_log':
                    $sub_title = 'Clearing Log on the child site';
                    break;
            }
        }

?>
<script type="text/javascript">
	jQuery(document).ready(function() {
            <?php if ($site_id) { ?>
                var data = {
                    action: 'mainwp_backupbuddy_perform_action',
                    what: 'settings_other',
                    other_action: '<?php echo $otherAction; ?>',
                    backupbuddyRequestSiteID: <?php echo intval($site_id); ?>,
                    _backupbuddyNonce: mainwp_backupbuddy_loc.nonce,
                    donotcheckIndividual: 1
                }
                jQuery('#mwp_bb_settings_other_info').html('<i class="fa fa-spinner fa-pulse"></i> ' + '<?php echo esc_html_e($sub_title); ?>').show();
                jQuery.post(ajaxurl, data, function (response) {
                    jQuery('#mwp_bb_settings_other_info').html('').hide();
                        var err = '', msg = '';
                        if (response) {
                            if (response.error) {
                                err = response.error;
                            } else if (response._error) {
                                err = response._error;
                            } else if (response._message) {
                                msg = response._message;
                            } else {
                                err = __('Undefined error.');
                            }
                        } else {
                            err = __('Undefined error.');
                        }
                        if (msg !== '')
                            jQuery('#mwp_bb_settings_other_info').html(msg).show();
                        if (err !== '')
                            jQuery('#mwp_bb_settings_other_error').html(err).show();
                }, 'json')
            <?php } else { ?>
                    var args = {
                        other_action: '<?php echo $otherAction; ?>'
                    }
                    mainwp_backupbuddy_bulk_load_sites('settings_other', args);
            <?php } ?>
	});
</script>
<?php
}

?>
<div class="mainwp_info-box" id="mwp_bb_settings_other_info" style="display:none"></div>
<div class="mainwp_info-box-red" id="mwp_bb_settings_other_error" style="display:none"></div>

<div id="pb_backupbuddy_bulk_settings_other_content">

        <h3 class="ui dividing header"><?php _e( 'Housekeeping', 'it-l10n-mainwp-backupbuddy' ); ?></h3>

        <div>
                <a href="<?php echo pb_mainwp_backupbuddy::page_url(); ?>&other_action=cleanup_now&subpage=settings<?php echo $addition_url ?>" class="button secondary-button"><?php _e('Cleanup OLD temporary data & perform housekeeping', 'it-l10n-mainwp-backupbuddy' );?>*</a>
                &nbsp;
                <a href="<?php echo pb_mainwp_backupbuddy::page_url(); ?>&other_action=delete_tempfiles_now&subpage=settings<?php echo $addition_url ?>" class="button secondary-button"><?php _e('Delete ALL data files (including resetting Stash Live catalog)', 'it-l10n-mainwp-backupbuddy' );?>*</a>
                &nbsp;
                <a href="<?php echo pb_mainwp_backupbuddy::page_url(); ?>&other_action=reset_disalerts&subpage=settings<?php echo $addition_url ?>" class="button secondary-button"><?php _e('Reset Dismissed Alerts', 'it-l10n-mainwp-backupbuddy' );?></a>
                &nbsp;
                <a href="<?php echo pb_mainwp_backupbuddy::page_url(); ?>&other_action=cancel_running_backups&subpage=settings<?php echo $addition_url ?>" class="button secondary-button"><?php _e('Force Cancel of all Backups & Transfers', 'it-l10n-mainwp-backupbuddy' );?></a>
                &nbsp;
                <?php if ($site_id) { ?>
                <a href="javascript:void(0);" class="button secondary-button" onClick="jQuery( '#backupbuddy-extra-log' ).toggle();"><?php _e('Show Extraneous Log (do NOT send to support)', 'it-l10n-mainwp-backupbuddy' );?></a>
                <?php } else {
                echo '<a href="' . pb_mainwp_backupbuddy::page_url() . '&other_action=reset_log&subpage=settings' . $addition_url . '" class="button secondary-button">' . __('Clear Log', 'it-l10n-mainwp-backupbuddy' ) . '</a>';
                } ?>
        </div>
        <br style="clear: both;">
        <span class="description"><?php _e( '* Temporary files & data are normally automatically cleaned up on a regularly scheduled basis.', 'it-l10n-mainwp-backupbuddy' ); ?></span>
        <br><br><br>
        <div id="backupbuddy-extra-log" style="display: none;">

                <b>Anything logged here is typically not important. Only provide to tech support if specifically requested.</b> By default only errors are logged. Enable Full Logging on the <a href="admin.php?page=ManageSitesBuddy&subpage=settings<?php echo intval($site_id); ?>&tab=1">Advanced Settings</a> tab.
                <br><br>

                <?php
                echo '<textarea readonly="readonly" style="width: 100%;" wrap="off" cols="65" rows="7" id="backupbuddy_logFile">';
                echo '*** Loading log file. Please wait ...';
                echo '</textarea>';
                echo '<a href="' . pb_mainwp_backupbuddy::page_url() . '&other_action=reset_log&subpage=settings' . $addition_url . '" class="button secondary-button">' . __('Clear Log', 'it-l10n-mainwp-backupbuddy' ) . '</a>';
                echo '<br><br><br>';
        ?>
        </div>


</div>
