jQuery( document ).ready(function($) {

	mainwp_uploader_upload_init = function () {
		jQuery( '#mainwp-message-zone' ).html( '' ).hide();
		jQuery( '#mainwp-message-zone' ).removeClass( "red green" );
	};

  jQuery( '.mainwp-file-uploader-delete-file' ).on('click', function() {
    var parent = jQuery( this ).closest('.uploader-setting-upload-new-files');
		var data = {
			action: 'mainwp_uploader_delete_file',
			filename: parent.find( '.qq-upload-file' ).attr('filename'),
            nonce: jQuery('#uploader_nonce').val(),
    };

		parent.find('.status').html( '<i class="notched circle loading icon"></i> ' + 'Removing the file...' );

		jQuery.post(ajaxurl, data, function(response) {
			parent.find('.status').html( '' );
      if (response && response['error']) {
        parent.find( '.status' ).html( '<i class="ui red circle times icon"></i> ' + response['error'] );
      } else if (response && response['ok']) {
        parent.fadeOut();
      } else {
        parent.find( '.status' ).html( '<i class="ui red circle times icon"></i> ' + __( "Undefined error occured. Please try again." ) );
      }
		}, 'json');
		return false;
  });

	jQuery( '#mainwp_uploader_btn_upload' ).on('click', function() {
		var errors = [];
		var selected_sites = [];
		var selected_groups = [];
		var selected_files = [];

		mainwp_uploader_upload_init();

		var fileUpload = jQuery( '.uploader-setting-upload-file[status="queue"]' );

		if ( fileUpload ) {
			jQuery( '.uploader-setting-upload-file[status="queue"]' ).each(function (i) {
				_file = $( this ).attr( 'filename' );
				selected_files.push( _file );
			});
		}

		var newFileUpload = jQuery( '.uploader-setting-upload-new-files' );

		if (newFileUpload) {
			jQuery( '.uploader-setting-upload-new-files' ).each(function (i) {
				_file = $( this ).find('.qq-upload-file').attr( 'filename' );
				selected_files.push( _file );
			});
		}

		if (selected_files.length == 0) {
			errors.push( __( 'There is no files to upload.', 'mainwp-file-uploader-extension' ) );
		}

		if ( jQuery( '#select_by' ).val() == 'site' ) {
			jQuery( "input[name='selected_sites[]']:checked" ).each(function (i) {
				selected_sites.push( jQuery( this ).val() );
			});
			if ( selected_sites.length == 0) {
				errors.push( __( 'Please select at least one website or group.', 'mainwp-file-uploader-extension' ) );
			}
		} else {
			jQuery( "input[name='selected_groups[]']:checked" ).each( function (i) {
				selected_groups.push( jQuery( this ).val() );
			});
			if ( selected_groups.length == 0 ) {
				errors.push( __( 'Please select at least one website or group.', 'mainwp-file-uploader-extension' ) );
			}
		}

		if ( errors.length > 0 ) {
			jQuery( '#mainwp-message-zone' ).addClass( 'red' );
			jQuery( '#mainwp-message-zone' ).html( '<i class="icon close"></i>' + errors.join( '<br />' ) ).show();
			return;
		}

		var path = $( '#mainwp_uploader_select_path' ).val();

		if ( path !== '/' ) {
			path += '/';
		}

		if ( $( '#mainwp_uploader_path_option' ).val().trim() !== '' ) {
			path += $( '#mainwp_uploader_path_option' ).val().trim();
		}

		var data = {
			action:'mainwp_uploader_load_sites',
			path: path,
			'files[]': selected_files,
			'sites[]': selected_sites,
			'groups[]': selected_groups
		};

		$( '#mainwp-message-zone' ).html( '<i class="notched circle loading icon"></i> ' + 'Please wait...' ).show();
		jQuery.post(ajaxurl, data, function(response) {
			$( '#mainwp-message-zone' ).hide();
			if ( response === 'NOSITE' ) {
				$( '#mainwp-message-zone' ).html( 'Please select at least one website or group.' ).addClass( 'red' ).show();
			} else if (response === 'NOFILE') {
				$( '#mainwp-message-zone' ).html( 'No files to upload.' ).addClass( 'red' ).show();
			} else {
				$( '#mainwp-uploader-settings-inside' ).html( response );
				uploader_setting_upload_file_next();
			}
		});
		return false;

	});

});

function mainwpUploaderCreateUploaderFile(){
	var uploader = new qq.FileUploader({
		element: document.getElementById( 'mainwp-uploader-file-uploader' ),
		action: location.href,
		template: '<div class="qq-uploader">' +
							'<div class="qq-upload-button ui big labeled icon green button"><i class="upload icon"></i>Choose File</div>' +
							'<div class="ui raised green padded segment qq-upload-drop-area">Drop files here to upload</span></div>' +
							'<div class="ui middle aligned divided selection list qq-upload-list"></div>' +
							'</div>',
		onComplete: function( id, fileName, result ) { uploader_setting_uploadbulk_oncomplete( id, fileName, result ) },
		params: { uploader_do: 'UploaderInstallBulk-uploadfile' }

	});
}

uploader_setting_uploadbulk_oncomplete = function ( id, fileName, result ) {
	if ( result.success ) {
		if ( totalSuccess > 0 ) {
            jQuery( ".qq-upload-file" ).each( function ( i ) {
                var parent = jQuery( this ).closest('.file-uploaded-item');
                if ( parent.hasClass( 'qq-upload-success' )) {
                    _file = jQuery( this ).attr( 'filename' );
                    parent.find( '.qq-upload-msg-success' ).html( '<span class="uploader-setting-upload-file" status="queue" id="' + id + '" filename ="' + _file + '">' + __( 'File is ready' ) + '</span>' );
                }
            } );
		}
	}
}

var uploader_CurrentThreads = 0;
var uploader_MaxThreads = 3;
var uploader_TotalThreads = 0;
var uploader_FinishedThreads = 0;

uploader_setting_upload_file_next = function(){
	if ( uploader_TotalThreads == 0 ) {
		uploader_TotalThreads = jQuery( '.mainwpUploaderFileItem[status="queue"]' ).length;
	}
	while ( ( fileToUpload = jQuery( '.mainwpUploaderFileItem[status="queue"]:first' ) ) && ( fileToUpload.length > 0 )  && ( uploader_CurrentThreads < uploader_MaxThreads ) ) {
		uploader_setting_upload_file_start_specific( fileToUpload );
	}
}

uploader_setting_upload_file_start_specific = function ( pFileToUpload ) {

	uploader_CurrentThreads++;

	pFileToUpload.attr( 'status', 'progress' );
	pFileToUpload.html( '<i class="notched circle loading icon"></i> ' + __( 'Uploading the file. Please wait...', 'mainwp-file-uploader-extension' ) );

	var data = {
		action:'mainwp_uploader_uploadbulk_file',
		siteId: pFileToUpload.closest( '.mainwpUploaderSiteItem' ).attr( 'siteid' ),
		filename: pFileToUpload.attr( 'filename' ),
		path: jQuery( '#mainwp_uploader_upload_file_path' ).val()
	};

	jQuery.post( ajaxurl, data, function( response ) {
		if ( response ) {
			if ( response == 'NOTEXIST' ) {
				pFileToUpload.html( '<i class="ui icon red circle times"></i> ' + __( 'Upload failed! File could not be found.', 'mainwp-file-uploader-extension' ) );
			} else if ( response == 'ERRORCREATEDIR' ) {
				pFileToUpload.html( '<i class="ui icon red circle times"></i> ' + __( 'Upload failed! Directory could not be created. Please check server permissions or contact the MainWP Support.', 'mainwp-file-uploader-extension' ) );
			} else if ( response['success'] ) {
				pFileToUpload.html( '<i class="ui icon green circle check"></i> ' + __( 'Upload successful!', 'mainwp-file-uploader-extension' ) );
			} else if ( response['error'] ) {
				pFileToUpload.html( '<i class="ui icon red circle times"></i> ' + response['error'] );
			} else {
				pFileToUpload.html( '<i class="ui icon red circle times"></i> ' + __( 'Upload failed! Please contact the MainWP Support for additional help.', 'mainwp-file-uploader-extension' ) );
			}
		} else {
			pFileToUpload.html( '<i class="ui icon red circle times"></i> ' + __( 'Upload failed! Please contact the MainWP Support for additional help.', 'mainwp-file-uploader-extension' ) );
		}

		uploader_CurrentThreads--;
		uploader_FinishedThreads++;

		if ( uploader_FinishedThreads == uploader_TotalThreads && uploader_FinishedThreads != 0 ) {
			jQuery( '#mainwp-message-zone' ).html( 'Files uploaded successfully!' ).addClass( 'green' ).show().fadeIn( 100 );
      jQuery( '#mainwp-uploader-settings-inside' ).append( '<a class="button-primary button button-hero" href="admin.php?page=Extensions-Mainwp-File-Uploader-Extension">Upload New File(s)<a/>' );

			var data = {
				action:'mainwp_uploader_delete_temp_file',
				tmp_files: jQuery( '#mainwp_uploader_tmp_files_name' ).val()
			};

			jQuery.post(ajaxurl, data, function(response) {

			})
		}
		uploader_setting_upload_file_next();
	},'json');
};
