/*
 Administration Javascript for MainWP Links Manager Extension
 */
jQuery(document).ready(function($) {
    //clear all data
    $('button#clear_all_data').bind('click', function() {
        if (!confirm('Are you sure? \nClick OK to clear all statistic.'))
            return false;
        var data = {
            action: 'keyword_links_do_clear_statistic_data',
            nonce: kwlDoClearNonce
        };
        var loading = $(this).closest('.option-field').find('.kwl-link-loading');
        loading.show();
        $.post(ajaxurl, data, function(response) {            
            loading.hide();
            if (response == 'SUCCESS')
                location.href = 'admin.php?page=Extensions-Mainwp-Links-Manager-Extension&message=3';                
            else
                location.href = 'admin.php?page=Extensions-Mainwp-Links-Manager-Extension&message=4';                                
        });
    });
    $(".link-sort").live("click", function() {
        if ($(this).hasClass('asc'))
            var type_direction = 'desc';
        else
            var type_direction = 'asc';
        keyword_links_load_links($(this).attr('id'), type_direction);
    });
    $('.stat-toggle').click(function() {
        //load if empty
        if ($("#" + $(this).attr('id') + '-expanded').html() == '')
            mainwp_kl_load_statistic($(this).attr('id') + '-expanded');
        $("#" + $(this).attr('id') + '-expanded').toggle('slow', '');
        $("." + $(this).attr('id')).toggle();
    });
    $(".next_previous_graph").live('click', function() {
        $("#" + $(this).attr("time-value")).click();
    });
    if ($('#keyword-links-option').size() > 0)
    {
        $('#keyword-links-option .option-tab-nav li a').click(function() {
            var href = $(this).attr('href');
            if ($(href).size() > 0)
            {
                var li = $(this).parent();
                $('#keyword-links-option .option-tab-nav li').not(li).removeClass('current');
                li.addClass('current');
                $('#keyword-links-option .option-tab').not(href).hide().removeClass('current');
                $(href).fadeIn(100).addClass('current');
                //remove comment if you want open the lastest opened tab when click s_kw_link menu item.
                setCookie('mainwp_kwl_current_tab', href);
                if (href == "#tab-links")
                    keyword_links_load_links();
                else if (href == "#tab-groups")
                    mainwp_kl_load_group();
                $('#do_not_link_submit').val("0");
                if (href == "#tab-do-not-link") {
                    $('#do_not_link_submit').val("1");
                }
                return false;
            }
        });
        if (getCookie('mainwp_kwl_current_tab'))
        {
            $('#keyword-links-option .option-tab-nav li a[href=' + getCookie('mainwp_kwl_current_tab') + ']').click();
        }
        else
        {
            $('#keyword-links-option .option-tab-nav li a:eq(0)').click();
        }
        
        $('.mainwp-kl-statistic .stat-navigation a').live('click', function() {
            var href = $(this).attr('href');
            var stat_parent = $(this).closest('.mainwp-kl-statistic');
            if ($(href).size() > 0)
            {
                stat_parent.find('.stat-navigation a').not(this).removeClass('current');
                $(this).addClass('current');
                stat_parent.find('.stat-wrapper').not(href).hide().removeClass('current');
                $(href).fadeIn(100).addClass('current');
                return false;
            }
        });
      
        $('.mainwp-kl-group-delete').live('click', function() {
            var href = $(this).attr('href');
            $(this).after("Deleting...").remove();
            $.get(href, {}, function(data) {
                if (data['error'])
                    alert(data['error']);
                 mainwp_kl_load_group();
            }, 'json')
            return false;
        });
        
        keyword_links_load_links_timeout = function() {
            setTimeout(function () {
                keyword_links_load_links();
                tb_remove();
            }, 2000);
        }
        
        $('#kwl-settings-delete-link').live('click', function() {                         
            var link_id = $(this).attr('link-id');
            var del_on_child_site = $("input[name=kwl_delete_link_child_site]:checked").val();
            var parent = $(this).closest('.kwl-popup-container');
            parent.find('.kwl-link-loading').show();            
//            if (del_on_child_site == 1) {                
                var data2 = {
                   action: 'keyword_links_delete_link_child_site',   
                   link_id: link_id,
                   delete_permanent: del_on_child_site == 1 ? 1 : 0
                }    
                jQuery.post(ajaxurl, data2, function(response2) {                              
                    parent.find('.kwl-ajax-message-zone').html(response2.message).show();                                                        
                    //if (response2.success == true) {                                       
                        keyword_links_delete_link_data(link_id, parent);
                    //} else {
                      //  keyword_links_load_links_timeout();                        
                    //}                                        
                }, 'json');                   
//            } 
//            else {
//                keyword_links_delete_link_data(link_id, parent);
//            }    
            return false;    
        });
        
        keyword_links_delete_link_data = function(link_id, parent) {
                var data = {
                    action: 'keyword_links_delete_link', 
                    link_id: link_id                     
                };
                $.ajax({url: ajaxurl, data: data , success: function(response) {
                    response = $.parseJSON(response);
                    parent.find('.kwl-link-loading').hide();
                    if (response.success === true) {
                        parent.find('.kwl-ajax-message-zone').html(__('The link was delete successfully.')).show();                                                
                    }
                    else
                    {
                        parent.find('.kwl-ajax-message-zone').html(__('Delete link failed.')).show();                
                    }
                    keyword_links_load_links_timeout();                        
                }, type: 'POST'});
        }
        
        $('#kwl-setting-group-delete').live('click', function() {
            var confirmed = confirm(__('Are you sure?'));            
            if (!confirmed)
                return false;    
            var row = $(this).closest('tr');
            var group_id = $(this).attr('group-id');
            $.ajax({url: ajaxurl, data: {
                    action: 'keyword_links_delete_group', 
                    group_id: group_id                     
                }, success: function(response) {
                    response = $.parseJSON(response);
                    if (response.success === true) {
                        row.html(__('<td colspan="3">The group was delete successfully.</td>'));
                    }
                    else
                    {
                        $('#kwl-setting-ajax-zone').html(__('Delete group failed.')).show();
                    }
                }, type: 'POST'});
            
            return false;    
        });        
        
        
        $('#kwl-btn-save-option').live('click', function() {
            var obj = $('.option-tab-wrapper #tab-config');
            var send_fields = keyword_links_get_send_fields(obj);
            var loading = jQuery(this).closest('.option-submit').find('.kwl-link-loading');
            loading.show();
            send_fields['action'] = 'keyword_links_save_configuration';
            jQuery('#kwl-option-save-status').text(__("Saving configuration.."));            
            jQuery.post(ajaxurl, send_fields, function(response) {
                if (response == 'SUCCESS') {                                                            
                    jQuery('#kwl-option-save-status').text(__("Saving configuration to child sites.."));            
                    var data = {
                       action: 'keyword_links_save_configuration_child_site'                          
                    }                        
                    jQuery.post(ajaxurl, data, function(response) {                                                    
                        jQuery('#kwl-option-save-status').text("");            
                        jQuery('#kwl-option-ajax-message-zone').html('<div class="mainwp_info-box-yellow">' + response + '</div>').show();                              
                        loading.hide();                            
                        setTimeout(function() {
                            location.href = 'admin.php?page=Extensions-Mainwp-Links-Manager-Extension&message=1';
                        }, 2000); 
                    });                      
                } else {
                    location.href = 'admin.php?page=Extensions-Mainwp-Links-Manager-Extension&message=-1';
                }
            });  
            return false;
        });
        
        keyword_links_get_send_fields = function(pObj) {        
                var fields = pObj.find('input[type=hidden], input[type=text], input[type=text_help],input[type=password], input[type=checkbox]:checked, input[type=radio]:checked, select, textarea');
                var send_fields = {};
                for (i = 0; i < fields.size(); i++)
                {
                    field = jQuery(fields[i]);
                    if (!field.attr('disabled') && field.attr('name'))
                    {
                        var value = field.val();
                        var name = field.attr('name');
                        if (name.match(/\[.*?\]/))
                        {
                            var k = parseInt(name.match(/\[(.*?)\]/)[1]);
                            name = name.replace(/\[.*?\]/, '');
                            if (typeof(send_fields[name]) == 'undefined')
                                send_fields[name] = new Array();
                            if (!k)
                                k = 0;
                            if (k == 0 && send_fields[name].length > 0)
                            {
                                k = send_fields[name].length;
                            }
                            send_fields[name][k] = value;
                        }
                        else
                        {
                            send_fields[name] = value;
                        }
                    }
                }
                return send_fields;        
        } 
        
        
        $('#close_btn').live('click', function() {
            tb_remove();
        })
        
        $('#kwl-edit-link-form form').live('submit', function() {
            $(this).find('input[type=submit]').attr('disabled', 'disabled');
            $(this).find('.kwl-link-loading').show();
            $(this).find('.field-error-msg').prev('br').remove();
            $(this).find('.error, .field-error-msg').remove();
            $(this).find('.field-error').removeClass('field-error');
            var fields = {};
            fields.link_id = ($(this).find('input[name=link_id]').size() > 0) ? $('input[name=link_id]').val() : '';
            fields.link_name = $(this).find('input[name=link_name]').val();
            fields.link_destination_url = $(this).find('input[name=link_destination_url]').val();
            fields.link_cloak_path = $(this).find('input[name=link_cloak_path]').val();
            fields.link_keyword = $(this).find('textarea[name=link_keyword]').val();
            fields.link_group = $(this).find('select[name=link_group]').val();
            fields.link_nofollow = $(this).find('select[name=link_nofollow]').val();
            fields.link_newtab = $(this).find('select[name=link_newtab]').val();
            fields.link_class = $(this).find('input[name=link_class]').val();                        
            fields.link_type = $(this).find('input[name=link_type]').val();                        
            fields.link_exact_match = $(this).find('select[name=link_exact_match]').val();
            fields.link_case_sensitive = $(this).find('select[name=link_case_sensitive]').val();
            
            if (jQuery('#kwl-edit-link-form #select_by').val() == 'site') {
                var selected_sites = [];
                jQuery("#kwl-edit-link-form input[name='selected_sites[]']:checked").each(function (i) {
                    selected_sites.push(jQuery(this).val());
                });
                fields.selected_sites = selected_sites;
            }
            else {
                var selected_groups = [];
                jQuery("#kwl-edit-link-form input[name='selected_groups[]']:checked").each(function (i) {
                    selected_groups.push(jQuery(this).val());
                });
                fields.selected_groups = selected_groups;
            }
            fields.selected_by = $('#kwl-edit-link-form #select_by').val();            
            fields.action = 'keyword_links_save_link';            
            var form_o = $(this);
            // save link into database
            $.post(ajaxurl, fields, function(data) {
                if (data['success'] == true)
                {
                    jQuery('#kwl-edit-link-ajax-message-zone').html('<div class="mainwp_info-box-yellow">' + __('The link saved successfully.') + '</div>').show();
                            
                    var link_id = fields.link_id ? fields.link_id : data['link_id'];                                        
                    var data1 = {
                        action: 'keyword_links_clear_link_child_site',   
                        link_id: link_id,
                        current_sites: $('#link_current_sites').val(),
                        current_groups: $('#link_current_groups').val()
                    }                        
                    
                    // clear the link on child site
                    jQuery.post(ajaxurl, data1, function(response) {                            
                        if (typeof response != "undefined" && response != false) {                          
                            jQuery('#kwl-edit-link-ajax-message-zone').html('<div class="mainwp_info-box-yellow">' + response + '</div>').show();
                        }
                        
                        var data2 = {
                            action: 'keyword_links_save_link_child_site',   
                            link_id: link_id                        
                        }    
                        // save the link on child site
                        jQuery.post(ajaxurl, data2, function(response) {
                            if (response && response.message) {
                                var error = '';
                                if (response.error_keywords)
                                    error = '<div class="mainwp_info-box-red">' + response.error_keywords + '</div>';
                                jQuery('#kwl-edit-link-ajax-message-zone').html('<div class="mainwp_info-box-yellow">' + response.message + '</div>' + error).show();
                                keyword_links_load_links(); 
                                if (!response.norefresh) {
                                    setTimeout(function () {
                                        tb_remove();
                                    }, 2000);
                                } else {
                                    jQuery('#submit_savelink').hide();
                                    jQuery('#close_btn').show();
                                }
                            } 
                            else 
                            {
                                tb_remove();
                                keyword_links_load_links();        
                            }
                            form_o.find('.kwl-link-loading').hide();                            
                        }, 'json');                       
                    });
                }
                else
                {
                    if (data['error'])
                        form_o.prepend('<div class="error"><p>' + data['error'] + '</p></div>');
                    if (typeof(data['field_error']['link_name']) != 'undefined')
                        form_o.find('input[name=link_name]').addClass('field-error').after('<br /><span class="field-error-msg">' + data['field_error']['link_name'] + '</span>');
                    if (typeof(data['field_error']['link_destination_url']) != 'undefined')
                        form_o.find('input[name=link_destination_url]').addClass('field-error').after('<br /><span class="field-error-msg">' + data['field_error']['link_destination_url'] + '</span>');
                    if (typeof(data['field_error']['link_cloak_path']) != 'undefined')
                        form_o.find('input[name=link_cloak_path]').addClass('field-error').after('<br /><span class="field-error-msg">' + data['field_error']['link_cloak_path'] + '</span>');
                    if (typeof(data['field_error']['link_keyword']) != 'undefined')
                        form_o.find('textarea[name=link_keyword]').addClass('field-error').after('<br /><span class="field-error-msg">' + data['field_error']['link_keyword'] + '</span>');
                    if (typeof(data['field_error']['link_group']) != 'undefined')
                        form_o.find('select[name=link_group]').addClass('field-error').after('<br /><span class="field-error-msg">' + data['field_error']['link_group'] + '</span>');
                    if (typeof(data['field_error']['link_nofollow']) != 'undefined')
                        form_o.find('select[name=link_nofollow]').addClass('field-error').after('<br /><span class="field-error-msg">' + data['field_error']['link_nofollow'] + '</span>');
                    if (typeof(data['field_error']['link_newtab']) != 'undefined')
                        form_o.find('select[name=link_newtab]').addClass('field-error').after('<br /><span class="field-error-msg">' + data['field_error']['link_newtab'] + '</span>');
                    if (typeof(data['field_error']['link_class']) != 'undefined')
                        form_o.find('input[name=link_class]').addClass('field-error').after('<br /><span class="field-error-msg">' + data['field_error']['link_class'] + '</span>');
                form_o.find('input[type=submit]').removeAttr('disabled');
                form_o.find('.kwl-link-loading').css('visibility', 'hidden');
                }
            }, 'json');
            return false;
        });
        $('#kwl-setting-group-form form').live('submit', function() {
            $(this).find('input[type=submit]').attr('disabled', 'disabled');
            $(this).find('.kwl-link-loading').show();
            $(this).find('.field-error-msg').prev('br').remove();
            $(this).find('.error, .field-error-msg').remove();
            $(this).find('.field-error').removeClass('field-error');
            var fields = {};
            fields.group_id = ($(this).find('input[name=group_id]').size() > 0) ? $('input[name=group_id]').val() : '';
            fields.group_name = $(this).find('input[name=group_name]').val();
            fields.action = 'mainwp_kl_save_group';            
            var form_o = $(this);
            $.post(ajaxurl, fields, function(data) {
                if (data['success'] == true)
                {
                    tb_remove();
                    mainwp_kl_load_group();
                    keyword_links_load_links();
                }
                else
                {
                    if (data['error'])
                        form_o.prepend('<div class="error"><p>' + data['error'] + '</p></div>');
                    if (typeof(data['field_error']['group_name']) != 'undefined')
                        form_o.find('input[name=group_name]').addClass('field-error').after('<br /><span class="field-error-msg">' + data['field_error']['group_name'] + '</span>');
                }
                form_o.find('input[type=submit]').removeAttr('disabled');
                form_o.find('.kwl-link-loading').hide();
            }, 'json');
            return false;
        });
        
        $('#export_download').click(function() {            
            var export_data = '';
            $('[name^="export_data"]:checked').each(function() {
                if (export_data != '')
                    export_data += ',';
                export_data += $(this).val();
            });
            if (export_data == '')
                return false;
            var format_exp = $('[name^="format_export"]:checked').not('hide').first().val();
            var data = {                
                'data': export_data,
                'action': 'mainwp_kl_download_export'
            };
            location.href = ajaxurl + "?data=" + data.data + "&action=" + data.action + "&format_export=" + format_exp;            
            return false;
        });
    }
    $(".redirection_folder_help").qtip({
        content: "<p>Links Manager Extension provides easy to use redirection support for customer keywords. Custom links can be  redirection through the Redirection Folder Below. Default is \"goto\" (Redirection link would be formed as http://yoursite.com/goto/word)If you leave blank NO redirection folder will be used and you will need to be careful how you name your post</p> ",
        style: {
            border: {
                width: 1,
                radius: 8,
                color: '#6699CC',
            },
        }
    });  
    
    $("input[name=btn_donotlink]").click(function() {      
        var donotlinks = $('#kwl_do_not_links').val();
        var parent = $(this).closest('.option-submit');
        $('#kwl-setting-ajax-zone').hide();
        parent.find('.kwl-link-loading').show();
        jQuery.post(ajaxurl, {
            'action': 'keyword_links_save_do_not_links',
            'donotlinks': donotlinks
        }, function(response) {
           if (response.success) {        
                var nonce = $('input[name=kwl-dnl-save-nonce]').val();
                location.href = 'admin.php?page=Extensions-Mainwp-Links-Manager-Extension&message=5&kwlSaveToSites=' + nonce;                
            } else {                
                location.href = 'admin.php?page=Extensions-Mainwp-Links-Manager-Extension&message=-5';              
            }
        }, 'json');
    })
	
    $("input[name=btn_stats]").click(function() {      
        var enableStats = $('#mainwp_lm_stats_option_footprint').is(':checked') ? 1 : 0;
        var parent = $(this).closest('.option-submit');
        $('#kwl-stats-ajax-zone').hide();
        parent.find('.kwl-link-loading').show();
        jQuery.post(ajaxurl, {
            'action': 'keyword_links_save_stats_options',
            'enablestats': enableStats
        }, function(response) {           
            var nonce = $('input[name=kwl-stats-option-nonce]').val();
            location.href = 'admin.php?page=Extensions-Mainwp-Links-Manager-Extension&kwlApplyStatsOptionToSites=' + nonce;                            
        });
    })
	

    $("input[name=btn_remove_kws]").click(function() {                      
        $('#kwl_remove_keywords').removeClass('form-invalid');
        $('#kwl_remove_settings').removeClass('form-invalid');
        $('#selected_sites').removeClass('form-invalid');
      
        var remove_keywords = $('#kwl_remove_keywords').val();
        var remove_all = $('#kwl_remove_settings').is(':checked') ? 1 : 0;
       
        var errors = []; 
        var selected_sites = [];
        var selected_groups = [];
        
        if ($.trim(remove_keywords) == '' && remove_all == 0) {
            errors.push(__('Keywords is required or select Remove All Keywords and Settings'));
            $('#kwl_remove_keywords').addClass('form-invalid');
            $('#kwl_remove_settings').addClass('form-invalid');
        } 
        
        if (jQuery('#select_by').val() == 'site') {
            jQuery("input[name='selected_sites[]']:checked").each(function (i) {
                selected_sites.push(jQuery(this).val());
            });
            if (selected_sites.length == 0) {
                errors.push(__('Please select websites or groups.'));
                $('#selected_sites').addClass('form-invalid');
            }
        }
        else {
            jQuery("input[name='selected_groups[]']:checked").each(function (i) {
                selected_groups.push(jQuery(this).val());
            });
            if (selected_groups.length == 0) {
                errors.push(__('Please select websites or groups.'));
                $('#selected_sites').addClass('form-invalid');
            }
        }
       
        if (errors.length > 0) {
            show_error('mwp-kwl-remove-links-error-box', errors.join('<br />'));                    
            return false;
        } else {
            jQuery('#mwp-kwl-remove-links-error-box').html("").hide();            
        }
        
        var parent = $(this).closest('.option-submit');        
        parent.find('.kwl-link-loading').show();
        jQuery.post(ajaxurl, {
            action: 'keyword_links_remove_keywords',
            removeKeywords: remove_keywords,
            removeAll: remove_all,
            'groups[]':selected_groups,
            'sites[]':selected_sites,
        }, function(response) {
            parent.find('.kwl-link-loading').hide();
            if (response) {
                if (response == "NOKEYWORDS") {        
                    jQuery("#mwp-kwl-remove-links-error-box").html("Keywords is required").show();
                } else if (response == "NOSITE") {        
                    jQuery("#mwp-kwl-remove-links-error-box").html("Please select websites or groups.").show();
                } else {   
                    jQuery("#mainwp_kwl_remove_keywords_inside").html(response);
                    jQuery("input[name=btn_remove_kws]").attr('disabled', true);
                }
            } else {
                jQuery("#mwp-kwl-remove-links-error-box").html("Undefined error").show();
            }            
        });
    })
    
});

function mainwp_kl_load_statistic(id) {
    var prs = jQuery.parseJSON(jQuery('#' + id).attr('data'));
    jQuery.get(ajaxurl, {
        'action': 'mainwp_kl_load_statistic',
        's': prs.s,
        'e': prs.e,
        'y': prs.y,
        'label': prs.label,
        'link_id': prs.link_id,
        'type': prs.type
    }, function(data) {
        jQuery('#' + id).html(data);
        //jQuery('#mainwp-kl-link-list').animate({opacity: 1.0}, 1000);
    });
}
function keyword_links_load_links(sort_type, sort_direction)
{
    //jQuery('#mainwp-kl-link-list').animate({opacity: 0.2}, 100);
    if (!sort_type)
        sort_type = 'name';
    if (!sort_direction)
        sort_direction = 'asc';
    jQuery.get(ajaxurl, {
        'action': 'keyword_links_load_links',        
        'sort_type': sort_type,
        'sort_direction': sort_direction
    }, function(data) {
        jQuery('#mainwp-kl-link-list').html(data);
        //jQuery('#mainwp-kl-link-list').animate({opacity: 1.0}, 1000);
    });
    
}
function mainwp_kl_load_group()
{
    //jQuery('#mainwp-kl-group-list').animate({opacity: 0.2}, 100);
    jQuery.get(ajaxurl, {
        'action': 'mainwp_kl_load_group',        
    }, function(data) {
        jQuery('#mainwp-kl-group-list').html(data);
        //jQuery('#mainwp-kl-group-list').animate({opacity: 1.0}, 1000);
    });
}
function setCookie(c_name, value, expiredays)
{
    var exdate = new Date();
    exdate.setDate(exdate.getDate() + expiredays);
    document.cookie = c_name + "=" + escape(value) + ((expiredays == null) ? "" : ";expires=" + exdate.toUTCString());
}
function getCookie(c_name)
{
    if (document.cookie.length > 0)
    {
        var c_start = document.cookie.indexOf(c_name + "=");
        if (c_start != -1)
        {
            c_start = c_start + c_name.length + 1;
            var c_end = document.cookie.indexOf(";", c_start);
            if (c_end == -1)
                c_end = document.cookie.length;
            return unescape(document.cookie.substring(c_start, c_end));
        }
    }
    return "";
}

kwl_maxSitesThreads = 3;
kwl_currentSitesThreads = 0;
kwl_totalSitesThreads = 0;
kwl_finishedSitesThreads = 0;

kwl_FinishedDNLThreads = 0;
kwl_TotalDNLThreads = 0;


kwl_ApplyLinksToSitesStarted = false;
kwl_ApplyDoNotLinksToSitesStarted = false;

keyword_links_import_data_to_sites = function() {
    
    jQuery.get(ajaxurl, {
        'action': 'keyword_links_import_refresh_data_sites',        
    }, function(response) {
        if (response.message) {
            jQuery('#kwl-import-resfresh-data-sites').html('<div class="mainwp_info-box-yellow">' + response.message + '</div>');
        } else 
            jQuery('#kwl-import-resfresh-data-sites').html('');
        
       jQuery.get(ajaxurl, {
           'action': 'keyword_links_preimport_config',        
       }, function(response) {
           if (response.error) {
               jQuery('#kwl-import-config-to-sites').html(response.message);
           } else {
               var importConfigQueue = '';            
               importConfigQueue = '<h4>Import configuration</h4>';            
               for (i = 0; i < response.sites.length; i++)            
               {
                   var site = response.sites[i];                
                   importConfigQueue += '<span class="importBulkConfig" siteid="' + site['id'] + '" status="queue"><strong>' + site['name'] + '</strong>: <span class="queue">'+__('Queued')+'</span><span class="progress"><img src="' + mainwpParams['image_url'] + 'loader.gif"> '+__('In progress')+'</span><span class="status"></span></span><br />';
               }
               jQuery('#kwl-import-config-to-sites').html(importConfigQueue);
               keyword_links_import_config_start_next();
           }
       }, 'json');
   }, 'json');
};


keyword_links_import_config_start_next = function()
{
    while ((siteToImportConfig = jQuery('.importBulkConfig[status="queue"]:first')) && (siteToImportConfig.length > 0)  && (kwl_currentSitesThreads < kwl_maxSitesThreads))
    {        
        keyword_links_import_config_start_specific(siteToImportConfig);
    }
    if (siteToImportConfig.length  == 0 && !kwl_ApplyLinksToSitesStarted) {
        kwl_ApplyLinksToSitesStarted = true;
        keyword_links_preimport_links_data();
    }
};


keyword_links_import_config_start_specific = function (pSiteToImportConfig)
{
    kwl_currentSitesThreads++;
    pSiteToImportConfig.attr('status', 'progress');
    pSiteToImportConfig.find('.queue').hide();
    pSiteToImportConfig.find('.progress').show();

    var data = {
        action:'keyword_links_perform_import_config',        
        siteId: pSiteToImportConfig.attr('siteid')
    };

    jQuery.post(ajaxurl, data, function (pSiteToImportConfig)
    {
        return function (response)
        {
            pSiteToImportConfig.attr('status', 'done');

            pSiteToImportConfig.find('.progress').hide();
            var statusEl = pSiteToImportConfig.find('.status');
            statusEl.show();

            if ((response.ok != undefined) && (response.ok[pSiteToImportConfig.attr('siteid')] != undefined))
            {
                statusEl.html(__('Import configuration successful'));
            }
            else if ((response.status != undefined) && (response.status[pSiteToImportConfig.attr('siteid')] != undefined))
            {
                statusEl.html(response.status[pSiteToImportConfig.attr('siteid')]);
                statusEl.css('color', 'red');
            } else if (response.error != undefined) {
                statusEl.html(response.error);
                statusEl.css('color', 'red');
            }
            else
            {
                statusEl.html(__('Import configuration failed'));
                statusEl.css('color', 'red');
            }

            kwl_currentSitesThreads--;
            keyword_links_import_config_start_next();
        }
    }(pSiteToImportConfig), 'json');
};


keyword_links_preimport_links_data = function ()
{
    jQuery.get(ajaxurl, {
        'action': 'keyword_links_preimport_links',        
    }, function(response) {
        if (response.message) {
            jQuery('#kwl-import-links-to-sites').html(response.message);
        } else {
            var importLinksQueue = '<br /><h4>Import links</h4>';
            for (var linkId in response.links)
            {
                var link = response.links[linkId];
                importLinksQueue += '<h5>' + link['name'] + '</h5>';
                for (var siteId in link.sites)
                {
                    var site = link.sites[siteId];
                    importLinksQueue += '<span class="importBulkLinks" linkid="' + linkId + '" siteid="' + siteId + '" status="queue"><strong>' + site['name'] + '</strong>: <span class="queue">'+__('Queued')+'</span><span class="progress" style="display:none"><img src="' + mainwpParams['image_url'] + 'loader.gif"> '+__('In progress')+'</span><span class="status"></span></span><br />';
                }
            }
            
            if (typeof response.links == "undefined")
                importLinksQueue += __('These are not links.');            
            jQuery('#kwl-import-links-to-sites').html(importLinksQueue);
            kwl_currentSitesThreads = 0; // to fix bug            
            keyword_links_import_links_start_next();
        }
    }, 'json');
}

keyword_links_import_links_start_next = function()
{
    while ((siteToImportLinks = jQuery('.importBulkLinks[status="queue"]:first')) && (siteToImportLinks.length > 0)  && (kwl_currentSitesThreads < kwl_maxSitesThreads))
    {        
        keyword_links_import_links_start_specific(siteToImportLinks);
    }
    
    if (siteToImportLinks.length  == 0 && !kwl_ApplyDoNotLinksToSitesStarted) {
        kwl_ApplyDoNotLinksToSitesStarted = true;        
        keyword_links_do_not_link_pre_apply_to_sites();
    }
    
};

keyword_links_import_links_start_specific = function (pSiteToImportLinks)
{
    
    kwl_currentSitesThreads++;
    pSiteToImportLinks.attr('status', 'progress');
    pSiteToImportLinks.find('.queue').hide();
    pSiteToImportLinks.find('.progress').show();

    var data = {
        action:'keyword_links_perform_import_links',        
        siteId: pSiteToImportLinks.attr('siteid'),
        linkId: pSiteToImportLinks.attr('linkid')
    };
    
    jQuery.post(ajaxurl, data, function (pSiteToImportLinks)
    {
        return function (response)
        {
            pSiteToImportLinks.attr('status', 'done');
            pSiteToImportLinks.find('.progress').hide();
            var statusEl = pSiteToImportLinks.find('.status');
            statusEl.show();

            if ((response.ok != undefined) && (response.ok[pSiteToImportLinks.attr('siteid')] != undefined))
            {
                statusEl.html(__('Import link successful'));
            } else if ((response.status != undefined) && (response.status[pSiteToImportLinks.attr('siteid')] != undefined))
            {
                statusEl.html(response.status[pSiteToImportLinks.attr('siteid')]);
                statusEl.css('color', 'red');
            } else if (response.error != undefined) {
                statusEl.html(response.error);
                statusEl.css('color', 'red');
            } else {
                statusEl.html(__('Import link failed'));
                statusEl.css('color', 'red');
            }

            kwl_currentSitesThreads--;
            keyword_links_import_links_start_next();
        }
    }(pSiteToImportLinks), 'json');
};

keyword_links_do_not_link_pre_apply_to_sites = function() {    
    jQuery.post(ajaxurl, {
        'action': 'keyword_links_clear_donotlink_on_sites',  
        'kwlPreSaveToSites': jQuery('input[name=kwl-dnl-presave-nonce]').val()
    }, function(response) {                   
        if (response) {
            jQuery('#kwl-dnl-clear-on-sites').html('<div class="mainwp_info-box-yellow">' + response.message + '</div>');
        }
        jQuery('#kwl-dnl-apply-to-sites-title').show();        
        jQuery.post(ajaxurl, {
            'action': 'keyword_links_donotlink_pre_apply_to_sites',  
            'kwlPreSaveToSites': jQuery('input[name=kwl-dnl-presave-nonce]').val()
        }, function(response) {            
                var saveDNLinksQueue = ''; 

                if (response) {
                    if (response['site_blocks'] != undefined) {
                        saveDNLinksQueue += '<h4>Sites block</h4>';
                        for ( var url_path in response['site_blocks']) {
                            saveDNLinksQueue += '<h5>' + url_path + '</h5>';
                            var site = response['site_blocks'][url_path];
                            saveDNLinksQueue += '<span class="saveBulkDoNotLink" type="site_blocks" siteid="' + site['siteid'] + '" status="queue"><strong>' + site['name'] + '</strong>: <span class="queue">'+__('Queued')+'</span><span class="progress" style="display:none"><img src="' + mainwpParams['image_url'] + 'loader.gif"> '+__('In progress')+'</span><span class="status"></span></span><br />';
                        }
                      }

                     if (response['fullurl_blocks'] != undefined) {
                        saveDNLinksQueue += '<br /><h4>Full url block</h4>';
                        for ( var url_path in response['fullurl_blocks']) {
                            saveDNLinksQueue += '<h5>' + url_path + '</h5>';
                            var sites = response['fullurl_blocks'][url_path];                            
                            for (var i = 0; i < sites.length; i++) {
                                var site = sites[i];
                                saveDNLinksQueue += '<span class="saveBulkDoNotLink" type="fullurl_blocks" siteid="' + site['siteid'] + '"  path="' + site['path'] + '" status="queue"><strong>' + site['name'] + '</strong>: <span class="queue">'+__('Queued')+'</span><span class="progress" style="display:none"><img src="' + mainwpParams['image_url'] + 'loader.gif"> '+__('In progress')+'</span><span class="status"></span></span><br />';
                            }
                        }
                      }
              
                      if (response['partial_blocks'] != undefined) {
                        saveDNLinksQueue += '<br /><h4>Partial url block</h4>';
                        for ( var url_path in response['partial_blocks']) {
                            saveDNLinksQueue += '<h5>' + url_path + '</h5>';
                            var sites = response['partial_blocks'][url_path];                            
                            for (var i = 0; i < sites.length; i++) {
                                var site = sites[i];
                                saveDNLinksQueue += '<span class="saveBulkDoNotLink" type="partial_blocks" siteid="' +  site['siteid'] + '" path="' + url_path + '" status="queue"><strong>' + site['name'] + '</strong>: <span class="queue">'+__('Queued')+'</span><span class="progress" style="display:none"><img src="' + mainwpParams['image_url'] + 'loader.gif"> '+__('In progress')+'</span><span class="status"></span></span><br />';
                            }   
                        }
                      }
                }
                if (saveDNLinksQueue == '') {
                    jQuery('#kwl-dnl-apply-to-sites').html(__('These are not do not links.'));
                    if (typeof kwl_OnDoNotLinkApplyDone !== "undefined") {
                        kwl_OnDoNotLinkApplyDone();
                    }
                    setTimeout(function() {
                        location.href = 'admin.php?page=Extensions-Mainwp-Links-Manager-Extension';
                    }, 1500);  
                } else {
                    jQuery('#kwl-dnl-apply-to-sites').html(saveDNLinksQueue);
                    kwl_TotalDNLThreads = jQuery('.saveBulkDoNotLink[status="queue"]').length;
                    kwl_FinishedDNLThreads = 0;
                    keyword_links_do_not_link_apply_to_sites_start_next();
                }

            }, 'json');    
    }, 'json');    
};


keyword_links_do_not_link_apply_to_sites_start_next = function()
{
    while ((siteDNLToSites = jQuery('.saveBulkDoNotLink[status="queue"]:first')) && (siteDNLToSites.length > 0)  && (kwl_currentSitesThreads < kwl_maxSitesThreads))
    {        
        keyword_links_do_not_link_apply_to_sites_start_specific(siteDNLToSites);
    }    
};


keyword_links_do_not_link_apply_to_sites_start_specific = function (pSiteDNLToSites)
{    
    kwl_currentSitesThreads++;    
    pSiteDNLToSites.attr('status', 'progress');
    pSiteDNLToSites.find('.queue').hide();
    pSiteDNLToSites.find('.progress').show();

    var data = {
        action:'keyword_links_donotlink_perform_apply_to_sites',        
        type: pSiteDNLToSites.attr('type'),
        siteId: pSiteDNLToSites.attr('siteid')
    };
    
    if (pSiteDNLToSites.attr('path'))
        data['path'] = pSiteDNLToSites.attr('path');
    
    jQuery.post(ajaxurl, data, function (response)
    {
        pSiteDNLToSites.attr('status', 'done');
        pSiteDNLToSites.find('.progress').hide();
        var statusEl = pSiteDNLToSites.find('.status');
        statusEl.show();

        if ((response.ok != undefined) && (response.ok[pSiteDNLToSites.attr('siteid')] != undefined))
        {
            statusEl.html(__('Applied successfully'));
        } else if ((response.status != undefined) && (response.status[pSiteDNLToSites.attr('siteid')] != undefined))
        {
            statusEl.html(response.status[pSiteDNLToSites.attr('siteid')]);
            statusEl.css('color', 'red');
        } else if (response.error != undefined) {
            statusEl.html(response.error);
            statusEl.css('color', 'red');
        } else {
            statusEl.html(__('Failed'));
            statusEl.css('color', 'red');
        }

        kwl_currentSitesThreads--;            
        keyword_links_do_not_link_apply_to_sites_start_next();
       
        kwl_FinishedDNLThreads++;
        if (kwl_FinishedDNLThreads == kwl_TotalDNLThreads) {
            jQuery('#kwl-dnl-apply-to-sites-ajax-message-zone').html('<br /><div class="mainwp_info-box-yellow">' + __('Applied do not links to sites done.') + '</div>').show();
            if (typeof kwl_OnDoNotLinkApplyDone !== "undefined") {
                kwl_OnDoNotLinkApplyDone();
            }
            setTimeout(function() {
                location.href = 'admin.php?page=Extensions-Mainwp-Links-Manager-Extension';
            }, 2000);              
        }            

    }, 'json');
};

keyword_links_stats_options_apply_to_sites_start_next = function() {
	while ((applyStats = jQuery('.applyStatsToSites[status="queue"]:first')) && (applyStats.length > 0)  && (kwl_currentSitesThreads < kwl_maxSitesThreads))
    {        
        keyword_links_stats_options_apply_to_sites_start_specific(applyStats);
    }
}

keyword_links_stats_options_apply_to_sites_start_specific = function (pApplyStatsSite)
{    
    kwl_currentSitesThreads++;    
    pApplyStatsSite.attr('status', 'progress');
    pApplyStatsSite.find('.queue').hide();
    pApplyStatsSite.find('.progress').html('<img src="' + mainwpParams['image_url'] + 'loader.gif"> running..').show();

    var data = {
        action:'keyword_links_stats_perform_apply_to_sites',                
        siteId: pApplyStatsSite.attr('siteid')
    };
    
    jQuery.post(ajaxurl, data, function (response)
    {
        pApplyStatsSite.attr('status', 'done');
        pApplyStatsSite.find('.progress').hide();
        var statusEl = pApplyStatsSite.find('.status');
        statusEl.show();

        if (response && response['status'] == 'SUCCESS') 									
        {
            statusEl.html(__('Applied successfully'));
        } else {
            statusEl.html(__('No change.'));
            statusEl.css('color', 'red');
        }

        kwl_currentSitesThreads--;            
        keyword_links_stats_options_apply_to_sites_start_next();
       
        kwl_FinishedDNLThreads++;
        if (kwl_FinishedDNLThreads == kwl_TotalDNLThreads) {
            jQuery('#kwl-stats-apply-to-sites-ajax-message-zone').html('<br /><div class="mainwp_info-box-yellow">' + __('Applied statistic option to sites done.') + '</div>').show();            
            setTimeout(function() {
                location.href = 'admin.php?page=Extensions-Mainwp-Links-Manager-Extension';
            }, 2000);              
        }            

    }, 'json');
};

jQuery(document).ready(function($) {       
    jQuery('.mainwp-show-tut').on('click', function(){
        jQuery('.mainwp-lm-tut').hide();   
        var num = jQuery(this).attr('number');
        console.log(num);
        jQuery('.mainwp-lm-tut[number="' + num + '"]').show();
        lm_setCookie('lm_quick_tut_number', jQuery(this).attr('number'));
        return false;
    }); 
    
    jQuery('#mainwp-lm-quick-start-guide').on('click', function () {
        if(lm_getCookie('lm_quick_guide') == 'on')
            lm_setCookie('lm_quick_guide', '');
        else 
            lm_setCookie('lm_quick_guide', 'on');        
        lm_showhide_quick_guide();
        return false;
    });
    jQuery('#mainwp-lm-tips-dismiss').on('click', function () {    
        lm_setCookie('lm_quick_guide', '');
        lm_showhide_quick_guide();
        return false;
    });
    
    lm_showhide_quick_guide();

    jQuery('#mainwp-lm-dashboard-tips-dismiss').on('click', function () {    
        $(this).closest('.mainwp_info-box-yellow').hide();
        lm_setCookie('lm_dashboard_notice', 'hide', 2);        
        return false;
    });

});

lm_showhide_quick_guide = function(show, tut) {
    var show = lm_getCookie('lm_quick_guide');
    var tut = lm_getCookie('lm_quick_tut_number');
    
    if (show == 'on') {
        jQuery('#mainwp-lm-tips').show();
        jQuery('#mainwp-lm-quick-start-guide').hide();   
        lm_showhide_quick_tut();        
    } else {
        jQuery('#mainwp-lm-tips').hide();
        jQuery('#mainwp-lm-quick-start-guide').show();    
    }
    
    if ('hide' == lm_getCookie('lm_dashboard_notice')) {
        jQuery('#mainwp-lm-dashboard-tips-dismiss').closest('.mainwp_info-box-yellow').hide();
    }
}

lm_showhide_quick_tut = function() {
    var tut = lm_getCookie('lm_quick_tut_number');
    jQuery('.mainwp-lm-tut').hide();   
    jQuery('.mainwp-lm-tut[number="' + tut + '"]').show();   
}

function lm_setCookie(c_name, value, expiredays)
{
    var exdate = new Date();
    exdate.setDate(exdate.getDate() + expiredays);
    document.cookie = c_name + "=" + escape(value) + ((expiredays == null) ? "" : ";expires=" + exdate.toUTCString());
}
function lm_getCookie(c_name)
{
    if (document.cookie.length > 0)
    {
        var c_start = document.cookie.indexOf(c_name + "=");
        if (c_start != -1)
        {
            c_start = c_start + c_name.length + 1;
            var c_end = document.cookie.indexOf(";", c_start);
            if (c_end == -1)
                c_end = document.cookie.length;
            return unescape(document.cookie.substring(c_start, c_end));
        }
    }
    return "";
}


keyword_links_remove_keywords_start_next = function()
{
    while ((siteToProcess = jQuery('.kwlProcessSiteItem[status="queue"]:first')) && (siteToProcess.length > 0)  && (kwl_currentSitesThreads < kwl_maxSitesThreads))
    {        
        keyword_links_remove_keywords_start_specific(siteToProcess);
    }   
    if (kwl_finishedSitesThreads == kwl_totalSitesThreads) {
        jQuery('#mainwp_kwl_remove_keywords_ajax_message_zone').html("Remove keywords on child sites finished.").show();
        setTimeout(function() {
                location.href = 'admin.php?page=Extensions-Mainwp-Links-Manager-Extension';
        }, 2000);             
    }
};

keyword_links_remove_keywords_start_specific = function (pSiteToProcess)
{    
    kwl_currentSitesThreads++;
    pSiteToProcess.attr('status', 'progress');
    pSiteToProcess.find('.status').hide();
    pSiteToProcess.find('.progress').show();

    var data = {
        action:'keyword_links_perform_remove_keywords',        
        siteId: pSiteToProcess.attr('siteid'),
        removeKeywords: jQuery('#mainwp_kwl_removeKeywords').val(),
        removeSettings: jQuery('#mainwp_kwl_removeAll').val(),
    };
    
    jQuery.post(ajaxurl, data, function (pSiteToProcess)
    {
        return function (response)
        {
            pSiteToProcess.attr('status', 'done');
            pSiteToProcess.find('.progress').hide();
            var statusEl = pSiteToProcess.find('.status');
            
            if (response){
                if (response.status == 'SUCCESS') {
                    statusEl.html(__('Successful'));
                } else if (response.status == 'NOCHANGE') {
                    statusEl.html(__('No change'));
                } else if (response.error) {
                    statusEl.html(response.error);
                    statusEl.css('color', 'red');
                } else {
                    statusEl.html(__('Undefined error'));
                    statusEl.css('color', 'red');
                }                
            } else {
                statusEl.html(__('Undefined error'));
                statusEl.css('color', 'red');
            }
            statusEl.show();
            kwl_finishedSitesThreads++;
            kwl_currentSitesThreads--;
            keyword_links_remove_keywords_start_next();
        }
    }(pSiteToProcess), 'json');
};

