<?php

class MainWP_TimeCapsule_Plugin {

	private $option_handle = 'mainwp_time_capsule_plugin_option';
	private $option = array();
	private static $order = '';
	private static $orderby = '';
	//Singleton
	private static $instance = null;

	static function get_instance() {
		if ( null == MainWP_TimeCapsule_Plugin::$instance ) {
			MainWP_TimeCapsule_Plugin::$instance = new MainWP_TimeCapsule_Plugin();
		}
		return MainWP_TimeCapsule_Plugin::$instance;
	}

	public function __construct() {
		$this->option = get_option( $this->option_handle );
	}

	public function admin_init() {
		add_action( 'wp_ajax_mainwp_time_capsule_upgrade_noti_dismiss', array( $this, 'dismiss_notice' ) );
		add_action( 'wp_ajax_mainwp_time_capsule_active_plugin', array( $this, 'active_plugin' ) );
		add_action( 'wp_ajax_mainwp_time_capsule_upgrade_plugin', array( $this, 'upgrade_plugin' ) );
		add_action( 'wp_ajax_mainwp_time_capsule_showhide_plugin', array( $this, 'ajax_showhide_plugin' ) );
	}

    
	public function get_option( $key = null, $default = '' ) {
		if ( isset( $this->option[ $key ] ) ) {
			return $this->option[ $key ]; }
		return $default;
	}

	public function set_option( $key, $value ) {
		$this->option[ $key ] = $value;
		return update_option( $this->option_handle, $this->option );
	}

    
	public static function gen_tab_dashboard( $websites ) {
        
		$orderby = 'name';
		$_order = 'desc';
		if ( isset( $_GET['timecapsule_orderby'] ) && ! empty( $_GET['timecapsule_orderby'] ) ) {
			$orderby = $_GET['timecapsule_orderby'];
		}
		if ( isset( $_GET['timecapsule_order'] ) && ! empty( $_GET['timecapsule_order'] ) ) {
			$_order = $_GET['timecapsule_order'];
		}

		$name_order = $version_order = $status_order = $last_scan_order = $time_order = $url_order = $hidden_order = '';

		if ( isset( $_GET['timecapsule_orderby'] ) ) {
			if ( 'name' == $_GET['timecapsule_orderby'] ) {
				$name_order = ('desc' == $_order) ? 'asc' : 'desc';
			} else if ( 'version' == $_GET['timecapsule_orderby'] ) {
				$version_order = ('desc' == $_order) ? 'asc' : 'desc';
			} else if ( 'url' == $_GET['timecapsule_orderby'] ) {
				$url_order = ('desc' == $_order) ? 'asc' : 'desc';
			} else if ( 'hidden' == $_GET['timecapsule_orderby'] ) {
				$hidden_order = ('desc' == $_order) ? 'asc' : 'desc';
			}
		}

		self::$order = $_order;
		self::$orderby = $orderby;
		usort( $websites, array( 'MainWP_TimeCapsule_Plugin', 'plugin_data_sort' ) );
		?>
    <table id="mainwp-table-plugins" class="wp-list-table widefat plugins" cellspacing="0">
    <thead>
	    <tr>
		    <th class="check-column">
		    	<input type="checkbox"  id="cb-select-all-1" >
		    </th>
				<th scope="col" class="manage-column sortable <?php echo $name_order; ?>">
					<a href="?page=Extensions-Mainwp-Timecapsule-Extension&timecapsule_orderby=name&timecapsule_order=<?php echo (empty( $name_order ) ? 'asc' : $name_order); ?>"><span><?php _e( 'Site', 'mainwp-timecapsule-extension' ); ?></span><span class="sorting-indicator"></span></a>
		    </th>
				<th scope="col" class="manage-column sortable <?php echo $url_order; ?>">
					<a href="?page=Extensions-Mainwp-Timecapsule-Extension&timecapsule_orderby=url&timecapsule_order=<?php echo (empty( $url_order ) ? 'asc' : $url_order); ?>"><span><?php _e( 'URL', 'mainwp-timecapsule-extension' ); ?></span><span class="sorting-indicator"></span></a>
		    </th>
				<th scope="col" class="manage-column sortable <?php echo $version_order; ?>">
					<a href="?page=Extensions-Mainwp-Timecapsule-Extension&timecapsule_orderby=version&timecapsule_order=<?php echo (empty( $version_order ) ? 'asc' : $version_order); ?>"><span><?php _e( 'Plugin Version', 'mainwp-timecapsule-extension' ); ?></span><span class="sorting-indicator"></span></a>
		    </th>
				<th scope="col" class="manage-column <?php echo $hidden_order; ?>">
					<a href="?page=Extensions-Mainwp-Timecapsule-Extension&timecapsule_orderby=hidden&timecapsule_order=<?php echo (empty( $hidden_order ) ? 'asc' : $hidden_order); ?>"><span><?php _e( 'Visibility', 'mainwp-timecapsule-extension' ); ?></span><span class="sorting-indicator"></span></a>
		    </th>
		    <th scope="col" class="manage-column">
					<span><?php _e( 'Settings' ); ?></span>
		    </th>
		    <th scope="col" class="manage-column">
					<span><?php _e( 'Actions', 'mainwp-timecapsule-extension' ); ?></span>
		    </th>
	    </tr>
    </thead>

    <tfoot>
			<tr>
		    <th class="check-column">
		    	<input type="checkbox"  id="cb-select-all-1" >
		    </th>
				<th scope="col" class="manage-column sortable <?php echo $name_order; ?>">
					<a href="?page=Extensions-Mainwp-Timecapsule-Extension&timecapsule_orderby=name&timecapsule_order=<?php echo (empty( $name_order ) ? 'asc' : $name_order); ?>"><span><?php _e( 'Site', 'mainwp-timecapsule-extension' ); ?></span><span class="sorting-indicator"></span></a>
		    </th>
				<th scope="col" class="manage-column sortable <?php echo $url_order; ?>">
					<a href="?page=Extensions-Mainwp-Timecapsule-Extension&timecapsule_orderby=url&timecapsule_order=<?php echo (empty( $url_order ) ? 'asc' : $url_order); ?>"><span><?php _e( 'URL', 'mainwp-timecapsule-extension' ); ?></span><span class="sorting-indicator"></span></a>
		    </th>
				<th scope="col" class="manage-column sortable <?php echo $version_order; ?>">
					<a href="?page=Extensions-Mainwp-Timecapsule-Extension&timecapsule_orderby=version&timecapsule_order=<?php echo (empty( $version_order ) ? 'asc' : $version_order); ?>"><span><?php _e( 'Plugin Version', 'mainwp-timecapsule-extension' ); ?></span><span class="sorting-indicator"></span></a>
		    </th>
				<th scope="col" class="manage-column <?php echo $hidden_order; ?>">
					<a href="?page=Extensions-Mainwp-Timecapsule-Extension&timecapsule_orderby=hidden&timecapsule_order=<?php echo (empty( $hidden_order ) ? 'asc' : $hidden_order); ?>"><span><?php _e( 'Visibility', 'mainwp-timecapsule-extension' ); ?></span><span class="sorting-indicator"></span></a>
		    </th>
		    <th scope="col" class="manage-column">
					<span><?php _e( 'Settings' ); ?></span>
		    </th>
		    <th scope="col" class="manage-column">
					<span><?php _e( 'Actions', 'mainwp-timecapsule-extension' ); ?></span>
		    </th>
	    </tr>
    </tfoot>

    <tbody id="the-time-capsule-list" class="list:sites">
			<?php
			if ( is_array( $websites ) && count( $websites ) > 0 ) {
				self::get_dashboard_table_row( $websites );
			} else {
				echo '<tr><td colspan="8">' . __( 'No websites were found with the WP Time Capsule plugin installed.', 'mainwp-timecapsule-extension' ) . '</td></tr>';
			}
			?>
    </tbody>
  </table>
	<?php
	}

	public static function get_dashboard_table_row( $websites ) {
		$dismiss = array();
		if ( session_id() == '' ) {
			session_start(); }
		if ( isset( $_SESSION['mainwp_time_capsule_dismiss_upgrade_plugin_notis'] ) ) {
			$dismiss = $_SESSION['mainwp_time_capsule_dismiss_upgrade_plugin_notis'];
		}

		if ( ! is_array( $dismiss ) ) {
			$dismiss = array(); }

		$plugin_name = 'WP Time Capsule';

        $location = 'admin.php?page=wp-time-capsule-monitor';
		foreach ( $websites as $website ) {	
			$website_id = $website['id'];
			$cls_active = (isset( $website['plugin_active'] ) && ! empty( $website['plugin_active'] )) ? 'active' : 'inactive';
			$cls_update = (isset( $website['the_plugin_upgrade'] )) ? 'update' : '';
			$cls_update = ('inactive' == $cls_active) ? 'update' : $cls_update;
			$showhide_action = (1 == $website['hide_backupwp']) ? 'show' : 'hide';
			$showhide_link = '<a href="#" class="mwp_time_capsule_showhide_plugin" showhide="' . $showhide_action . '"><i class="fa fa-eye-slash"></i> ' . ('show' === $showhide_action ? 'Show ' . $plugin_name . ' plugin' : 'Hide ' . $plugin_name . ' plugin') . '</a>';

			$td_status = '';
			?>
			<tr class="<?php echo $cls_active . ' ' . $cls_update; ?>" website-id="<?php echo $website_id; ?>" plugin-name="<?php echo $plugin_name; ?>">
      	<th class="check-column">
	        <input type="checkbox"  name="checked[]">
        </th>
	      <td>
					<a href="admin.php?page=managesites&dashboard=<?php echo $website_id; ?>"><?php echo $website['name']; ?></a><br/>
					<div class="row-actions"><span class="dashboard"><a href="admin.php?page=managesites&dashboard=<?php echo $website_id; ?>"><i class="fa fa-tachometer"></i> <?php _e( 'Overview', 'mainwp-timecapsule-extension' ); ?></a></span> | <span class="edit"><a href="admin.php?page=managesites&id=<?php echo $website_id; ?>"><i class="fa fa-pencil-square-o"></i> <?php _e( 'Edit' ); ?></a> | <?php echo $showhide_link; ?></span></div>
					<div class="its-action-working"><span class="status" style="display:none;"></span><span class="loading" style="display:none;"><i class="fa fa-spinner fa-pulse"></i> <?php _e( 'Please wait...' ); ?></span></div>
        </td>
        <?php
          $change_store_location = '/wp-admin/admin.php?page=wp-time-capsule&show_connect_pane=set';
          $change_store_location = base64_encode($change_store_location);
        ?>
        <td>
					<a href="<?php echo $website['url']; ?>" target="_blank"><?php echo $website['url']; ?></a><br/>
					<div class="row-actions"><span class="edit"><a target="_blank" href="admin.php?page=SiteOpen&newWindow=yes&websiteid=<?php echo $website_id; ?>"><i class="fa fa-external-link"></i> <?php _e( 'Open WP-Admin', 'mainwp-timecapsule-extension' ); ?></a></span> |
          	<span class="edit"><a href="admin.php?page=SiteOpen&newWindow=yes&websiteid=<?php echo $website_id; ?>&location=<?php echo base64_encode( $location ); ?>" target="_blank"><i class="fa fa-cog"></i> <?php _e( 'Open WP Time Capsule', 'mainwp-timecapsule-extension' ); ?></a></span> |
          	<span><a href="admin.php?page=SiteOpen&newWindow=yes&websiteid=<?php echo $website_id; ?>&openUrl=yes&location=<?php echo $change_store_location; ?>" target="_blank"><i class="fa fa-pencil-square-o"></i> <?php _e( 'Change cloud storage', 'mainwp-timecapsule-extension' ); ?></a></span>
          </div>
        </td>
        <td>
					<?php
					if ( isset( $website['the_plugin_version'] ) ) {
						echo $website['the_plugin_version'];
					} else {
						echo '&nbsp;'; }
					?>
        </td>
        <td>
					<span class="the_plugin_hidden_title">
						<?php
						echo (1 == $website['hide_backupwp']) ? __( 'Yes' ) : __( 'No' );
						?>
          </span>
        </td>
        <td>
					<span><?php echo ($website['isOverride'] ? __( 'Individual', 'mainwp-timecapsule-extension' ) : __( 'General' )); ?></span>
        </td>
        <td>
					<span><a href="admin.php?page=ManageSitesWPTimeCapsule&tab=backup&id=<?php echo $website_id; ?>"><?php _e( 'Backup Now', 'mainwp-timecapsule-extension' ); ?></a></span> |
					<span><a href="admin.php?page=ManageSitesWPTimeCapsule&tab=staging&id=<?php echo $website_id; ?>"><?php _e( 'Staging', 'mainwp-timecapsule-extension' ); ?></a></span> |
        	<span><a href="admin.php?page=Extensions-Mainwp-Timecapsule-Extension&tab=activity_log&site_id=<?php echo $website_id; ?>"><?php _e( 'Logs', 'mainwp-timecapsule-extension' ); ?></a></span> |
          <span><a href="admin.php?page=ManageSitesWPTimeCapsule&tab=info&tab=info&id=<?php echo $website_id; ?>"><?php _e( 'Info', 'mainwp-timecapsule-extension' ); ?></a></span>
        </td>
      </tr>
			<?php
			$active_link = $update_link = '';
			$version = '';
			$plugin_slug = $website['plugin_slug'];
			if ( isset( $website['plugin_active'] ) && empty( $website['plugin_active'] ) ) {
				$active_link = '<a href="#" class="mwp_time_capsule_active_plugin" >Activate ' . $plugin_name . ' plugin</a>'; }

			if ( isset( $website['the_plugin_upgrade'] ) ) {
				if ( isset( $website['the_plugin_upgrade']['new_version'] ) ) {
					$version = $website['the_plugin_upgrade']['new_version']; }
				$update_link = '<a href="#" class="mwp_time_capsule_upgrade_plugin" >Update ' . $plugin_name . ' plugin</a>';
				if ( isset( $website['the_plugin_upgrade']['plugin'] ) ) {
					$plugin_slug = $website['the_plugin_upgrade']['plugin']; }
			}

			$hide_update = false;
			if ( isset( $dismiss[ $website_id ] ) ) {
				$hide_update = true;
			}

			if ( ! empty( $active_link ) || ! empty( $update_link ) ) {
			
				$link_row = $active_link . ' | ' . $update_link;
				$link_row = rtrim( $link_row, ' | ' );
				$link_row = ltrim( $link_row, ' | ' );
				?>
				<tr class="plugin-update-tr" <?php echo ($hide_update ? 'style="display: none"' : ''); ?>>
        	<td colspan="8" class="plugin-update">
						<div class="ext-upgrade-noti update-message" plugin-slug="<?php echo $plugin_slug; ?>" website-id="<?php echo $website_id; ?>" version="<?php echo $version; ?>">
							<p>
								<?php if ( ! $hide_update ) { ?>
									<span style="float:right"><a href="#" class="time_capsule_upgrade_noti_dismiss"><?php _e( 'Dismiss' ); ?></a></span>
								<?php } ?>
								<?php echo $link_row; ?>
									<span class="mwp-plugin-working-row"><i class="fa fa-spinner fa-pulse" style="display: none"></i>&nbsp;<span class="status"></span></span>
							</p>
						</div>
          </td>
        </tr>
				<?php
			}
		}
	}

	public static function plugin_data_sort( $a, $b ) {
		if ( 'version' == self::$orderby ) {
			$a = $a['the_plugin_version'];
			$b = $b['the_plugin_version'];
			$cmp = version_compare( $a, $b );
		} else if ( 'url' == self::$orderby ) {
			$a = $a['url'];
			$b = $b['url'];
			$cmp = strcmp( $a, $b );
		} else if ( 'hidden' == self::$orderby ) {
			$a = $a['hide_backupwp'];
			$b = $b['hide_backupwp'];
			$cmp = $a - $b;
		} else {
			$a = $a['name'];
			$b = $b['name'];
			$cmp = strcmp( $a, $b );
		}
		if ( 0 == $cmp ) {
			return 0; }

		if ( 'desc' == self::$order ) {
			return ($cmp > 0) ? -1 : 1; } else {
			return ($cmp > 0) ? 1 : -1; }
	}

	public function get_time_capsule_websites() {
		global $mainwpWPTimeCapsuleExtensionActivator;
		$websites = apply_filters( 'mainwp-getsites', $mainwpWPTimeCapsuleExtensionActivator->get_child_file(), $mainwpWPTimeCapsuleExtensionActivator->get_child_key(), null );
		$sites_ids = array();
		if ( is_array( $websites ) ) {
			foreach ( $websites as $site ) {
				$sites_ids[] = $site['id'];
			}
			unset( $websites );
		}
		$option = array(
            'plugin_upgrades' => true,
			'plugins' => true,
		);
		$dbwebsites = apply_filters( 'mainwp-getdbsites', $mainwpWPTimeCapsuleExtensionActivator->get_child_file(), $mainwpWPTimeCapsuleExtensionActivator->get_child_key(), $sites_ids, array(), $option );
		$dataSites = array();
		if ( count( $sites_ids ) > 0 ) {
			$dataSites = MainWP_TimeCapsule_DB::get_instance()->get_timecapsule_of_sites( $sites_ids );
		}
		return MainWP_TimeCapsule_Plugin::get_instance()->get_websites_with_the_plugin_data( $dbwebsites, $dataSites );
	}

    public function get_websites_with_the_plugin_data( $websites, $dataSites = array() ) {
        $return = array();
		if ( is_array( $websites ) ) {
			foreach ( $websites as $website ) {
				if ( $website && $website->plugins != '' ) {
                    $plugins = json_decode( $website->plugins, 1 );
					if ( is_array( $plugins ) && count( $plugins ) != 0 ) {
						foreach ( $plugins as $plugin ) {
							if ( ('wp-time-capsule/wp-time-capsule.php' == $plugin['slug']) ) {
                                $site = MainWP_TimeCapsule_Utility::map_site( $website, array( 'id' ) );
								if ( ! $plugin['active'] ) {
                                    continue;                                         
                                }
                                $data_site = array( 'id' => $website->id );
                                $data = isset( $dataSites[ $site['id'] ] ) ? $dataSites[ $site['id'] ] : array();
								if ( ! is_array( $data ) ) {
										$data = array();                                         
                                }
                                $data_site['lastbackup_time'] = isset( $data['lastbackup_time'] ) ? $data['lastbackup_time'] : 0;                                
                                $return[ $website->id ] = $data_site;
                                break;
							}
						}
					}
				}
			}
		}
        return $return;
	}
    
	public function get_websites_with_the_plugin( $websites, $selected_group = null, $plugin_data_sites = array() ) {
    
		$websites_data = array();

		$pluginHide = $this->get_option( 'hide_the_plugin' );

		if ( ! is_array( $pluginHide ) ) {
			$pluginHide = array(); }
		$_text = __( 'There are no scheduled backups at the moment.', 'mainwp-timecapsule-extension' );
		if ( is_array( $websites ) && count( $websites ) ) {
			if (  $selected_group === null ) {
				foreach ( $websites as $website ) {
					if ( $website && $website->plugins != '' ) {
						$plugins = json_decode( $website->plugins, 1 );
						if ( is_array( $plugins ) && count( $plugins ) != 0 ) {
							foreach ( $plugins as $plugin ) {
								if ( ('wp-time-capsule/wp-time-capsule.php' == $plugin['slug']) ) {
									$site = MainWP_TimeCapsule_Utility::map_site( $website, array( 'id', 'name', 'url' ) );
                                    if ( $plugin['active'] ) {
                                        $site['plugin_active'] = 1;                                         
                                    } else {
                                        $site['plugin_active'] = 0;                                         
                                    }
                                    // get upgrade info
                                    $site['the_plugin_version'] = $plugin['version'];
                                    $site['plugin_slug'] = $plugin['slug'];
                                    $plugin_upgrades = json_decode( $website->plugin_upgrades, 1 );
                                    if ( is_array( $plugin_upgrades ) && count( $plugin_upgrades ) > 0 ) {
                                        if ( isset( $plugin_upgrades['wp-time-capsule/wp-time-capsule.php'] ) ) {
                                            $upgrade = $plugin_upgrades['wp-time-capsule/wp-time-capsule.php'];
                                            if ( isset( $upgrade['update'] ) ) {
                                                $site['the_plugin_upgrade'] = $upgrade['update'];
                                            }
                                        }
                                    }

                                    $site['hide_backupwp'] = 0;
                                    if ( isset( $pluginHide[ $website->id ] ) && $pluginHide[ $website->id ] ) {
                                        $site['hide_backupwp'] = 1;
                                    }

                                    $plugintDS = isset( $plugin_data_sites[ $site['id'] ] ) ? $plugin_data_sites[ $site['id'] ] : array();
                                    if ( ! is_array( $plugintDS ) ) {
                                        $plugintDS = array(); }

                                    //$site['isPremium'] = isset($plugintDS['is_premium']) ? $plugintDS['is_premium'] : 0;
                                    $site['isOverride'] = isset( $plugintDS['override'] ) ? $plugintDS['override'] : 0;
                                    $websites_data[] = $site;
                                    break;
								}
							}
						}
					}
				}
			} else {
				global $mainwpWPTimeCapsuleExtensionActivator;

				$group_websites = apply_filters( 'mainwp-getdbsites', $mainwpWPTimeCapsuleExtensionActivator->get_child_file(), $mainwpWPTimeCapsuleExtensionActivator->get_child_key(), array(), array( $selected_group ) );
				$sites = array();
				foreach ( $group_websites as $site ) {
					$sites[] = $site->id;
				}
				foreach ( $websites as $website ) {
					if ( $website && $website->plugins != '' && in_array( $website->id, $sites ) ) {
						$plugins = json_decode( $website->plugins, 1 );
						if ( is_array( $plugins ) && count( $plugins ) != 0 ) {
							foreach ( $plugins as $plugin ) {
								if ( ('wp-time-capsule/wp-time-capsule.php' == $plugin['slug']) ) {
									$site = MainWP_TimeCapsule_Utility::map_site( $website, array( 'id', 'name', 'url' ) );
									if ( $plugin['active'] ) {
										$site['plugin_active'] = 1; } else {
										$site['plugin_active'] = 0; }
										$site['the_plugin_version'] = $plugin['version'];
										// get upgrade info
										$plugin_upgrades = json_decode( $website->plugin_upgrades, 1 );
										if ( is_array( $plugin_upgrades ) && count( $plugin_upgrades ) > 0 ) {
											if ( isset( $plugin_upgrades['wp-time-capsule/wp-time-capsule.php'] ) ) {
												$upgrade = $plugin_upgrades['wp-time-capsule/wp-time-capsule.php'];
												if ( isset( $upgrade['update'] ) ) {
													$site['the_plugin_upgrade'] = $upgrade['update'];
												}
											}
										}
										$site['hide_backupwp'] = 0;
										if ( isset( $pluginHide[ $website->id ] ) && $pluginHide[ $website->id ] ) {
											$site['hide_backupwp'] = 1;
										}

										$plugintDS = isset( $plugin_data_sites[ $site['id'] ] ) ? $plugin_data_sites[ $site['id'] ] : array();
										if ( ! is_array( $plugintDS ) ) {
											$plugintDS = array(); }

										//$site['isPremium'] = $plugintDS['is_premium'];
										$site['isOverride'] = $plugintDS['override'];
										$websites_data[] = $site;
										break;
								}
							}
						}
					}
				}
			}
		}

		// if search action
		$search_sites = array();
		if ( isset( $_GET['s'] ) && ! empty( $_GET['s'] ) ) {
			$find = trim( $_GET['s'] );
			foreach ( $websites_data as $website ) {
				if ( stripos( $website['name'], $find ) !== false || stripos( $website['url'], $find ) !== false ) {
					$search_sites[] = $website;
				}
			}
			$websites_data = $search_sites;
		}
		unset( $search_sites );

		return $websites_data;
	}

	public static function gen_select_sites( $websites, $selected_group ) {
		global $mainwpWPTimeCapsuleExtensionActivator;
		$groups = apply_filters( 'mainwp-getgroups', $mainwpWPTimeCapsuleExtensionActivator->get_child_file(), $mainwpWPTimeCapsuleExtensionActivator->get_child_key(), null );
		$search = (isset( $_GET['s'] ) && ! empty( $_GET['s'] )) ? trim( $_GET['s'] ) : '';
		?> 

        <div class="alignleft actions bulkactions">
            <select id="mwp_time_capsule_plugin_action">
				<option selected="selected" value="-1"><?php _e( 'Bulk Actions' ); ?></option>
				<option value="activate-selected"><?php _e( 'Active' ); ?></option>
				<option value="update-selected"><?php _e( 'Update' ); ?></option>
				<option value="hide-selected"><?php _e( 'Hide' ); ?></option>
				<option value="show-selected"><?php _e( 'Show' ); ?></option>
            </select>
			<input type="button" value="<?php _e( 'Apply' ); ?>" class="button action" id="mwp_time_capsule_doaction_btn" name="">
        </div>

        <div class="alignleft actions">
            <form action="" method="GET">
                <input type="hidden" name="page" value="Extensions-Mainwp-Timecapsule-Extension">
				<span role="status" aria-live="polite" class="ui-helper-hidden-accessible"><?php _e( 'No search results.', 'mainwp-timecapsule-extension' ); ?></span>
				<input type="text" class="mainwp_autocomplete ui-autocomplete-input" name="s" autocompletelist="sites" value="<?php echo stripslashes( $search ); ?>" autocomplete="off">
                <datalist id="sites">
					<?php
					if ( is_array( $websites ) && count( $websites ) > 0 ) {
						foreach ( $websites as $website ) {
							echo '<option>' . $website['name'] . '</option>';
						}
					}
					?>                
                </datalist>
                <input type="submit" name="" class="button" value="Search Sites">
            </form>
        </div>    
        <div class="alignleft actions">
            <form method="post" action="admin.php?page=Extensions-Mainwp-Timecapsule-Extension">
                <select name="mainwp_time_capsule_plugin_groups_select">
					<option value="0"><?php _e( 'Select a group' ); ?></option>
					<?php
					if ( is_array( $groups ) && count( $groups ) > 0 ) {
						foreach ( $groups as $group ) {
							$_select = '';
							if ( $selected_group == $group['id'] ) {
								$_select = 'selected '; }
							echo '<option value="' . $group['id'] . '" ' . $_select . '>' . $group['name'] . '</option>';
						}
					}
					?>
                </select>&nbsp;&nbsp;                     
				<input class="button" type="submit" name="mwp_time_capsule_plugin_btn_display" value="<?php _e( 'Display', 'mainwp-timecapsule-extension' ); ?>">
            </form>  
        </div>    
		<?php
		return;
	}

	public function dismiss_notice() {
		$website_id = $_POST['timecapsuleSiteID'];
		$version = $_POST['new_version'];
		if ( $website_id ) {
			session_start();
			$dismiss = $_SESSION['mainwp_time_capsule_dismiss_upgrade_plugin_notis'];
			if ( is_array( $dismiss ) && count( $dismiss ) > 0 ) {
				$dismiss[ $website_id ] = 1;
			} else {
				$dismiss = array();
				$dismiss[ $website_id ] = 1;
			}
			$_SESSION['mainwp_time_capsule_dismiss_upgrade_plugin_notis'] = $dismiss;
			die( 'updated' );
		}
		die( 'nochange' );
	}

	public function active_plugin() {
		$_POST['websiteId'] = $_POST['timecapsuleSiteID'];
		do_action( 'mainwp_activePlugin' );
		die();
	}

	public function upgrade_plugin() {
		$_POST['websiteId'] = $_POST['timecapsuleSiteID'];
		do_action( 'mainwp_upgradePluginTheme' );
		die();
	}

	public function ajax_showhide_plugin() {
		$siteid = isset( $_POST['timecapsuleSiteID'] ) ? $_POST['timecapsuleSiteID'] : null;
		$showhide = isset( $_POST['showhide'] ) ? $_POST['showhide'] : null;
		if ( null !== $siteid && null !== $showhide ) {
			global $mainwpWPTimeCapsuleExtensionActivator;
			$post_data = array(
			'mwp_action' => 'set_showhide',
				'showhide' => $showhide,
			);
			$information = apply_filters( 'mainwp_fetchurlauthed', $mainwpWPTimeCapsuleExtensionActivator->get_child_file(), $mainwpWPTimeCapsuleExtensionActivator->get_child_key(), $siteid, 'time_capsule', $post_data );

			if ( is_array( $information ) && isset( $information['result'] ) && 'SUCCESS' === $information['result'] ) {
				$hide_backupwp = $this->get_option( 'hide_the_plugin' );
				if ( ! is_array( $hide_backupwp ) ) {
					$hide_backupwp = array(); }
				$hide_backupwp[ $siteid ] = ('hide' === $showhide) ? 1 : 0;
				$this->set_option( 'hide_the_plugin', $hide_backupwp );
			}
			die( json_encode( $information ) );
		}
		die();
	}
}
