<?php
// @codingStandardsIgnoreStart
/*
UpdraftPlus Addon: backblaze:Backblaze Support
Description: Backblaze Support
Version: 1.0
Shop: /shop/backblaze/
Include: includes/backblaze
IncludePHP: methods/addon-base-v2.php
RequiresPHP: 5.3.3
Latest Change: 1.13.9
*/
// @codingStandardsIgnoreEnd

if (!defined('MAINWP_UPDRAFT_PLUS_DIR')) die('No direct access allowed');

if (!class_exists('MainWP_Updraft_Plus_RemoteStorage_Addons_Base')) require_once(MAINWP_UPDRAFT_PLUS_DIR.'/methods/addon-base.php');

/**
 * Possible enhancements:
 * - Investigate porting to WP HTTP API so that curl is not required
 */
class MainWP_Updraft_Plus_Addons_RemoteStorage_backblaze extends MainWP_Updraft_Plus_RemoteStorage_Addons_Base {

    /**
	 * Constructor
	 */
	public function __construct() {
		
	}
	
	/**
	 * Retrieve default options for this remote storage module.
	 *
	 * @return Array - an array of options
	 */
	public function get_default_options() {
		return array(
			'account_id' => '',
			'key' => '',
			'bucket_name' => '',
			'backup_path' => '',
		);
	}
    
    public function get_opts() {
		global $mainwp_updraftplus;
		$opts = MainWP_Updraft_Plus_Options::get_updraft_option( 'updraft_backblaze' ); //$opts = $mainwp_updraftplus->get_job_option('updraft_azure');
		if (!is_array($opts)) $opts = $this->get_default_options();
		return $opts;
	}
	
    public function do_config_print($opts) {       
        
		$account_id = empty($opts['account_id']) ? '' : $opts['account_id'];
        $key = empty($opts['key']) ? '' : $opts['key'];
        $bucket_name = empty($opts['bucket_name']) ? '' : $opts['bucket_name'];
        $backup_path = empty($opts['backup_path']) ? '' : $opts['backup_path'];
        
        
		ob_start();
	
		global $mainwp_updraftplus_admin;

		$classes = "mwp_updraftplusmethod backblaze"; 
		
		?>

		<tr class="<?php echo $classes;?>">
			<th></th>
			<td>
				<img width="434" src="<?php echo MAINWP_UPDRAFT_PLUS_URL;?>/images/backblaze.png"><br>
				<?php //$mainwp_updraftplus_admin->curl_check('Backblaze B2', false, 'backblaze'); ?>
			</td>
		</tr>
		
		<tr class="<?php echo $classes;?>">
			<th><?php echo _e('Account ID', 'updraftplus'); ?>:</th>
			<td><input type="text" size="40" name="mwp_updraft_backblaze[account_id]" value="<?php  echo $account_id; ?>"><br>
			<em><?php echo sprintf(__('Get these settings from %s, or sign up %s.', 'updraftplus'), '<a target="_blank" href="https://secure.backblaze.com/b2_buckets.htm">'.__('here', 'updraftplus').'</a>', '<a target="_blank" href="https://www.backblaze.com/b2/">'.__('here', 'updraftplus').'</a>');?></em></a><br>
			</td>
		</tr>

		<tr class="<?php echo $classes;?>">
			<th><?php _e('Application key', 'updraftplus'); ?>:</th>
			<td><input type="password" name="mwp_updraft_backblaze[key]" value="<?php echo $key; ?>" /></td>
		</tr>

		<tr class="<?php echo $classes;?>">
			<th><?php _e('Backup path', 'updraftplus'); ?>:</th>
			<td>/<input type="text" size="19" maxlength="50" name="mwp_updraft_backblaze[bucket_name]" placeholder="<?php _e('Bucket name', 'updraftplus');?>" data-updraft_settings_test="bucket_name"  value="<?php echo $bucket_name; ?>" />/<input type="text" size="19" maxlength="200" placeholder="<?php _e('some/path', 'updraftplus');?> " data-updraft_settings_test="backup_path" name="mwp_updraft_backblaze[backup_path]" value="<?php echo $backup_path; ?>" /><br>
			<em><?php echo sprintf(__('N.B. You need to create the bucket in %s first.', 'updraftplus').' <a href="https://help.backblaze.com/hc/en-us/articles/217666908-What-you-need-to-know-about-B2-Bucket-names">'.__('There are limits upon which path-names are valid. Spaces are not allowed.', 'updraftplus').'</a>', '<a target="_blank" href="https://secure.backblaze.com/b2_buckets.htm">'.__('your Backblaze console', 'updraftplus').'</a>');?><br><?php _e('Supported tokens', 'mainwp-updraftplus-extension'); ?> %sitename%, %siteurl%</em><br>
			</td>
		</tr>
		
		<?php
			
		$html = ob_get_clean();
        echo $html;
	}
}
