"use strict";

(function( $ ) {
	var itsecMalwareScan = {
		init: function() {
			this.bindEvents();
		},
		
		bindEvents: function() {
			$( '#itsec-malware-scan-start' ).on( 'click', this.startScan );
			$( '.itsec-malware-scan-results-wrapper' ).on( 'click', '.itsec-malware-scan-toggle-details', this.toggleDetails );
		},
		
		toggleDetails: function( e ) {
			e.preventDefault();
			
			var $container = $(this).parents( '.itsec-malware-scan-results-section' );
			var $details = $container.find( '.itsec-malware-scan-details' );
			
			if ( $details.is(':visible') ) {
				$(this).html( mainwp_itsecMalwareScanData.showDetailsText );
				$details.hide();
			} else {
				$(this).html( mainwp_itsecMalwareScanData.hideDetailsText );
				$details.show();
			}
		},
		
		startScan: function( e ) {
			e.preventDefault();
			
			mainwp_itsecMalwareScanData.originalSubmitButtonText = $(this).val();
			
			$(this)
				.prop( 'disabled', true )
				.val( mainwp_itsecMalwareScanData.clickedButtonText );
			
			var data = {
				'action': 'run-scan'
			};
			
			mainwp_itsecSettingsPage.sendWidgetAJAXRequest( 'malware-scan', data, itsecMalwareScan.handleResponse );
		},
		
		handleResponse: function( results ) {
			$('#itsec-malware-scan-start').hide();
			
			if ( results.errors.length > 0 ) {
				var message;
				
				$.each( results.errors, function( index, error ) {
					message = '<div class="error inline"><p><strong>' + error + '</strong></p></div>';
					$('.itsec-malware-scan-results-wrapper').append( message );
				} );
			} else {
				$('.itsec-malware-scan-results-wrapper').html( results.response );
			}
		},
	};
	
	$(document).ready(function() {
		itsecMalwareScan.init();
	});
        
        //process tooltip actions
        jQuery( '#itsec_one_time_malware_scan_submit' ).click( function ( event ) {
                event.preventDefault(); 
                var caller = this;
                jQuery( caller ).closest('.submit').find('i').show();
                jQuery( caller ).attr('disabled', 'disabled');
                var site_id = jQuery('#mainwp_itheme_managesites_site_id').attr('site-id');                
                if ( site_id > 0) {     
                    mainwp_itheme_individual_malware_scan(site_id, caller);
                } else {  
                    var data = {
                        action:'mainwp_itheme_load_sites',
                        what: 'malware_scan'
                    };            
                    jQuery.post(ajaxurl, data, function (response) {
                        if (response) {
                            jQuery('#mainwp_itheme_screens_tab').html(response);    
                            ithemes_bulkTotalThreads = jQuery('.siteItemProcess[status=queue]').length;
                            if (ithemes_bulkTotalThreads > 0) 
                                mainwp_itheme_malware_scan_start_next();
                        } else {
                            jQuery('#mainwp_itheme_screens_tab').html('<div class="mainwp_info-box-red">' + __("Undefined error.") + '</div>');

                        }
                    })
                } 
        });

})( jQuery );
