<?php

class MainWP_Vulnerability_List {	
	protected static $_instance = null;           
       
	private static $order = '';
	private static $orderby = '';
        
	public static function instance() {
		if ( is_null( self::$_instance ) ) {
			self::$_instance = new self();
		}
		return self::$_instance;
	}
             
	public static function render_dashboard_tab( $websites ) {

		$_orderby = 'name';
		$_order = 'desc';
		if ( isset( $_GET['data_orderby'] ) && ! empty( $_GET['data_orderby'] ) ) {
			$_orderby = $_GET['data_orderby'];
		}
		if ( isset( $_GET['data_order'] ) && ! empty( $_GET['data_order'] ) ) {
			$_order = $_GET['data_order'];
		}
		$name_order = $url_order = $wp_order = $plugin_order = $theme_order = $last_date = '';
		if ( isset( $_GET['data_orderby'] ) && 'name' == $_GET['data_orderby'] ) {
			$name_order = ('desc' == $_order) ? 'asc' : 'desc';
		} else if ( isset( $_GET['data_orderby'] ) && 'url' == $_GET['data_orderby'] ) {
			$url_order = ('desc' == $_order) ? 'asc' : 'desc';
		} else if ( isset( $_GET['data_orderby'] ) && 'wp_vulner' == $_GET['data_orderby'] ) {
			$wp_order = ('desc' == $_order) ? 'asc' : 'desc';
		} else if ( isset( $_GET['data_orderby'] ) && 'plugin_vulner' == $_GET['data_orderby'] ) {
			$plugin_order = ('desc' == $_order) ? 'asc' : 'desc';
		} else if ( isset( $_GET['data_orderby'] ) && 'theme_vulner' == $_GET['data_orderby'] ) {
			$theme_order = ('desc' == $_order) ? 'asc' : 'desc';
		} else if ( isset( $_GET['data_orderby'] ) && 'last_check' == $_GET['data_orderby'] ) {
			$last_date = ('desc' == $_order) ? 'asc' : 'desc';
		}

		self::$order = $_order;
		self::$orderby = $_orderby;                
		usort( $websites, array( 'MainWP_Vulnerability_List', 'data_sort' ) );                
		?>

        <table class="wp-list-table tablesorter widefat fixed striped results" cellspacing="0" id="mainwp_vulner_table">
            <thead>
                <tr>
                    <th id="cb" class="check-column">
                        <div class="header-wrap"><input type="checkbox"  id="cb-select-all-1" ></div>
                    </th>
                    <th scope="col" id="site" class="manage-column drag-enable sortable <?php echo $name_order; ?>">
                            <div class="table-handle"></div> <div class="header-wrap"><a href="?page=Extensions-Mainwp-Vulnerability-Checker-Extension&data_orderby=name&data_order=<?php echo (empty( $name_order ) ? 'asc' : $name_order); ?>"><span><?php _e( 'Site', 'mainwp-vulnerability-checker-extension' ); ?></span><span class="sorting-indicator"></span></a></div>
                    </th>
                    <th scope="col" id="url" class="manage-column drag-enable sortable <?php echo $url_order; ?>">
                        <div class="table-handle"></div> <div class="header-wrap"><a href="?page=Extensions-Mainwp-Vulnerability-Checker-Extension&data_orderby=url&data_order=<?php echo (empty( $url_order ) ? 'asc' : $url_order); ?>"><span><?php _e( 'URL', 'mainwp-vulnerability-checker-extension' ); ?></span><span class="sorting-indicator"></span></a></div>
                    </th>
                    <th scope="col" id="wp-core" class="manage-column drag-enable sortable <?php echo $wp_order; ?>">
                            <div class="table-handle"></div> <div class="header-wrap"><a href="?page=Extensions-Mainwp-Vulnerability-Checker-Extension&data_orderby=result&data_order=<?php echo (empty( $wp_order ) ? 'asc' : $wp_order); ?>"><span><?php _e( 'WP Core', 'mainwp-vulnerability-checker-extension' ); ?></span><span class="sorting-indicator"></span></a></div>
                    </th> 
                    <th scope="col" id="plugin" class="manage-column drag-enable sortable <?php echo $plugin_order; ?>">
                            <div class="table-handle"></div> <div class="header-wrap"><a href="?page=Extensions-Mainwp-Vulnerability-Checker-Extension&data_orderby=plugin_vulner&data_order=<?php echo (empty( $plugin_order ) ? 'asc' : $version_order); ?>"><span><?php _e( 'Plugins', 'mainwp-vulnerability-checker-extension' ); ?></span><span class="sorting-indicator"></span></a></div>
                    </th>                        
                    <th scope="col" id="theme" class="manage-column drag-enable sortable <?php echo $theme_order; ?>">
                            <div class="table-handle"></div> <div class="header-wrap"><a href="?page=Extensions-Mainwp-Vulnerability-Checker-Extension&data_orderby=theme_vulner&data_order=<?php echo (empty( $theme_order ) ? 'asc' : $version_order); ?>"><span><?php _e( 'Themes', 'mainwp-vulnerability-checker-extension' ); ?></span><span class="sorting-indicator"></span></a></div>
                    </th>
                    <th scope="col" id="last-date" class="manage-column drag-enable sortable <?php echo $last_date; ?>">
                            <div class="table-handle"></div> <div class="header-wrap"><a href="?page=Extensions-Mainwp-Vulnerability-Checker-Extension&data_orderby=last_check&data_order=<?php echo (empty( $last_date ) ? 'asc' : $last_date); ?>"><span><?php _e( 'Last check date', 'mainwp-vulnerability-checker-extension' ); ?></span><span class="sorting-indicator"></span></a></div>
                    </th> 
                </tr>
            </thead>
            <tfoot>
                <tr>
                    <th id="cb" class="check-column">
                        <input type="checkbox"  id="cb-select-all-2" >
                    </th>
                    <th scope="col" id="site" class="manage-column drag-enable sortable <?php echo $name_order; ?>">
                            <div class="table-handle"></div> <div class="header-wrap"><a href="?page=Extensions-Mainwp-Vulnerability-Checker-Extension&data_orderby=name&data_order=<?php echo (empty( $name_order ) ? 'asc' : $name_order); ?>"><span><?php _e( 'Site', 'mainwp-vulnerability-checker-extension' ); ?></span><span class="sorting-indicator"></span></a></div>
                    </th>
                    <th scope="col" id="url" class="manage-column drag-enable sortable <?php echo $url_order; ?>">
                            <div class="table-handle"></div> <div class="header-wrap"><a href="?page=Extensions-Mainwp-Vulnerability-Checker-Extension&data_orderby=url&data_order=<?php echo (empty( $url_order ) ? 'asc' : $url_order); ?>"><span><?php _e( 'URL', 'mainwp-vulnerability-checker-extension' ); ?></span><span class="sorting-indicator"></span></a></div>
                    </th>
                    <th scope="col" id="wp-core" class="manage-column drag-enable sortable <?php echo $wp_order; ?>">
                            <div class="table-handle"></div> <div class="header-wrap"><a href="?page=Extensions-Mainwp-Vulnerability-Checker-Extension&data_orderby=wp_vulner&data_order=<?php echo (empty( $wp_order ) ? 'asc' : $wp_order); ?>"><span><?php _e( 'WP Core', 'mainwp-vulnerability-checker-extension' ); ?></span><span class="sorting-indicator"></span></a></div>
                    </th>   
                    <th scope="col" id="plugin" class="manage-column drag-enable sortable <?php echo $plugin_order; ?>">
                            <div class="table-handle"></div> <div class="header-wrap"><a href="?page=Extensions-Mainwp-Vulnerability-Checker-Extension&data_orderby=plugin_vulner&data_order=<?php echo (empty( $plugin_order ) ? 'asc' : $plugin_order); ?>"><span><?php _e( 'Plugins', 'mainwp-vulnerability-checker-extension' ); ?></span><span class="sorting-indicator"></span></a></div>
                    </th>                        
                    <th scope="col" id="theme" class="manage-column drag-enable sortable <?php echo $theme_order; ?>">
                            <div class="table-handle"></div> <div class="header-wrap"><a href="?page=Extensions-Mainwp-Vulnerability-Checker-Extension&data_orderby=theme_vulner&data_order=<?php echo (empty( $theme_order ) ? 'asc' : $theme_order); ?>"><span><?php _e( 'Themes', 'mainwp-vulnerability-checker-extension' ); ?></span><span class="sorting-indicator"></span></a></div>
                    </th>    
                    <th scope="col" id="last-date" class="manage-column drag-enable sortable <?php echo $last_date; ?>">
                            <div class="table-handle"></div> <div class="header-wrap"><a href="?page=Extensions-Mainwp-Vulnerability-Checker-Extension&data_orderby=last_date&data_order=<?php echo (empty( $last_date ) ? 'asc' : $last_date); ?>"><span><?php _e( 'Last check date', 'mainwp-vulnerability-checker-extension' ); ?></span><span class="sorting-indicator"></span></a></div>
                    </th>                    
                </tr>
            </tfoot>
            <tbody id="the-vulner-results-list" class="list:sites">
                    <?php
                    if ( is_array( $websites ) && count( $websites ) > 0 ) {
                            self::gen_data_table_row( $websites );
                    } else {
                            _e( '<tr><td colspan="7">No websites were found with the Vulnerability checker result.</td></tr>' );
                    }
                    ?>
            </tbody>
        </table>
        <?php                
        $current_options = get_option( 'mainwp_opts_saving_status' );
        $col_orders = "";
        if (is_array($current_options) && isset($current_options['vulner_col_order'])) {
            $col_orders = $current_options['vulner_col_order'];            
        }        
        ?>     
        <script type="text/javascript">
            var vulnerColOrder = '<?php echo $col_orders; ?>';
            jQuery(document).ready(function () {
                    //mainwp_table_draggable_init('vulner_results', 'mainwp_vulner_table', vulnerColOrder, 'vulner_col_order');                                                       
            });           
        </script>
                    
        <?php
	}

	public static function gen_data_table_row( $websites ) {
		                 
		foreach ( $websites as $website ) {
			
                        $website_id = $website['id'];
                        $recheck_link = '<a href="#" class="vulner_action_recheck" >' . __( 'Recheck', 'mainwp-vulnerability-checker-extension' ) . '</a>';
                        $open_link = '<a target="_blank" href="admin.php?page=SiteOpen&newWindow=yes&websiteid=' . $website_id . '">' . esc_html__( 'Open WP-Admin', 'mainwp-vulnerability-checker-extension' ) . '</a>';
                        
                        $wp_count = isset($website['wp_vulner_count']) ? intval($website['wp_vulner_count']) : 0;                        
                        if ( $wp_count == 0 ) {
                            $mainwp_tu_color_code = 'mainwp-green';
                        } else if ( $wp_count > 0 && $wp_count < 5 ) {
                            $mainwp_tu_color_code = 'mainwp-yellow';
                        } else {
                            $mainwp_tu_color_code = 'mainwp-red';
                        }
                        $wp_detail = '<span class="fa-stack fa-lg" title="'. __('View detail', 'mainwp-vulnerability-checker-extension') . '">
                            <i class="fa fa-circle fa-stack-2x ' . $mainwp_tu_color_code . '"></i><a href="admin.php?page=ManageSitesVulnerChecker&id=' . $website_id . '"><strong class="mainwp-white fa-stack-1x"><span class="wp_count">' . $wp_count . '</span></strong></a></span>';
                        
                        $plugin_count = isset($website['plugin_vulner_count']) ? intval($website['plugin_vulner_count']) : 0;                        
                        if ( $plugin_count == 0 ) {
                            $mainwp_tu_color_code = 'mainwp-green';
                        } else if ( $plugin_count > 0 && $plugin_count < 5 ) {
                            $mainwp_tu_color_code = 'mainwp-yellow';
                        } else {
                            $mainwp_tu_color_code = 'mainwp-red';
                        }
                        $plugin_detail = '<span class="fa-stack fa-lg" title="'. __('View detail', 'mainwp-vulnerability-checker-extension') . '">
                            <i class="fa fa-circle fa-stack-2x ' . $mainwp_tu_color_code . '"></i><a href="admin.php?page=ManageSitesVulnerChecker&id=' . $website_id . '"><strong class="mainwp-white fa-stack-1x"><span class="plugin_count">' . $plugin_count . '</span></strong></a></span>';
                                                
                        $theme_count = isset($website['theme_vulner_count']) ? intval($website['theme_vulner_count']) : 0;                        
                        if ( $theme_count == 0 ) {
                            $mainwp_tu_color_code = 'mainwp-green';
                        } else if ( $theme_count > 0 && $theme_count < 5 ) {
                            $mainwp_tu_color_code = 'mainwp-yellow';
                        } else {
                            $mainwp_tu_color_code = 'mainwp-red';
                        }
                        $theme_detail = '<span class="fa-stack fa-lg" title="'. __('View detail', 'mainwp-vulnerability-checker-extension') . '">
                            <i class="fa fa-circle fa-stack-2x ' . $mainwp_tu_color_code . '"></i><a href="admin.php?page=ManageSitesVulnerChecker&id=' . $website_id . '"><strong class="mainwp-white fa-stack-1x"><span class="theme_count">' . $theme_count . '</span></strong></a></span>';
                       
                        
                        $last_date = $website['last_check'];
                        
			?>
                    <tr website-id="<?php echo $website_id; ?>">
                        <th class="check-column">
                            <input type="checkbox"  name="checked[]">
                        </th>
                        <td>
                            <a href="admin.php?page=managesites&dashboard=<?php echo $website_id; ?>"><?php echo stripslashes( $website['name'] ); ?></a><br/>
                            <div class="row-actions"><span class="dashboard"><a href="admin.php?page=managesites&dashboard=<?php echo $website_id; ?>"><?php _e( 'Overview', 'mainwp-vulnerability-checker-extension' ); ?></a></span> |  <span class="edit"><a href="admin.php?page=managesites&id=<?php echo $website_id; ?>"><?php _e( 'Edit' ); ?></a></span></div>                    
                        </td>
                        <td>
                            <a href="<?php echo $website['url']; ?>" target="_blank"><?php echo $website['url']; ?></a><br/>
                            <div class="row-actions"><span class="edit"><?php echo $open_link; ?></span> | <span><?php echo $recheck_link; ?></span></div>                    
                            <span class="vulner-result-row-working"><i class="fa fa-spinner fa-pulse" style="display: none"></i> <span class="status"></span></span>
                        </td>
                        <td>
                        <?php echo $wp_detail; ?>
                        </td>
                        <td>
                        <?php echo $plugin_detail; ?>
                        </td>
                        <td>
                        <?php echo $theme_detail; ?>
                        </td>
                        <td>
                        <?php 
                        if ($last_date) {
                            echo MainWP_Vulnerability_Checker::formatTimestamp( MainWP_Vulnerability_Checker::getTimestamp( $last_date ) ); 
                        }
                        ?>
                        </td>                       
                    </tr>        
                    <?php                   
                }
	}

	public static function data_sort( $a, $b ) {
                
		if ( 'url' == self::$orderby ) {
			$a = $a['url'];
			$b = $b['url'];
			$cmp = strcmp( $a, $b );
		} else if ('wp_vulner' == self::$orderby) {
			$a = $a['wp_vulner_count'];
			$b = $b['wp_vulner_count'];
                	$cmp = $a - $b;		
		} else if ('plugin_vulner' == self::$orderby) {
			$a = $a['plugin_vulner_count'];
			$b = $b['plugin_vulner_count'];
                	$cmp = $a - $b;		
		} else if ('theme_vulner' == self::$orderby) {
			$a = $a['theme_vulner_count'];
			$b = $b['theme_vulner_count'];
                	$cmp = $a - $b;		
		} else if ('last_check' == self::$orderby) {
			$a = $a['last_check'];
			$b = $b['last_check'];
                	$cmp = $a - $b;		
		} else {
			$a = $a['name'];
			$b = $b['name'];
			$cmp = strcmp( $a, $b );
		}
                 
		if ( 0 == $cmp ) {
                    return 0;                         
                }
                if ( 'desc' == self::$order ) {
                    return ($cmp > 0) ? -1 : 1;                         
                } else {
                    return ($cmp > 0) ? 1 : -1;                         
                }                
	}

	public function get_websites_result( $websites, $selected_group = 0 ) {
		$sites_results = array();
		
                if ( is_array( $websites ) && count( $websites ) ) {
                    if ( empty( $selected_group ) ) {                        
                        $sites_results = $websites;
                    } else  {				
                        global $mainwp_VulnerCheckerExtensionActivator;
                            $group_websites = apply_filters( 'mainwp-getdbsites', $mainwp_VulnerCheckerExtensionActivator->get_child_file(), $mainwp_VulnerCheckerExtensionActivator->get_child_key(), array(), array( $selected_group ) );				
                            $site_ids = array();
                            foreach ( $group_websites as $site ) {
                                    $site_ids[] = $site->id;
                            }
                                                        
                            foreach ( $websites as $site ) {
                                if ( $site && in_array( $site['id'], $site_ids ) ) {
                                    $sites_results[] = $site;                                        
                                }
                            }
                    }
		}

		// if search action
		$search_sites = array();
		if ( isset( $_GET['s'] ) && ! empty( $_GET['s'] ) ) {
			$find = trim( $_GET['s'] );
			foreach ( $sites_results as $site ) {
				if ( stripos( $site['name'], $find ) !== false || stripos( $site['url'], $find ) !== false ) {
					$search_sites[] = $site;
				}
			}
			$sites_results = $search_sites;
		}
		unset( $search_sites );

		return $sites_results;
	}

	public static function gen_select_sites( $websites, $selected_group ) {
            
		global $mainwp_VulnerCheckerExtensionActivator;
		$groups = apply_filters( 'mainwp-getgroups', $mainwp_VulnerCheckerExtensionActivator->get_child_file(), $mainwp_VulnerCheckerExtensionActivator->get_child_key(), null );
		$search = (isset( $_GET['s'] ) && ! empty( $_GET['s'] )) ? trim( $_GET['s'] ) : '';
		?> 
                <div class="alignleft actions bulkactions">
                    <select id="vulner_results_action" class="mainwp-select2">
                        <option selected="selected" value="-1"><?php _e( 'Bulk Actions', 'mainwp-vulnerability-checker-extension' ); ?></option>
                        <option value="recheck"><?php _e( 'Recheck' ); ?></option>
                        <option value="force-recheck"><?php _e( 'Force recheck' ); ?></option>                        
                    </select>
                        <input type="button" value="<?php _e( 'Apply' ); ?>" class="button action" id="vulner_results_doaction_btn" name="">
                </div>

                <div class="alignleft actions">
                    <form action="" method="GET">
                        <input type="hidden" name="page" value="Extensions-Mainwp-Vulnerability-Checker-Extension">
                        <span role="status" aria-live="polite" class="ui-helper-hidden-accessible"><?php _e( 'No search results.', 'mainwp-vulnerability-checker-extension' ); ?></span>
                        <input type="text" class="mainwp_autocomplete ui-autocomplete-input" name="s" autocompletelist="sites" value="<?php echo stripslashes( $search ); ?>" autocomplete="off">
                        <datalist id="sites">
                            <?php
                            if ( is_array( $websites ) && count( $websites ) > 0 ) {
                                    foreach ( $websites as $website ) {
                                            echo '<option>' . stripslashes( $website['name'] ) . '</option>';
                                    }
                            }
                            ?>                
                        </datalist>
                        <input type="submit" name="" class="button" value="<?php _e('Search Sites', 'mainwp-vulnerability-checker-extension'); ?>">
                    </form>
                </div>    
                <div class="alignleft actions">
                    <form method="post" action="admin.php?page=Extensions-Mainwp-Vulnerability-Checker-Extension">
                        <select name="mainwp_vulner_groups_select" class="mainwp-select2">
                            <option value="0"><?php _e( 'Select a group', 'mainwp-vulnerability-checker-extension' ); ?></option>
                            <?php
                            if ( is_array( $groups ) && count( $groups ) > 0 ) {
                                    foreach ( $groups as $group ) {
                                            $_select = '';
                                            if ( $selected_group == $group['id'] ) {
                                                    $_select = 'selected '; }
                                            echo '<option value="' . $group['id'] . '" ' . $_select . '>' . $group['name'] . '</option>';
                                    }
                            }
                            ?>
                        </select>&nbsp;&nbsp;                     
                        <input class="button" type="button" name="vulner_btn_display" id="vulner_btn_display"value="<?php _e( 'Display', 'mainwp-vulnerability-checker-extension' ); ?>">
                    </form>  
                </div>    
		<?php
		return;
	}

} // End of class
