
jQuery( document ).ready(function($) {    
    $( '.mainwp_vulner_tabs_link a' ).on('click', function () {
        $('.mainwp_vulner_tabs_link a').removeClass('mainwp_action_down');
        $(this).addClass('mainwp_action_down');
        var tab = $(this).attr('tab-link');
        $('.vulner_ext_tabs').hide();
        $('.vulner_ext_tabs[tab-content="' + tab + '"]').show();
        return false;
    });
    
    $( '.vulner_action_recheck' ).on('click', function () {
        var obj = $(this).closest('tr');
        mainwp_vulner_results_recheck_start_specific( obj, false, false );
        return false;
    });
    
    $( '#vulner_btn_display' ).live('click', function () {
            $( this ).closest( 'form' ).submit();
    });
        
    $( '#vulner_recheck_all_sites' ).on('click', function () {
        var data = {
		action: 'mainwp_vulner_load_sites',		
                nonce: mainwp_vulner_loca.nonce,
                what: 'recheck'
	};       
        var workingEl = jQuery('#vulber_recheck_all_working');        
        var statusEl = workingEl.find( '.status' );
        workingEl.find( 'i' ).show();  
        statusEl.hide();
	jQuery.post(ajaxurl, data, function (response) {
		workingEl.find( 'i' ).hide();		
                if (response) {
                    if (response['error']) {
                        statusEl.css('color', 'red');                        
                        statusEl.html( '<i class="fa fa-exclamation-circle"></i>  ERROR: ' + response['error'] ).show();
                    } else if (response['result']) {
                            jQuery('#mainwp_vulner_result_table_wrap').html(response['result']);
                            vulner_bulkTotalThreads = jQuery('.siteItemProcess[status=queue]').length;
                            mainwp_vulner_recheck_all_sites_start_next();
                    } else {
                        statusEl.css('color', 'red');  
                        statusEl.html('<i class="fa fa-exclamation-circle"></i>  ERROR: ' + __( "Undefined error" ) ).show();
                    }
                } else {
                    statusEl.css('color', 'red');  
                    statusEl.html( '<i class="fa fa-exclamation-circle"></i>  ERROR: ' + __( "Undefined error" ) ).show();
                }

	}, 'json');
	return false;    
    });
    

    $( '#vulner_results_doaction_btn' ).on('click', function () {
            var bulk_act = $( '#vulner_results_action' ).val();            
            mainwp_vulner_results_do_bulk_action( bulk_act );
    });
    
    
    $( '#vulner_recheck_site' ).on('click', function () {
        var btme = this;
        var site_id = $(btme).attr('website-id');
	var data = {
		action: 'mainwp_vulner_result_recheck',
		websiteId: site_id,		
		force: 0,
                nonce: mainwp_vulner_loca.nonce
	}
       $(btme).attr('disabled', 'disabled');
        var workingEl = jQuery('#vulber_recheck_working');                
        var statusEl = workingEl.find( '.status' );
        workingEl.find( 'i' ).show(); 
        
       jQuery.post(ajaxurl, data, function (response) {
                $(btme).removeAttr('disabled');
		workingEl.find( 'i' ).hide();		
                if (response) {
                    if (response['error']) {
                        statusEl.css('color', 'red');                        
                        workingEl.find( '.status' ).html( '<i class="fa fa-exclamation-circle"></i> ERROR: ' + response['error'] ).show();
                    } else if (response['ok']) {                       
                        statusEl.css('color', '#21759B');  
                        statusEl.html( '<span style="color:#0073aa"><i class="fa fa-check-circle"></i> ' + __( "Successful" ) ).show();                        
                        window.location = "admin.php?page=ManageSitesVulnerChecker&id=" + site_id;
                    } else {
                        statusEl.css('color', 'red');  
                        statusEl.html( '<i class="fa fa-exclamation-circle"></i> ERROR: ' +  __( "Undefined error" ) ).show();
                    }
                } else {
                    statusEl.css('color', 'red');  
                    statusEl.html( '<i class="fa fa-exclamation-circle"></i> ERROR: ' + __( "Undefined error" ) ).show();
                }
	}, 'json');
	return false;        
    });
    
    $( 'a.vulner-detail-action-btn' ).on('click', function () {                
        mainwp_vulner_upgrade_delete_plugintheme($(this));        
        return false;
    });
});



var vulner_bulkMaxThreads = 3;
var vulner_bulkTotalThreads = 0;
var vulner_bulkCurrentThreads = 0;
var vulner_bulkFinishedThreads = 0;

mainwp_vulner_results_do_bulk_action = function (act) {	
        jQuery( '#the-vulner-results-list tr' ).addClass( 'queue' );        
	switch (act) {
            case 'recheck':
                mainwp_vulner_results_recheck_start_next( false);
                break;
            case 'force-recheck': 
                mainwp_vulner_results_recheck_start_next( true);
                break;            
	}
}

mainwp_vulner_results_recheck_start_next = function ( force) {   
    var selector = '#the-vulner-results-list tr';    
    while ((objProcess = jQuery( selector + '.queue:first' )) && (objProcess.length > 0) && (vulner_bulkCurrentThreads < vulner_bulkMaxThreads)) {        
        objProcess.removeClass( 'queue' );        
        if (objProcess.find( '.check-column input[type="checkbox"]:checked' ).length == 0)
            continue;
        mainwp_vulner_results_recheck_start_specific( objProcess, true, force );
    }
}

mainwp_vulner_results_recheck_start_specific = function (pObj, bulk, force) {	
	var workingRow = pObj.find( '.vulner-result-row-working' );
        var statusEl = workingRow.find( '.status' );        
	var data = {
		action: 'mainwp_vulner_result_recheck',
		websiteId: pObj.attr( 'website-id' ),		
		force: force ? 1 : 0,
                nonce: mainwp_vulner_loca.nonce
	}
        
	if (bulk) {
            vulner_bulkCurrentThreads++; 
        }
        
	workingRow.find( 'i' ).show(); 
        statusEl.css('color', '#21759B'); 
        statusEl.html('Running...').show();        
	jQuery.post(ajaxurl, data, function (response) {
		workingRow.find( 'i' ).hide();
		pObj.removeClass( 'queue' );
                if (response) {
                    if (response['error']) {
                        statusEl.css('color', 'red');                        
                        workingRow.find( '.status' ).html( '<i class="fa fa-exclamation-circle"></i> ERROR: ' + response['error'] ).show();
                    } else if (response['ok']) {                       
                        statusEl.css('color', '#21759B');  
                        statusEl.html( '<span style="color:#0073aa"><i class="fa fa-check-circle"></i> ' + __( "Successful" ) ).show();
                        pObj.find('span.wp_count').html(response['wp_count']);
                        pObj.find('span.plugin_count').html(response['plugin_count']);
                        pObj.find('span.theme_count').html(response['theme_count']);
                    } else {
                        statusEl.css('color', 'red');  
                        statusEl.html( '<i class="fa fa-exclamation-circle"></i> ERROR: ' +  __( "Undefined error" ) ).show();
                    }
                } else {
                    statusEl.css('color', 'red');  
                    statusEl.html( '<i class="fa fa-exclamation-circle"></i> ERROR: ' + __( "Undefined error" ) ).show();
                }

		if (bulk) {
                    vulner_bulkCurrentThreads--;
                    vulner_bulkFinishedThreads++;
                    mainwp_vulner_results_recheck_start_next( force );
		}

	}, 'json');
	return false;
}


mainwp_vulner_recheck_all_sites_start_next = function () {
    while ((objProcess = jQuery( '.siteItemProcess[status=queue]:first' )) && (objProcess.length > 0) && (vulner_bulkCurrentThreads < vulner_bulkMaxThreads)) {
        objProcess.attr( 'status', 'processed' );            
        mainwp_vulner_recheck_all_sites_start_specific(objProcess);             
    }
    if (vulner_bulkFinishedThreads > 0 && vulner_bulkFinishedThreads == vulner_bulkTotalThreads) {          
        jQuery( '#mainwp_vulner_result_table_wrap' ).append( '<div class="mainwp_info-box">' + __( "Checking completed successfully!" ) + '</div>' + '<p><a class="button-primary" href="admin.php?page=Extensions-Mainwp-Vulnerability-Checker-Extension">Back to overview</a></p>' );                   
    }  
}

mainwp_vulner_recheck_all_sites_start_specific = function (pObj) {	
    
        var loadingEl = objProcess.find( 'i' );
	var statusEl = objProcess.find( '.status' );        
	vulner_bulkCurrentThreads++;
        
	var data = {
		action: 'mainwp_vulner_result_recheck',
		websiteId: pObj.attr( 'website-id' ),				
                nonce: mainwp_vulner_loca.nonce
	};
            
	statusEl.hide();
	loadingEl.show();
	jQuery.post( ajaxurl, data, function ( response ) {
			loadingEl.hide();
                        if ( response) {                               
                                if (response.error) {
                                        statusEl.css( 'color', 'red' );
                                        statusEl.html( '<i class="fa fa-exclamation-circle"></i> ERROR: ' + response.error ).show();
                                } else if (response.ok) {                                                                                         
                                        statusEl.html( '<span style="color:#0073aa"><i class="fa fa-check-circle"></i> ' + __( 'Successful!' ) + '</span>' ).show();
                                } else {
                                        statusEl.css( 'color', 'red' );
                                        statusEl.html( '<i class="fa fa-exclamation-circle"></i>  ERROR: ' + 'Undefined error' ).show();
                                }
                        } else {
                                statusEl.css( 'color', 'red' );
                                statusEl.html( '<i class="fa fa-exclamation-circle"></i>  ERROR: ' + 'Undefined error' ).show();
                        }
			vulner_bulkCurrentThreads--;
			vulner_bulkFinishedThreads++;
			mainwp_vulner_recheck_all_sites_start_next();
	}, 'json' );        
	return false;
}


mainwp_vulner_upgrade_delete_plugintheme = function (pObj) {
        var action = pObj.attr('what');        
	var parent = pObj.closest( '.vulner-detail-actions' );	
	var type = parent.attr('action-type');
        var slug = parent.attr( 'slug' );
        
        if (action == 'delete') {
            if (!confirm(__('Are you sure?'))) {
                return false;
            }
        }
        
        var data = false;        
        if (action == 'update') {
            data = {	
                action: 'mainwp_vulner_upgrade_plugintheme',
                websiteId: parent.attr( 'website-id' ),
                type: type,
                'slugs[]': [slug],
                nonce: mainwp_vulner_loca.nonce
            }
	} else if (action == 'delete') {
            if (type == 'plugin') {
                data = {	
                    action: 'mainwp_vulner_delete_plugin',
                    websiteId: parent.attr( 'website-id' ),
                    plugins: [slug],               
                    nonce: mainwp_vulner_loca.nonce
                }            
            } else {
                var name = parent.attr( 'theme-name' ),
                data = {	
                    action: 'mainwp_vulner_delete_theme',
                    websiteId: parent.attr( 'website-id' ),
                    themes: [name],               
                    nonce: mainwp_vulner_loca.nonce
                }
            }
        }
        
        parent.find('.vulner-detail-action-btn').each(function(){
            jQuery(this).attr('disabled', 'disabled');                  
        });
        
	parent.find( 'i' ).show();
        parent.find('span.status').html('');
	jQuery.post(ajaxurl, data, function (response) {
		parent.find( 'i' ).hide();
                if (response) {
                    if (response['error']) {
                        if (response['error'] == 'IsActivatedTheme') {
                            parent.find('span.status').html( '<font color="red">Can not delete the activated theme.</font>' );
                        } else {
                            parent.find('span.status').html( '<font color="red">' + response['error'] + '</font>' );
                        }
                    } else if ((action == 'delete' && response['result']) || (action == 'update' && response['upgrades'][slug])) {
                        parent.find('span.status').html( '<i class="fa fa-check-circle"></i> ' + __( 'Successful.' ) );  
                        scrollToElement();
                        jQuery( '#vulner_recheck_site' ).trigger("click");
                    } else {
                        parent.find('span.status').html( '<font color="red">' + __( "Undefined error" ) + '</font>' );
                    }
                } else {
                    parent.find('span.status').html( '<font color="red">' + __( "Undefined error" ) + '</font>' );
                }
	}, 'json');
	return false;
}



// jQuery( document ).ready(function ($) {
//	mainwp_vulner_check_showhide_sections();
//	$( '.mainwp_vulner_postbox .handlediv' ).live('click', function () {
//            var pr = $( this ).parent();
//            if (pr.hasClass( 'closed' )) {
//                mainwp_vulner_set_showhide_section( pr, true ); 
//            } else { 			
//                mainwp_vulner_set_showhide_section( pr, false ); 
//            }
//	});
//});
//
// mainwp_vulner_set_showhide_section = function (obj, show) {
//    var sec = obj.attr( 'section' );
//    if (show) {
//        obj.removeClass( 'closed' );
//        mainwp_setCookie( 'mainwp_vulner_showhide_section_' + sec, 'show' );
//    } else {
//        obj.addClass( 'closed' );
//        mainwp_setCookie( 'mainwp_vulner_showhide_section_' + sec, '' );
//    }
//}
//
//mainwp_vulner_check_showhide_sections = function () {
//    var pr, sec;
//    jQuery( '.mainwp_vulner_postbox .handlediv' ).each(function () {
//        pr = jQuery( this ).parent();
//        sec = pr.attr( 'section' );
//        if (mainwp_getCookie( 'mainwp_vulner_showhide_section_' + sec ) == 'show') {
//                mainwp_vulner_set_showhide_section( pr, true );
//        } else {
//                mainwp_vulner_set_showhide_section( pr, false );
//        }
//    });
//};

//mainwp_vulner_save_settings_to_sites = function() {
//    var data = {
//        action: 'mainwp_vulner_load_sites',		
//        nonce: mainwp_vulner_loca.nonce,
//        what: 'save_settings'
//    };       
//    var result_wrap = jQuery('#mainwp_vulner_settings_wrap');            
//    jQuery.post(ajaxurl, data, function (response) {            		
//            if (response) {
//                if (response['error']) {
//                    result_wrap.css('color', 'red');                        
//                    result_wrap.html( '<i class="fa fa-exclamation-circle"></i>  ERROR: ' + response['error'] ).show();
//                } else if (response['result']) {
//                        result_wrap.html(response['result']);
//                        vulner_bulkTotalThreads = jQuery('.siteItemProcess[status=queue]').length;
//                        mainwp_vulner_save_settings_to_sites_start_next();
//                } else {
//                    result_wrap.css('color', 'red');  
//                    result_wrap.html('<i class="fa fa-exclamation-circle"></i>  ERROR: ' + __( "Undefined error" ) ).show();
//                }
//            } else {
//                result_wrap.css('color', 'red');  
//                result_wrap.html( '<i class="fa fa-exclamation-circle"></i>  ERROR: ' + __( "Undefined error" ) ).show();
//            }
//
//    }, 'json');
//    return false;  
//}
//
//
//
//mainwp_vulner_save_settings_to_sites_start_next = function () {
//    while ((objProcess = jQuery( '.siteItemProcess[status=queue]:first' )) && (objProcess.length > 0) && (vulner_bulkCurrentThreads < vulner_bulkMaxThreads)) {
//        objProcess.attr( 'status', 'processed' );            
//        mainwp_vulner_save_settings_to_sites_start_specific(objProcess);             
//    }
//    if (vulner_bulkFinishedThreads > 0 && vulner_bulkFinishedThreads == vulner_bulkTotalThreads) {          
//        jQuery( '#mainwp_vulner_settings_wrap' ).append( '<div class="mainwp_info-box">' + __( "Finished." ) + '</div>' + '<p><a class="button-primary" href="admin.php?page=Extensions-Mainwp-Vulnerability-Checker-Extension&tab=settings">Back to Settings</a></p>' );                   
//    }  
//}
//
//mainwp_vulner_save_settings_to_sites_start_specific = function (pObj) {	
//    
//        var loadingEl = objProcess.find( 'i' );
//	var statusEl = objProcess.find( '.status' );        
//	vulner_bulkCurrentThreads++;
//        
//	var data = {
//		action: 'mainwp_vulner_to_save_settings',
//		websiteId: pObj.attr( 'website-id' ),				
//                nonce: mainwp_vulner_loca.nonce
//	};
//            
//	statusEl.hide();
//	loadingEl.show();
//	jQuery.post( ajaxurl, data, function ( response ) {
//			loadingEl.hide();
//                        if ( response) {                               
//                                if (response.error) {
//                                        statusEl.css( 'color', 'red' );
//                                        statusEl.html( '<i class="fa fa-exclamation-circle"></i> ERROR: ' + response.error ).show();
//                                } else if (response.ok) {                                                                                         
//                                        statusEl.html( '<span style="color:#0073aa"><i class="fa fa-check-circle"></i> ' + __( 'Successful.' ) + '</span>' ).show();
//                                } else {
//                                        statusEl.css( 'color', 'red' );
//                                        statusEl.html( '<i class="fa fa-exclamation-circle"></i>  ERROR: ' + 'Undefined error' ).show();
//                                }
//                        } else {
//                                statusEl.css( 'color', 'red' );
//                                statusEl.html( '<i class="fa fa-exclamation-circle"></i>  ERROR: ' + 'Undefined error' ).show();
//                        }
//			vulner_bulkCurrentThreads--;
//			vulner_bulkFinishedThreads++;
//			mainwp_vulner_save_settings_to_sites_start_next();
//	}, 'json' );        
//	return false;
//}


